

app.factory('Common',  ['$mdToast', '$mdDialog', 'toastr', 'toastrConfig', '$templateCache',
	function ($mdToast, $mdDialog, toastr, toastrConfig, $templateCache) {		
        var obj = {};
        obj.time = jui.include("util.time");
        
        obj.toast = function (message) {
        	$mdToast.show(
		      $mdToast.simple()
		        .textContent(message)
		        .position('bottom right')
		        .hideDelay(500)
		    );        	
        };
        
        // 전체 삭제
        obj.toastrClearAll = function() {
        	toastr.clear();
        }
        
        //$templateCache.put('directives/toast/toast.html', "<div class=\"{{toastClass}} {{toastType}}\" ng-click=\"tapToast()\">\n  <div ng-switch on=\"allowHtml\">\n    <div ng-switch-default ng-if=\"title\" class=\"{{titleClass}}\" aria-label=\"{{title}}\">{{title}}</div>\n    <div ng-switch-default class=\"{{messageClass}}\" aria-label=\"{{message}}\">{{message}}</div>\n    <div ng-switch-when=\"true\" ng-if=\"title\" class=\"{{titleClass}}\" ng-bind-html=\"title\"></div>\n    <div ng-switch-when=\"true\" class=\"{{messageClass}}\" ng-bind-html=\"message\"></div>\n  </div>\n  <progress-bar ng-if=\"progressBar\"></progress-bar>\n</div>\n");
        // 템플릿 변경 (위 주석이 기존 템플릿) = angular-toastr.tpls.js 마지막 라인에서도 확인가능
        $templateCache.put('directives/toast/toast.html', "<div class=\"{{toastClass}} {{toastType}}\" ng-click=\"tapToast()\">\n  <div ng-switch on=\"allowHtml\">\n    <div ng-switch-default ng-if=\"title\" class=\"{{titleClass}}\" aria-label=\"{{title}}\">{{title}}</div>\n    <div ng-switch-default class=\"{{messageClass}}\" aria-label=\"{{message}}\">{{message}}</div>\n    <div ng-switch-when=\"true\" ng-if=\"title\" class=\"{{titleClass}}\" ng-bind-html=\"title\"></div>\n    <div ng-switch-when=\"true\" class=\"{{messageClass}}\" ng-bind-html=\"message\"></div>\n  </div>\n  <progress-bar ng-if=\"progressBar\"></progress-bar>\n <button type=\"button\" class=\"btn waves-effect waves-light btn-inner kr app-color active-red\" ng-if=\"eventData.eventDiv=='Y'\" ng-click=\"eventDtl(eventData); $event.stopPropagation();\" style=\"width: 70px;position: absolute;right: 5px;top: 7px;\">상세보기</button>\n</div>\n");
        //$templateCache.put('directives/toast/toast.html', "<div class=\"{{toastClass}} {{toastType}}\" ng-click=\"tapToast()\">\n  <div ng-switch on=\"allowHtml\">\n    <div ng-switch-default ng-if=\"title\" class=\"{{titleClass}}\" aria-label=\"{{title}}\">{{title}}</div>\n    <div ng-switch-default class=\"{{messageClass}}\" aria-label=\"{{message}}\">{{message}}</div>\n    <div ng-switch-when=\"true\" ng-if=\"title\" class=\"{{titleClass}}\" ng-bind-html=\"title\"></div>\n    <div ng-switch-when=\"true\" class=\"{{messageClass}}\" ng-bind-html=\"message\"></div>\n  </div>\n  <progress-bar ng-if=\"progressBar\"></progress-bar>\n </div>\n");
        
        // Common.toastr(message(=메시지), status(=상태 : error, warning ...), noTimeout(일정 시간 후 자동삭제 기능 제거 = Y) , eventId(=이벤트 id)
        obj.toastr = function (message, status, noTimeout, eventData, clickCallback) {

        	var timeoutFlag = (noTimeout != "Y") ? 5000 : 0;
        	var toastrConfig = {
        			newestOnTop: false,
            		timeOut: timeoutFlag, // Toast 자동 삭제 (0 = false, 0보다 큰 수는 true + 시간) 
            		tapToDismiss: true, // Toast 클릭 시  삭제 (true/false)    
            		eventDtlCallback:clickCallback,
            		extraData: {
            			// 사용자 정의 데이터/함수
            			func: function(toastScope) {            				
            				//console.log(toastScope);
            				clickCallback(toastScope.extraData.eventId);
            				
            			},
            			eventData : eventData
            		},
            		eventData : eventData
            }
        	
        	switch (status) {
        		case "success":
        			toastr.success(message, "Success"); 
        			break;
        		case "info":
        			toastr.info(message, "Info");
        			break;
        		case "error":
        			toastr.error(message, "Error", toastrConfig);
        			break;
        		case "warning":
        			toastr.warning(message, "Warning", toastrConfig);
        			break;
        		default :
        			toastr.info(message);
        			break;
        	};        	        	  
        };
                
        
        obj.alertDialog = function (title, message) {
        	$mdDialog.show(
				$mdDialog.alert()
					.clickOutsideToClose(true)
					.ariaLabel("Dialog")
					.title(title)        				
			        .htmlContent(message)
			        .ok('닫기') 
			        .targetEvent(event)
			    );        	
        };
        
        obj.alertHtmlDialog = function (title, message) {
        	$mdDialog.show(
				$mdDialog.alert()
					.clickOutsideToClose(true)
					.ariaLabel("Dialog")
					.title(title)        				
			        .htmlContent(message)
			        .ok('닫기') 
			        .targetEvent(event)
			    );        	
        };
        
        obj.alertOkEventDialog = function (title, message, okCallback) {
        	$mdDialog.show(
				$mdDialog.alert()
					.clickOutsideToClose(true)
					.ariaLabel("Dialog")
					.title(title)        				
			        .htmlContent(message)
			        .ok('닫기') 
			        .targetEvent(event)
	        	).then(function() {
			    	okCallback();
	            });       	
        };
        
        obj.confirmDialog = function (title, message, okCallback, cancelCallback) {
        	//Common.confirmDialog("Title", "Message", function(){alert("ok Func")}, function(){"cancel Func"});
        	$mdDialog.show(
				$mdDialog.confirm()
					.clickOutsideToClose(true)
					.ariaLabel("Dialog")
					.title(title)        				
			        .textContent(message)
			        .ok('확인') 
			        .cancel('취소')
			        .targetEvent(event)    			        
			    ).then(function() {
			    	okCallback();
	            }, function() {
	            	cancelCallback();	            	
	            });  
        };
        
        obj.formatDate = function(q) {
        	return "";
        }
        
        obj.formatTime = function(q) {
        	return "";
        }
        
        obj.formatNumber = function(q) {	// comma처리, input : numberValue , output:stringValue 
	       	if(typeof(q) == "number"){
	       		var retValue="";
	       		var str=q.toString();
	       		for(var i=1; i<=str.length; i++){
		       		if(i>1 && (i%3)==1){ 
		       			 retValue=str.charAt(str.length - i) + "," + retValue;
		       		}else{
		       			 retValue=str.charAt(str.length - i ) + retValue;
		       		}
	       		}
	       		return retValue;
	       	} else {
	       		return q;	//number가 아니면 input q를 return
	       	}
        };
        
        obj.nvl = function (s){
        	return (s==null || s=='null') ? '' : s;
        }
     
        obj.getElementWidth = function(element) {
        	return element[0].clientWidth;
        };
        
        obj.getElementHeight = function(element) {
        	return element[0].clientHeight;
        };
        
        obj.getRandomValue = function(min, max) {
        	return Math.random() * (max - min) + min;
        };
        
        obj.pastTimeInterval = function(min, gap) {
        	if (gap == undefined){
        		gap = 0;
        	}
        	var clientTime = new Date().getTime();
        	var prevTime = clientTime -  (obj.time.MINUTE * min) + gap;
        	var curTime = clientTime + gap;        	
        	return [new Date(prevTime), new Date(curTime)];
        };
        
        obj.getThisTime = function () {
        	var date = new Date();
        	
        	var eHH = date.getHours();
        	var emm = date.getUTCMinutes();
        	
        	if(emm < 0){
        		eHH = eHH - 1;
        		emm = emm + 60;
        	}
        	if(eHH < 0){
        		eHH = 0;
        		emm = 0;
        	}
        	eHH = eHH >= 10 ? eHH : '0' + eHH;
        	emm = emm >= 10 ? emm : '0' + emm;
    		
        	return eHH + ":" + emm;
        };	
        
        obj.getToday = function() {
        	var date = new Date();
        	var year = date.getFullYear();
        	var month = (1+date.getMonth());
        	month = month>=10? month:'0'+month;
        	var day = date.getDate();
        	day = day>=10? day:'0'+day;
        	return year + '/' + month + '/' + day;
        };

        obj.getYesterday = function() {
        	var date = new Date();
        	date.setDate(date.getDate()-1);	
        	var year = date.getFullYear();
        	var month = (1+date.getMonth());
        	month = month>=10? month:'0'+month;
        	var day = date.getDate();
        	day = day>=10? day:'0'+day;
        	return year + '/' + month + '/' + day;
        };

        obj.getTomorrow = function() {
        	var date = new Date();
        	date.setDate(date.getDate()+1);	
        	var year = date.getFullYear();
        	var month = (1+date.getMonth());
        	month = month>=10? month:'0'+month;
        	var day = date.getDate();
        	day = day>=10? day:'0'+day;
        	return year + '/' + month + '/' + day;
        };
        
        obj.getPerFiveMinute = function() {
        	var date = new Date();
        	
        	var sHH = date.getHours();
        	var smm = date.getUTCMinutes()-5;
        	if(smm < 0){
        		sHH = sHH - 1;
        		smm = smm + 60;
        	}
        	if(sHH < 0){
        		sHH = 0;
        		smm = 0;
        	}
        	sHH = sHH >= 10 ? sHH : '0' + sHH;
        	smm = smm >= 10 ? smm : '0' + smm;
        	
        	return sHH + ":" + smm;
        };
        
        obj.getPerHours = function(parmHours) {
        	var date = new Date();
        	
        	var sHH = date.getHours() - parmHours;
        	var smm = date.getUTCMinutes();
        	if(smm < 0){
        		sHH = sHH - 1;
        		smm = smm + 60;
        	}
        	if(sHH < 0){
        		sHH = 0;
        		smm = 0;
        	}
        	sHH = sHH >= 10 ? sHH : '0' + sHH;
        	smm = smm >= 10 ? smm : '0' + smm;
        	
        	return sHH + ":" + smm;
        };
        obj.getPageObj = function(list, xtableList, PAGE_BUFFER_COUNT, PAGING_BUFFER_COUNT){
        	var pageObj = {
       			currentPage : 1,
        		pagingCurrentPage : 0,
        		totalCount : list.length,
        		totalPage : 0,
        		pagingTotalPage : 0,
        		pageNums : [],
        		pagingPageNums : [],
        		prevPagingPage : function() {
        			if (pageObj.pagingCurrentPage == 1) {
        				return;
        			}
        			pageObj.gotoPagingPage(pageObj.pagingCurrentPage-1, "prev");
        		},
        		nextPagingPage : function() {
        			if (pageObj.pagingCurrentPage == pageObj.pagingTotalPage) {
        				return;
        			}
        			pageObj.gotoPagingPage(pageObj.pagingCurrentPage+1, "next");
        		},
        		gotoPage : function(no) {
        			if (pageObj.currentPage == no) {
        				return;
        			}
        			pageObj.currentPage = no;	
        			xtableList.page(pageObj.currentPage);
        		},
        		gotoPagingPage : function(no, type) {
        			if (pageObj.pagingCurrentPage == no){ return };
        			pageObj.pagingCurrentPage = no;
        			pageObj.pagingPageNums = [];
        			for (var i=0; i<PAGING_BUFFER_COUNT; i++) {
        				if (pageObj.pageNums[i + ((pageObj.pagingCurrentPage-1) * PAGING_BUFFER_COUNT)] != undefined) {
        					pageObj.pagingPageNums.push(pageObj.pageNums[i + ((pageObj.pagingCurrentPage-1) * PAGING_BUFFER_COUNT)]);	
        				}			
        			}						
        			if (type == "prev") {
        				pageObj.gotoPage(pageObj.pagingPageNums[pageObj.pagingPageNums.length-1]);
        			} else if (type == "next") {
        				pageObj.gotoPage(pageObj.pagingPageNums[0]);
        			} else {
        				pageObj.gotoPage(pageObj.pagingPageNums[0]);
        			}
        		}
        	};
        	
        	pageObj.totalPage = Math.ceil(pageObj.totalCount / PAGE_BUFFER_COUNT);
        	
        	for (var i=0; i<pageObj.totalPage; i++) {
        		pageObj.pageNums.push(i+1);
			}
        	pageObj.currentPage = 1;
			
			var pagingTotalCount = pageObj.totalPage;
			pageObj.pagingTotalPage = Math.ceil(pagingTotalCount / PAGING_BUFFER_COUNT);
			
			for (var i=0; i<PAGING_BUFFER_COUNT; i++) {
				if (pageObj.pageNums[i + (pageObj.pagingCurrentPage * PAGING_BUFFER_COUNT)] != undefined) {
					pageObj.pagingPageNums.push(pageObj.pageNums[i + (pageObj.pagingCurrentPage * PAGING_BUFFER_COUNT)]);
				}				
			}
			
			pageObj.pagingCurrentPage = 1;
			xtableList.hideLoading();
			xtableList.update(list);
			xtableList.resize();
        	return pageObj;
        }
        
        obj.strEllip = function(str, num){
        	var text = str;
        	if(num < text.length){
        		return text.substring(0,num)+'...';
        	}else{
        		return text;
        	}
        }
        return obj;
	}]);
