function CounterTodayVisitor(id, $scope, $rootScope, $interval, Data, TickTime) {
	function Component(type, id){
		ComponentBase.apply(this, arguments);
	};	
	inherit(Component, ComponentBase);
	function inherit(C, P) {
		var F = function(){};
		F.prototype = P.prototype;
		C.prototype = new F();
	};
	
	var comp = new Component('chart', id);
	comp.data = [];
	var chart = new Object();
	
	var configWatch = $scope.$watch('config.visible', function(bool){
		if (!comp.active){
			return;
		}
		if (bool) { comp.show(); } 
		else { comp.hide(); }
	}, true);
	
	createWidget();
	function createWidget() {
		jui.ready(["chart.builder"], function (juiChart) {
			var style = {
	            colors: ["#6b0082", "#9a00b8"],    
	            backgroundColor: "#00000000",
		        axisBorderColor: "#00000000",
		        axisBorderWidth: 1,
		        axisBorderRadius: 5,
		        gridXFontSize: 10,
		        gridXFontColor: "#c2c6c9",
		        gridYFontSize: 10,
		        gridYFontColor: "#c2c6c9",	    
		        gridXAxisBorderWidth: 1,
		        gridXAxisBorderColor: "#c2c6c9",
		        gridYAxisBorderWidth: 1,
		        gridYAxisBorderColor: "#c2c6c9",
		        gridBorderColor:"#00000000",
		        tooltipFontColor:"#fff",
		        tooltipBackgroundColor:"#1b1b1b",
		        lineBorderWidth: 1
			};	
			
			chart = juiChart("#"+id+" > .box-content > .component", {
				padding: { left: 40, top: 20, right: 20, bottom: 30 },
				axis: {
				    x: {
				        /*type: "range",
				        domain : [ 0, 23],
				        step: 24*/
				    	type: "dateblock",
				    	domain: [new Date(comp.getToday()), new Date(comp.getTomorrow())],
				    	interval: comp.time.HOUR,
				    	format: function (d, i) {
				    		return i;
				    	}
				    },
				    y: {
				        type: "range",
				        domain : yDomain,	       
				        step: 4,
				        line: true
				    },
				    data: comp.data
				},
				brush: [
					{
		                type: "area",
                        target: ["someday"],
                        line : false,
                        colors: function (d) {
							//20180403 색상수정  return "#6b0082";
    			            return "#6b0082"; // 보라색(#6b0082), 청록색 계열(#06C6A6)
    			        }
	            	},
	            	{
		                type: "line",
                        target: ["today"],
                        animate : true,
                        display : 'max',
                        colors: function (d) {                        	
    			            return "#cddc39"; //#06C6A6
    			        }
	            	}	            	
				],
				widget: [
	            	{
	            		type: "cross",
	            		xFormat: function(d) {
	            			return comp.time.format(d, "HH:mm");
	            		},
	            		yFormat: function(d) {
	            			return Math.round(d);
	            		}           		
	            	}
	            ],
				style: style,
				render: false
	        }); 
			comp.setComponent(chart);
	    	comp.init();   
	    	//if (TickTime > 0) { startTick(); }
		});
	}
	
	comp.api.remove = function() {
		configWatch();
		comp.remove();
		comp = null;			
	};
	var yDomain =[0,100];
	comp.api.update = function(data) {
		if (data.loadTimeValue.value == undefined || data.loadTimeValue.value == null || data.loadTimeValue.value.length == 0) {
			return;
		};
		
		if (data.realTimeValue.value == undefined || data.realTimeValue.value == null || data.realTimeValue.value.length == 0) {
			return;
		};
		
		comp.data = [];
		for (var i = 0; i < 24; i++) {
			comp.data.push({
				//today: data.realTimeValue.value[i],
				someday: data.loadTimeValue.value[i],
			});
		};
		
		//data.realTimeValue.value = [100, 100, 100, 100, 100];
		for (var j = 0; j < data.realTimeValue.value.length; j++) {
			comp.data[j].today = data.realTimeValue.value[j];
		};
		
		var todayMax = comp.getCounterDomain(data.realTimeValue.value)[1];
		var somedayMax = comp.getCounterDomain(data.loadTimeValue.value)[1];
		var max = Math.max.apply(null, [todayMax, somedayMax]);
		yDomain = [0, Math.round(max)];
		
		if (comp.component == null || comp.component == undefined) {
			createWidget();
			return;
		};
		
		comp.component.axis(0).set("y", {domain: yDomain});

		if (!comp.active){
			return;		
		}
		comp.update();
        
	};
	
	comp.api.resize = function() {
		if (!comp.active){
			return;
		}
		comp.resize();		
	};
	
	comp.api.reset = function(){
		if (comp.component == null || comp.component == undefined) {
			return;
		}
		if (!comp.active){
			return;		
		}
		/*if (comp.component.uit == undefined || comp.component.uit == null) {
			return;
		}*/
		comp.data=[];
		comp.update();
	};
	return comp.api;
};
