function RealTimeActiveService(id, $scope, $rootScope, $interval, Data, TickTime) {
	function Component(type, id){
		ComponentBase.apply(this, arguments);
	};	
	inherit(Component, ComponentBase);
	function inherit(C, P) {
		var F = function(){};
		F.prototype = P.prototype;
		C.prototype = new F();
	};
	
	var comp = new Component('chart', id);
	comp.data = [];
	//var ymaxArr= [];
	var chart = new Object();
	
	var configWatch = $scope.$watch('config.visible', function(bool){
		if (!comp.active){
			return;
		}
		if (bool) { comp.show(); } 
		else { comp.hide(); }
	}, true);
	
	createWidget();
	function createWidget() {
		jui.ready(["chart.builder"], function (juiChart) {
			var style = {
					colors: [
	                	"#38c3ff", "#00ceae", "#ff474c", "#ffb500", "#e8e8e8", 
	                	"#1bbe64", "#98dc08", "#cf0073", "#cf0073", "#576f83",
	                	"#38c3ff", "#00ceae", "#ff474c", "#ffb500", "#e8e8e8", 
	                	"#1bbe64", "#98dc08", "#cf0073", "#cf0073", "#576f83",
	                	"#38c3ff", "#00ceae", "#ff474c", "#ffb500", "#e8e8e8", 
	                	"#1bbe64", "#98dc08", "#cf0073", "#cf0073", "#576f83",
	                	"#38c3ff", "#00ceae", "#ff474c", "#ffb500", "#e8e8e8", 
	                	"#1bbe64", "#98dc08", "#cf0073", "#cf0073", "#576f83",
	                	"#38c3ff", "#00ceae", "#ff474c", "#ffb500", "#e8e8e8", 
	                	"#1bbe64", "#98dc08", "#cf0073", "#cf0073", "#576f83"	                	
	                	],     	                
		            backgroundColor: "#00000000",
			        axisBorderColor: "#00000000",
			        axisBorderWidth: 1,
			        axisBorderRadius: 5,
			        gridXFontSize: 10,
			        gridXFontColor: "#c2c6c9",
			        gridYFontSize: 10,
			        gridYFontColor: "#c2c6c9",	    
			        gridXAxisBorderWidth: 1,
			        gridXAxisBorderColor: "#c2c6c9",
			        gridYAxisBorderWidth: 1,
			        gridYAxisBorderColor: "#c2c6c9",
			        gridBorderColor:"#00000000",
			        tooltipFontColor:"#fff",
			        tooltipBackgroundColor:"#1b1b1b",
			        lineBorderWidth: 1
			};	
			
			chart = juiChart(("#"+id+" > .box-content > .component" ), {
				padding: { left: 40, top: 20, right: 20, bottom: 30 },
					axis: [{
		                x: {
		                    type : "dateblock",
		                    domain : comp.pastTimeInterval(5, $rootScope.timeGap),
		                    interval : 1,
		                    realtime: "minutes",
		                    format: "HH:mm",
		                    line: 'solid'
		                },
		                y: {
		                    type : "range",
		                    domain : [ 0, 100 ],
		                    step : 5,
		                    line: 'solid'
		                }	                
		            }],			 
		            brush: [
		            	{
		                    type: "line",
		                    target: []
		            	}
		            ],	
		            widget: [
		            	/*{
		            		type: "cross",
		            		xFormat: function(d) {
		            			return comp.time.format(d, "HH:mm:ss");
		            		},
		            		yFormat: function(d) {
		            			return Math.round(d);
		            		}
		            	},*/
		            	{
		            		type : "tooltip",
		            		format : function(k,v){
		            			var key = v;
		            			return key;
		            		}
		            	}
		            ],
	            style: style,
	            render: false
	        }); 		
			comp.setComponent(chart);
	    	comp.init();   
		});
	}
	
	comp.api.remove = function() {
		configWatch();
		comp.remove();
		comp = null;			
	};
	
	comp.api.update = function(valuesArr) {
		var objV=valuesArr[0];
		var data=objV.data;
		
		if (data == undefined || data == null || data.length == 0){
			return;
		}
		
		if (comp.data.length == 0) {
			var dummyObj = {};
			for (prop in target) {
				dummyObj[prop] = 0;
			}
			for (var i = 0; i < 300; i++) {
				comp.data.push(dummyObj)
			}
		}		
		
		for (var i = 0; i < data.length; i++) {
			comp.data.push(data[i]);
		}
		
		while(comp.data.length > 300) {
        	comp.data.shift();        	
        }
				
		if (comp.component == null || comp.component == undefined) {
			createWidget();
			return;
		}
		if (!comp.active){
			return;		
		}
		
		/*ymaxArr.push(objV.ymax);
		while(ymaxArr.length > 300) {
			ymaxArr.shift();        	
        }*/
		var ymax1=0;
		/*for (var i = 0; i < ymaxArr.length; i++) {
			ymax1=Math.max(ymaxArr[i], ymax1);
		}*/
		for (var i = 0; i < comp.data.length; i++) {
			var temp = comp.data[i];
			
			for (var key in temp){
				ymax1=Math.max(temp[key], ymax1);
			}
		}
		var ymax2=Math.floor(ymax1/5)*5+5;
		
		var xDomain = comp.pastTimeInterval(5, $rootScope.timeGap);
		var target = objV.objNms;
		comp.component.axis(0).set("x", {domain: xDomain});
		comp.component.axis(0).set("y", {domain: [0, ymax2]});

		comp.component.updateBrush(0, {target: target});			
		comp.component.updateBrush(1, {target: target});
		comp.update();
	};
	
	comp.api.resize = function() {		
		if (!comp.active){
			return;
		}
		comp.resize();		
	};
	
	comp.api.reset = function(){
		if (comp.component == null || comp.component == undefined) {
			return;
		}
		if (!comp.active){
			return;		
		}
		/*if (comp.component.uit == undefined || comp.component.uit == null) {
			return;
		}*/
		comp.data=[];
		comp.update();
	}
	
	return comp.api;
};
