function RealTimeActiveServiceEQ(id, $scope, $rootScope, $interval, Data, TickTime) {
	function Component(type, id){
		ComponentBase.apply(this, arguments);
	};	
	inherit(Component, ComponentBase);
	function inherit(C, P) {
		var F = function(){};
		F.prototype = P.prototype;
		C.prototype = new F();
	};
	
	var comp = new Component('chart', id);
	comp.data = [
		{ act1: 0, act2:0, act3:0, value:0}		
	];
	var chart = new Object();
	
	var configWatch = $scope.$watch('config.visible', function(bool){
		if (!comp.active){
			return;
		}
		if (bool) { comp.show(); } 
		else { comp.hide(); }
	}, true);
	
	createWidget();
	function createWidget() {
		jui.ready(["chart.builder"], function (juiChart) {
			var style = {
				//colors: ["#38c3ff",  "#ffb500", "#00ceae", "#ff474c"],	                
				colors: ["#38c3ff",  "#ffb500", "#ff474c"],
		        backgroundColor: "#00000000",
		        axisBorderColor: "#00000000",
		        axisBorderWidth: 1,
		        axisBorderRadius: 5,
		        gridXFontSize: 10,
		        gridXFontColor: "#c2c6c9",
		        gridYFontSize: 10,
		        gridYFontColor: "#c2c6c9",	    
		        gridXAxisBorderWidth: 1,
		        gridXAxisBorderColor: "#c2c6c9",
		        gridYAxisBorderWidth: 1,
		        gridYAxisBorderColor: "#c2c6c9",
		        gridBorderColor:"#00000000",
		        tooltipFontColor:"#fff",
		        tooltipBackgroundColor:"#1b1b1b",
		        lineBorderWidth: 1
			};	
			
			chart = juiChart("#"+id+" > .box-content > .component", {
				padding: { left: 40, top: 20, right: 20, bottom: 30 },
	            axis: [
	            	{
		                x: {
		                    type: "block",
		                    domain: [],                	                   
		                },
		                y: {
		                    type: "range",
		                    /*domain : function(d) {
		                        return Math.max(d.value) * 1.5;
		                    },*/
		                    domain:[],
		                    step: 4,
		                    line: true
		                },
		                data: comp.data             
	            	}
	            ],
	            brush: [
	            	{
		                type: "equalizercolumn",
						target: ["act1", "act2", "act3"],
		                display : "all",
	                    animate: true,
		                unit: 5		                
	            	},
	            	{
		                type: "equalizercolumn",
						target: ["act4"],
		                display : "all",
		                unit: 5,
		                colors: function (d) {
    			            return "#757474";
    			        }
	            	}
	            ],
	            widget: [
	            	{ 
	            		type : "tooltip",
	            		format : function(k,v){
	            			var key = '';
	            			var value = '';
	            			if('act1' == v){
	            				key = 'Normal';
	            			}else if('act2' == v){
	            				key = 'Warning';
	            			}else if('act3' == v){
	            				key = 'Cirtical';
	            			}
            				value = k[v];
	            			return key +" : "+ value;
	            		},
	            		animate: true,
	            		all: true
	            	}
	            ],
			    event : {
			        "click": function(obj) {
			        	$scope.openActiveThreadListDialog(obj.data.nodeId);
			        }
			    },	            
	            style: style,
	            render: false
	        }); 
			comp.setComponent(chart);
	    	comp.init();   
		});
	}
	
	comp.api.remove = function() {
		configWatch();
		comp.remove();
		comp = null;			
	};
	
	comp.api.update = function(data) {
		if (data == undefined || data == null || data.length == 0){
			return;
		}
		if (comp.component == null || comp.component == undefined) {
			createWidget();
			return;
		}
		if (!comp.active){
			return;
		}
		var dataSource = [];
		for (var i=0; i<data.length; i++) {
			if(data[i].nodeAlive == false){
				data[i].value.act4 = 10;
			}else{
				data[i].value.act4 = 0;
			}
			data[i].value.nodeAlive = data[i].nodeAlive;
			data[i].value.value = data[i].value.act1 + data[i].value.act2 + data[i].value.act3;
			dataSource.push(data[i].value);
		}		
		var yDomain = comp.getEQDomain(dataSource);
		var target = comp.getEQTarget(data);
		comp.component.axis(0).set("x", {domain: target});
		comp.component.axis(0).set("y", {domain: yDomain});
		comp.data = dataSource;
		comp.update();
		
	};
	
	comp.api.resize = function() {
		if (!comp.active){
			return;
		}
		comp.resize();		
	};
	
	comp.api.reset = function() {
		if (comp.component == null || comp.component == undefined) {
			return;
		}
		if (!comp.active){
			return;		
		}
		/*if (comp.component.uit == undefined || comp.component.uit == null) {
			return;
		}*/
		var dataSource = [];
		var data = []; 
		var yDomain = comp.getEQDomain(dataSource);
		var target = comp.getEQTarget(data);
		comp.component.axis(0).set("x", {domain: target});
		comp.component.axis(0).set("y", {domain: yDomain});
		comp.data = dataSource;
		comp.update();
	}

	return comp.api;
};
