function RealTimeActiveThreadList(id, $scope, $rootScope, $interval, Data, TickTime) {
	function Component(type, id){
		ComponentBase.apply(this, arguments);
	};	
	inherit(Component, ComponentBase);
	function inherit(C, P) {
		var F = function(){};
		F.prototype = P.prototype;
		C.prototype = new F();
	};
	
	var comp = new Component('table', id);
	comp.data = [];
	var table = new Object();
	
	var configWatch = $scope.$watch('config.visible', function(bool){
		if (!comp.active){
			return;
		}
		if (bool) { comp.show(); } 
		else { comp.hide(); }
	}, true);
	
	createWidget();
	function createWidget() {
		jui.ready([ "grid.table" ], function(juiTable) {
			table = juiTable("#"+id+" > .box-content > .component > .componentTable > table", {
				data:comp.data,
				event: {
					select: function(row, e) {
						if ($(row.element).hasClass("selected")) {
							//this.unselect(row.index);
						} else {
							this.select(row.index); 	
							row.data.type = "1"; //xLog와 구분하기 위한 타입
							$scope.openActiveThreadDialog([row]);           			
						};
					}
				},
				tpl: {
					row: angular.element("#tpl_row").html()
				}	
			});
	    	comp.setComponent(table);
	    	comp.init();
	    });
	}
	
	//override
	comp.api.remove = function() {
		configWatch();
		comp.remove();
		comp = null;			
	};
	
	comp.api.update = function(data) {
		if (data == undefined || data == null || data.length == 0){
			comp.data = [];
			comp.update();
			return;
		}
		if (comp.component == null || comp.component == undefined) {
			createWidget();
			return;
		}
		if (!comp.active){
			return;	
		}
		if (data.length == 0){
			return;
		}
		
		for (var i=0; i<data.length; i++) {
			var elapsed = data[i].elapsed/1000;
			data[i].elapsed = elapsed.toFixed(2);
		}
		
		/*data = [
            { serviceName: "Login/Login.do", objName: "w1", elapsed: "100" }            
        ];*/			
		
		comp.data = data;      		
		comp.update();
	};
	
	comp.api.resize = function() {
		if (!comp.active){
			return;
		}
		comp.resize();		
	};
	
	comp.api.reset = function() {
		if (comp.component == null || comp.component == undefined) {
			return;
		}
		if (!comp.active){
			return;		
		}
		if (comp.component.uit == undefined || comp.component.uit == null) {
			return;
		}
		comp.data = [];
		comp.update();
	}
	
	return comp.api;
};
	