function RealTimeSpeedBar(id, $scope, $rootScope, $interval, Data, TickTime) {
	function Component(type, id){		
		this.active = false;
		this.data = { tps: 0, rps: 0, act1: 0, act2: 0, act3: 0 };
		
		this.component = {};
		this.api = {};
		
		this.resize = function() {
		};
		
		this.update = function() {
		};	
	};
	
	
	var comp = new Component('speedBar', id);
	var rpsSpeed = 2;
	var tpsSpeed = 2;
	
	createWidget();	
	function createWidget() {
		//create p5 Objcet
		var closure = function(sketch) {
			var boxElement = angular.element("#"+id)[0];	 
			var width = boxElement.clientWidth;
			var height = boxElement.clientHeight;
			
			function showRequestQue() {
				showBackground();
				
				var rectWidth = width/50; 
				var rectHeight = 30;
				var rectStart = 0;
				
				var i=0; var count = 0;
				
				var tPosition = 0;
				var act1 = comp.data.act1; 
				var act2 = comp.data.act2; 
				var act3 = comp.data.act3;
				
				if ((act1 + act2 + act3) == 0) {return;};
				
				if (act3 >= 50){
					act1 = 0;
					act2 = 0;
					act3 = 50;
				}else if (act2 + act3 >= 50){
					act1 = 0;
					act2 = 50 - act3;
				}else if (act1 + act2 + act3 >= 50){
					act1 = 50 - act2 - act3;
				}
				
				for (i=0; i<act1; i++) {		
					sketch.stroke(30, 37, 51);
					sketch.fill(55, 194, 255);					
					sketch.rect(rectStart, (height-rectHeight)/2, rectWidth, rectHeight);
					rectStart+=rectWidth;
				};
				
				for (i=0; i<act2; i++) {					
					sketch.stroke(30, 37, 51);
					sketch.fill(255, 181, 0);										
					sketch.rect(rectStart, (height-rectHeight)/2, rectWidth, rectHeight);	
					rectStart+=rectWidth;
				};
				
				var position;
				for (i=0; i<act3; i++) {					
					sketch.stroke(30, 37, 51);
					sketch.fill(255, 71, 76);					
					sketch.rect(rectStart, (height-rectHeight)/2, rectWidth, rectHeight);
					rectStart+=rectWidth;
				};				
			};
			
			function showBackground() {
				var rectWidth = width/50; 
				var rectHeight = 30;
				var rectStart = 0;
				
				for (var i=0; i<50; i++) {					
					sketch.stroke(30, 37, 51);
					sketch.fill(74, 79, 89);						
					sketch.rect(rectStart + (i*rectWidth), (height-rectHeight)/2, rectWidth, rectHeight);
					
				};
			};
			
			var speedBars = [];
			function SpeedBar() {
				this.rectWidth = width/150; 
				this.rectHeight = 30;
				
				this.startX = 0;
				this.startY = 0;
				
				this.x = this.startX;
				this.y = this.startY;				
				this.speed = 5;
				
				this.update = function() {
					this.move();
					this.display();
					if (width > 0 && this.x > width-20) {
						this.remove();
					};
				};
				
				this.move = function() {
					this.x += this.speed;					
				};
				
				this.display = function() {
					sketch.fill(74, 79, 89);	
					sketch.stroke(30, 37, 51);
					sketch.rect(this.x, (height-this.rectHeight)/2, this.rectWidth, this.rectHeight);
				};
				
				this.remove = function() {
					this.x = -1000;
					speedBars.splice(speedBars.indexOf(this), 1);				
				};				
			}
			
			sketch.setup = function() {
				sketch.createCanvas(0, 0);	
				sketch.noStroke();				
			};
			
			var rpsFrameCount = 0;
			var tpsFrameCount = 0;
			var tempCount = 0;
			
			sketch.draw = function() {
				var newWidth = boxElement.clientWidth;
				var newHeight = boxElement.clientHeight;
				var changed = false;
				if (newWidth != width || newHeight != height) {
					width = newWidth; height = newHeight;
					sketch.resizeCanvas(newWidth, newHeight);
					changed = true;
				};
				sketch.background(30, 37, 51);
				
				var maxValue = sketch.constrain(sketch.frameCount * 2, 0, 400);
				rpsFrameCount++;
				tpsFrameCount++;
				
				showRequestQue();
				
				if (changed) {changed = false;}		
			};
		};
		
		speedBarInit();
		
		function speedBarInit(){
			_initEvent();
		};
		
		function currentDomn(_defaultVal){
			var _domn = localStorage.getItem('service_transaction');
			if(_defaultVal){
				if(_domn && _domn != ''){
					
				}else{
					_domn = _defaultVal;
				}
			}else{
				if(_domn){
					
				}else{
					_domn = '';
				}
			}
			return _domn;
		};
		
		function _initEvent(){
			var st_domnId = currentDomn();
			
			if(st_domnId && st_domnId!=''){
				$('input[name="service_transaction"][value="'+st_domnId+'"').attr('checked', 'checked');
			}
		};
		
		comp.component = new p5(closure, id);
		comp.active = true;
	};
	
	comp.api.remove = function() {	
		if (!comp.active){
			return;
		}
		comp.component.remove();
		comp.component = null;
		comp = null;			
	};
	
	comp.api.update = function(data) {
		if (data == undefined || data == null || data.length == 0){
			return;		
		}
		if (comp.component == null || comp.component == undefined) { createWidget(); return; }		
		if (!comp.active){
			return;
		}
		comp.data = data[1].value;
		
		
		var data = {"ttps":comp.data.tps, "rtps":comp.data.rps, "act1":comp.data.act1, "act2":comp.data.act2, "act3":comp.data.act3};
		refreshTps(data);
		
	};
	
	comp.api.resize = function() {
		if (!comp.active){
			return;
		}
	};
	
	comp.api.reset = function() {
		if (comp.component == null || comp.component == undefined) {
			return;
		}
		if (!comp.active){
			return;		
		}
		comp.data= {ttps: 0, rtps: 0, act1: 0, act2: 0, act3: 0};
		comp.update();
		
		refreshTps(comp.data);
	}
	
	function refreshTps(_data){
		var _ttps = _data.ttps * 1; 
		var _rtps = _data.rtps * 1;
		var _act1 = _data.act1 * 1;
		var _act2 = _data.act2 * 1;
		var _act3 = _data.act3 * 1;
		
		$('#speedbar_input').attr('class','').addClass('ani-lv'+getTpsGrade(_ttps));
		
		if(!$('#speedbar_output').hasClass('ani-lv0') && _rtps == 0){
			$('#speedbar_output').fadeOut();
			$('#speedbar_output').attr('class','').addClass('ani-lv'+getTpsGrade(_rtps));
			$('#speedbar_output').fadeIn();
		}else{
			$('#speedbar_output').attr('class','').addClass('ani-lv'+getTpsGrade(_rtps));
		}
		
		$('#speecbar_desc .input-desc').text(_ttps);
		$('#speecbar_desc .output-desc').text(_rtps);
		$('#speecbar_desc .act1-desc').text(_act1);
		$('#speecbar_desc .act2-desc').text(_act2);
		$('#speecbar_desc .act3-desc').text(_act3);
	};
	
	
	function getTpsGrade(_tps){
		var arrays = [10, 30, 60, 90];
		
		var tpsObj = {};
			tpsObj['lv1'] = '10'; 
			tpsObj['lv2'] = '30'; 
			tpsObj['lv3'] = '60'; 
			tpsObj['lv4'] = '90'; 
		
		
		try{
			if(tpsObj['lv1']){ arrays[0] = tpsObj['lv1']*1; }
			if(tpsObj['lv2']){ arrays[1] = tpsObj['lv2']*1; }
			if(tpsObj['lv3']){ arrays[2] = tpsObj['lv3']*1; }
			if(tpsObj['lv4']){ arrays[3] = tpsObj['lv4']*1; }
		}catch(e){
			arrays = [10, 30, 60, 90];
		}
	
		var lv = 0;
		if(_tps == 0){
			lv = 0;
		}else if(_tps < arrays[0]){
			lv = 1;
		}else if(_tps < arrays[1]){
			lv = 2;
		}else if(_tps < arrays[2]){
			lv = 3;
		}else if(_tps < arrays[3]){
			lv = 4;
		}else{
			lv = 5;
		}
		return lv;
	};
	return comp.api;
};
	