function RealTimeSystemCPUEQ(id, $scope, $rootScope, $interval, Data, TickTime) {
	function Component(type, id){
		ComponentBase.apply(this, arguments);
	};	
	inherit(Component, ComponentBase);
	function inherit(C, P) {
		var F = function(){};
		F.prototype = P.prototype;
		C.prototype = new F();
	};
	
	var comp = new Component('chart', id);
	comp.data = [
		{ wait: 0, sys:0, user:0, nice:0, value:0}		
	];

	var chart = new Object();
	
	var configWatch = $scope.$watch('config.visible', function(bool){
		if (!comp.active){
			return;
		}
		if (bool) { comp.show(); } 
		else { comp.hide(); }
	}, true);
	
	createWidget();
	function createWidget() {
		jui.ready(["chart.builder"], function (juiChart) {
			var tooltipText = {
					"wait" : "Wait",
					"sys" : "Sys",
					"user" : "User",
					"nice" : "Nice"
			}
			
			var style = {
				//yellow, red, green, blue
				//colors: ["#38c3ff", "#00ceae", "#ffb500", "#ff474c"],
	            colors: ["#ff474c", "#38c3ff", "#8000ff", "#80ff00"],
		        backgroundColor: "#00000000",
		        axisBorderColor: "#00000000",
		        axisBorderWidth: 1,
		        axisBorderRadius: 5,
		        gridXFontSize: 10,
		        gridXFontColor: "#c2c6c9",
		        gridYFontSize: 10,
		        gridYFontColor: "#c2c6c9",	    
		        gridXAxisBorderWidth: 1,
		        gridXAxisBorderColor: "#c2c6c9",
		        gridYAxisBorderWidth: 1,
		        gridYAxisBorderColor: "#c2c6c9",
		        gridBorderColor:"#00000000",
		        tooltipFontColor:"#fff",
		        tooltipBackgroundColor:"#1b1b1b",
		        legendFontColor:"#c2c6c9",
		        lineBorderWidth: 1
			};	
			
			chart = juiChart("#"+id+" > .box-content > .component", {
				padding: { left: 40, top: 20, right: 20, bottom: 30 },
				axis: [
	            	{
		                x: {
		                	type: "block",
							domain:[],
		                },
		                y: {
		                    type: "range",
		                    /*domain : function(d) {
		                        return Math.max(d.value) * 1.5;
		                    },*/
		                    domain:[0, 100],
		                    step: 4,
		                    line: true
		                },
		                data: comp.data
	            	}
	            ],
	            brush: [
	            	{
		                type: "equalizercolumn",						
						target: ["wait", "nice", "user", "sys"],
						display : "all",
		                unit: 25	                
	            	},
	            	{
		                type: "equalizercolumn",
						target: ["nodeAlive"],
		                display : "all",
		                unit: 5,
		                colors: function (d) {
    			            return "#757474";
    			        }
	            	}
	            ],
	            widget: [
	            	{
	            		type: "tooltip",
	            		format : function(k,v){
	            			var key = tooltipText[v];
	            			var value = k[v];
	            			return key +" : "+ value;
	            		},
	            		all: true
	            	},	            	
	            ],
	            event : {
			        "click": function(obj) {
			        	$scope.openCpuThreadListDialog(obj.data.nodeId);
			        }
			    },
	            style: style,
	            render: false
	        }); 
			comp.setComponent(chart);
	    	comp.init();   
		});
	}
	
	comp.api.remove = function() {
		configWatch();
		comp.remove();
		comp = null;			
	};
	
	comp.api.update = function(data) {
		if (data == undefined || data == null || data.length == 0){
			return;
		}
		if (comp.component == null || comp.component == undefined) {
			createWidget();
			return;
		}
		if (!comp.active){
			return;		
		}
		var dataSource = [];
		for (var i=0; i<data.length; i++) {
			if(data[i].nodeAlive == false){
				data[i].value.nodeAlive = 100;
			}else{
				data[i].value.nodeAlive = 0;
			}
			data[i].value.value = data[i].value.wait + data[i].value.sys + data[i].value.user + data[i].value.nice;
			data[i].value.nodeId = data[i].id;
			dataSource.push(data[i].value);
		}
		var yDomain = [0, 100];//comp.getEQDomain(dataSource);
		var target = comp.getEQTarget(data);
		comp.component.axis(0).set("x", {domain: target});
		comp.component.axis(0).set("y", {domain: yDomain});
		comp.data = dataSource;
		comp.update();
	};
	
	comp.api.resize = function() {
		if (!comp.active){
			return;
		}
		comp.resize();		
	};
	
	comp.api.reset = function() {
		if (comp.component == null || comp.component == undefined) {
			return;
		}
		if (!comp.active){
			return;		
		}
		/*if (comp.component.uit == undefined || comp.component.uit == null) {
			return;
		}
		var dataSource = [];
		var data = []; 
		var yDomain = comp.getEQDomain(dataSource);
		var target = comp.getEQTarget(data);
		comp.component.axis(0).set("x", {domain: target});
		comp.component.axis(0).set("y", {domain: yDomain});
		comp.data = dataSource;
		comp.update();*/
		
		comp.data=[];
		comp.update();
	}
	return comp.api;
};
