
function TopologyView(id, $scope, $rootScope, $interval, Data, TickTime) {
	function Component(type, id){
		ComponentBase.apply(this, arguments);
	};	
	inherit(Component, ComponentBase);
	function inherit(C, P) {
		var F = function(){};
		F.prototype = P.prototype;
		C.prototype = new F();
	};
	
	var comp = new Component('chart', id);
	var chart = new Object();
	
	var configWatch = $scope.$watch('config.visible', function(bool){
		if (!comp.active){
			return;
		}
		if (bool) { comp.show(); } 
		else { comp.hide(); }
	}, true);
	
	var nodeData = [];
	var edgeData = [];
	
	createWidget();
	
	function createWidget() {
		jui.ready(["chart.builder"], function (juiChart) {
			var style = {
					colors: ["#1e608e", "#899cb5", "#c66611", "#c69361", "#287f28", "#79ae6e", "#a72425", "#c67977", "#765494", "#9a8ba6"],		
			        backgroundColor: "#00000000",
			        axisBorderColor: "#00000000",
			        axisBorderWidth: 0,
			        axisBorderRadius: 5,
			        topologyNodeRadius: 20,
	                topologyNodeFontSize: 14,
	                topologyNodeFontColor:"#fff",
	                topologyEdgeWidth:1,
	                topologyNodeTitleFontColor:"#fff",
	                topologyEdgeFontColor:"#fff",
			        tooltipFontColor:"#1b1b1b",
			        tooltipBackgroundColor:"#1b1b1b"
			};	
	    	
			chart = juiChart(("#"+id+" > .box-content > .component" ), {    	
	    		padding: { left: 10, top: 10, right: 20, bottom: 40 },
	    	    axis: {
	    	        c: {
	    	            type: "topologytable"
	    	        },
	    	        data: nodeData
	    	    },
	    	    brush: {
	    	        type: "topologynode",
	    	        nodeImage: function (data) {
                        if (data.type == "user") {
                            return "images/topology/user.png";
                        } else if (data.type == "server" || data.type == "host") {
                            return "images/topology/server.png";
                        } else if (data.type == "was") {
                            return "images/topology/was.png";
                        } else if (data.type == "db") {
                            return "images/topology/db.png";
                        } else {
                        	return "images/topology/was.png";
                        }
                    },
	    	        /*nodeText: function(data) {
	    	        	if (data.type == "user") {
	    	        		return "{user}";
	    	        	}else if(data.type == "server") {
	    	                return "{server}";
	    	            } else if(data.type == "was") {
	    	                return "{was}";
	    	            } else if (data.type == "db") {
	    	            	return "{db}";
	    	            } else {
	    	                return "";
	    	            }	    	            
	    	        },*/
	    	        nodeTitle: function(data) {
	    	            return data.name;
	    	        },
	                nodeScale: function(data) {
                        //return 1.0;
                        if (data.type == "user") {
                            return 1;
                        } else if (data.type == "server" || data.type == "host") {
                            return 1;
                        } else if (data.type == "was") {
                            return 0.8;
                        } else if (data.type == "db") {
                            return 0.8;
                        } else {
                            return 0.8;
                        }
                    }
	                /*edgeData: edgeData,
	                edgeText: function(data, align) {
	                    var text = data.count;
	                    if(align == "end") {
	                        text = text + " →";
	                    } else {
	                        text = "← " + text;
	                    }
	                    return text;
	                },
	                edgeOpacity: function(data) {
	                    if(data.time > 1000) {
	                        return 1;
	                    }
	                    return 0.75;
	                },
	                tooltipTitle: function(data, align) {
	                    if(align == "start") {
	                        return data.reverse().join(" ← ");
	                    }
	                    return data.join(" → ");
	                },
	                tooltipText: function(data) {
	                    return "Total Response Time (Count) : " + data.time + " (" + data.count + ")";
	                }*/
	    	    },	    	        	   
	            style: style,
	            render: false
	        });
			comp.setComponent(chart);
	    	comp.init();   
	    	//if (TickTime > 0) { startTick(); }
		});
	}
	
	comp.api.remove = function() {
		configWatch();
		comp.remove( );
		comp = null;		
	};
	
	function createNode() {
		nodeData.push({ key: data[i].key, name: data[i].nodeGroupNm, type: "server", outgoing: []});
	};
	
	var tempCreate = false;
	var cacheData = [];
	comp.api.update = function(data) {		
		if (data == undefined || data == null || data.length == 0) {
			return;
		}
		if (comp.component == null || comp.component == undefined) {
			createWidget();
			return;
		}
		if (!comp.active){
			return;
		}
		
		if (cacheData.length == data.length) {
			return;
		}
		nodeData = [];
		nodeData.push({ key: data.groupId, name: data.groupName, type: "user", outgoing: [] });
		
		var list = data.list;
		for (var i = 0; i < list.length; i++) {
			nodeData.push({ key: list[i].key, name: list[i].name + '\n tps:10' + '\n cpu:100' , type: list[i].type, outgoing: [list[i].outgoing] });
		}
		
		//if (tempCreate) { return; } else { tempCreate = true; };
		
		if (tempCreate) {			
			comp.component.updateBrush(0, {nodeTitle: [1,2,3,4,5]});
			comp.component.render();
		} else {
			tempCreate = true;
			comp.component.axis(0).update(nodeData);
			comp.component.render();
		};
		
	};
	
	comp.api.resize = function() {		
		if (!comp.active){
			return;
		}
		comp.resize();		
	};
	
	return comp.api;
};


