'use strict';
angular.module('mainApp')
.controller('DashBoardCtrl', function ($window, $route, $scope, $rootScope, $cookies, $interval, $timeout, $log, $mdDialog, $mdMenu, Data, Common, StorageManager, WidgetInfoManager, $location) {
// ===============================================================================
// initialize -->
// ===============================================================================		
	$rootScope.$watch("networkConnected", function(newVal, oldVal) {
	   	if (newVal !== oldVal) { 
	   		var bool = newVal;
	   		if (!bool) {
	   			fnStopInterval();	   			
	   		} else {
	   			fnResetWorker();
	   		}	   		
		};
    });
	
	$scope.alertDialogOk = function (){
		$location.path("/login");
		return;
	}
	
	var hostindex = location.href.indexOf(location.host) + location.host.length;
	var serviceBase = location.href.substring(0, location.href.indexOf('/', hostindex + 1)) + "/";
	
	var isCollectInterval;
	var isLoadDataInterval;
	var isCalendarInterval;
	
	var isFirstStart = false;
	var isAjaxCollectEnd = true;
	var isAjaxLoadDataEnd = true;
	var myDashboardId = 0;
	var uxid = (new Date()).getTime();      	
	
	//dashBoard widget
	var realTimeSpeedBar = undefined;
	var realTimeActiveService = undefined;
	var realTimeActiveServiceEQ = undefined;
	var realTimeXlog = undefined;
	var realTimeProcessCPU = undefined;
	var realTimeSystemCPUEQ = undefined;
	var realTimeHeapMemory = undefined;
	
	var realTimeDbCounter = undefined;
	var realTimeActiveThreadList = undefined;
	var counterTodayTPS = undefined;
	var counterTodayVisitor = undefined;
	var counterTodayCurrentUser = undefined;
	var collectSearchCnt = 0;
	
	$scope.isSlickAutoMove=false;
    $scope.normalFilter=true;
    $scope.errorFilter=true;
    $scope.autoAxisY=true;
	$scope.nodeAllselected = {select :false};
	//dashBoard data
	//현재 시스템 간략 카운트 정보
	$scope.totalResponseTime = 0; 
	$scope.totalTpsTime = 0;
	$scope.totalCurrentActive = 0; 
	$scope.totalAgentCount = 0; 
	$scope.totalPrev5minUser = 0; 
	$scope.totalTodayUser = 0; 
	
	$scope.prev5TotalResponseTime = "0"; 
	$scope.prev5TotalTpsTime = "0";	
	$scope.prev5TotalPrev5minUser = "0";
	
	$scope.week5TotalResponseTime = "0"; 
	$scope.week5TotalTpsTime = "0";	
	$scope.week5TotalPrev5minUser = "0";
	
	//서비스 예외 및 오류개수
	$scope.exceptionCritical = 0; 
	$scope.exceptionWarn = 0; 
	$scope.exceptionNormal = 0;
	
	//variables	
	var isLoading = true;
	$scope.isReady = false;
	$scope.isResize = false;
	
	$scope.config = {visible : false, setting: false};
	$scope.dashboard = {};
	
	$scope.gridsterOptions = {
		margins : [ 10, 10 ],
		columns : 9,
		rowHeight : 180
	};
	
	$scope.datePicker = {
		currentUserLoadDate : Common.getYesterday()
		, serviceCallLoadDate : Common.getYesterday()
		, visitorLoadDate : Common.getYesterday()
	};

	$scope.currentDate;
	$scope.currentTime;
	$scope.ready = function () {
		//loading or transition
		isLoading = true;
    };
    
    $scope.isSelectNode = false;
    
	$(document).ready(function(){
        $("html").css("background-color", "#151b25");
        
        if ($rootScope.userInfo == undefined){        	
        	$scope.sessionCheck = true;
    		Common.alertDialog("알림", "세션 정보를 찾을수 없습니다. 다시 로그인 하세요.");
    		$location.path("/login");
    		return;
    	}else{
    		$scope.userTyp = $rootScope.userInfo.userTyp;
    	}
        
        if($scope.userTyp != "user"){
        	var html = '<a class="dropdown-button" data-activates="settings">구성관리<i class="material-icons right">arrow_drop_down</i></a>';
        	$("#settingsTag").html(html);
        }
        
        $(".dropdown-button").dropdown();
		
        $scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;
    	
		fnInit();
	});
	
	angular.element(window).on('resize', function(e) {
		if ($scope.isResize) { return;}
		$scope.isResize = true;
		$timeout(function() {
			fnResizeDashboard();
			$scope.isResize = false;
		}, 200)		
	});

	$scope.$on('gridster-resized', function(gridster, size) {		
		if ($scope.isResize) { return;}
		$scope.isResize = true;
		$timeout(function() {
			fnResizeDashboard();
			$scope.isResize = false;
		}, 200)
	});
	
	function fnInit() {
		if (!$rootScope.noticeCloseFlag){
			$rootScope.noticeCount = 0;
		}
		
		isLoading = false;
		
		isCalendarInterval = $interval(function() {
        	fnCalendar();        	
        }, 1000);
		
		$timeout(function() {
				$scope.isReady = true;
				$scope.config.visible = true;
			}, 200);
		
		$scope.$watch('config.visible', function(bool){
			if (!$scope.isReady){
				return;
			}
			
			if (!bool) {
				//서버연동 일시중지
				$scope.gridsterOptions = {
						margins : [ 10, 10 ],
						columns : 9,
						draggable : {
							enabled : true,
							handle : 'div',
							start : function(event, $element, widget) {
							},
							stop : function(event, $element, widget) {
								$timeout(function() {
									if (widget.component){
										widget.component.resize();
									}
								}, 400)
							}
						},
						resizable : {
							enabled : true,
							//handles : [ 'n', 'e', 's', 'w', 'ne', 'se', 'sw', 'nw' ],
							start : function(event, $element, widget) {
							},
							resize : function(event, $element, widget) {
								if (widget.component){
									widget.component.resize();
								}
							},
							stop : function(event, $element, widget) {
								$timeout(function() {
									if (widget.component){
										widget.component.resize();
									}
								}, 400)
							}
						},
					};
			} else {
				//대시보드 gridster depth 문제로 인해 page reload가 필요함.
				$scope.gridsterOptions = {
						margins : [ 10, 10 ],
						columns : 9,
						draggable : { enabled : false },
						resizable : { enabled : false },
					};
			}
		}, true);
		
		fnCreateDashboard();	
		
		if (StorageManager.getAllAgent() != undefined && StorageManager.getAllAgent() != null) {
			$rootScope.allAgent = StorageManager.getAllAgent();
		};
		
		if (StorageManager.getSelectedGroup() != undefined && StorageManager.getSelectedGroup() != null) {
			$rootScope.selectedGroup = StorageManager.getSelectedGroup();			
		} else {
			//선택된 그룹이 없을 경우 가장 처음그룹으로 자동선택
			var b = false;
			var allAgent = $rootScope.allAgent;
			for (var i = 0; i < allAgent.length; i++) {
				if(0 < allAgent[i].serverList.length){
					$scope.selectGroup(allAgent[i]);
					b = true;
					break;
				}
			}
			if(!b){
				$rootScope.selectedGroup = {};
				$rootScope.selectedGroup.selectedAgent = [];
				$scope.openAgentList();
			}
			return;
		};
		
		//play worker
		if ($rootScope.selectedGroup.selectedAgent.length > 0) {
			$rootScope.xlogYMax = StorageManager.getXlogYMax($rootScope.selectedGroup);
			fnResetWorker();			
		} else {		
			//선택된 그룹이 없을 경우 가장 처음그룹으로 자동선택
			var b = false;
			var allAgent = $rootScope.allAgent;
			for (var i = 0; i < allAgent.length; i++) {
				if(0 < allAgent[i].serverList.length){
					$scope.selectGroup(allAgent[i]);
					b = true;
					break;
				}
			}
			if(!b){
				$rootScope.selectedGroup.selectedAgent = [];
				$scope.openAgentList();
			}
			return;
		};
		
		$timeout(function() {
			$("#groupList").slick({
				infinite:false,
				variableWidth: true,
				slidesToScroll:5
			});
			
		}, 1000);
		
	};	
	
	var oldNodeSubListGroupid = null;
	$scope.nodeSubOpen = function(group, $event){
		if (oldNodeSubListGroupid == group.nodeGroupId && $scope.isSelectNode == true){
			$scope.isSelectNode = false;
			return;
		}
		
		$scope.nodeAllselected.select = false;
		var allAgent = StorageManager.getAllAgent();
		
		$scope.nodeSubList = [];
		
		for (var i = 0; i < allAgent.length; i++) {
			if (allAgent[i].nodeGroupId == group.nodeGroupId){
				for (var serverCnt = 0; serverCnt < allAgent[i].serverList.length; serverCnt ++){
					for (var nodeCnt = 0; nodeCnt < allAgent[i].serverList[serverCnt].nodeList.length; nodeCnt ++){
						var nodeObj = { nodeGroupId : allAgent[i].serverList[serverCnt].nodeList[nodeCnt].nodeGroupId,
										nodeGroupNm : allAgent[i].serverList[serverCnt].nodeList[nodeCnt].nodeGroupNm,
										svrId : allAgent[i].serverList[serverCnt].nodeList[nodeCnt].svrId,
										nodeId : allAgent[i].serverList[serverCnt].nodeList[nodeCnt].nodeId, 
										nodeNm :allAgent[i].serverList[serverCnt].nodeList[nodeCnt].nodeNm, selected:false};
						
						$scope.nodeSubList.push(nodeObj);
					}
				}
				break;
			}
		}
		
		$scope.glSubListX = $event.clientX -135;
		oldNodeSubListGroupid = group.nodeGroupId
		$scope.isSelectNode = true;
		
		$timeout(function() {
			$("#nodeSublist").mCustomScrollbar();
		}, 200)		
		
	};
	
	$scope.nodeSubAnswer = function(){
		var selectedAgentIds = [];
		
		for (var i=0; i<$scope.nodeSubList.length; i++) {
			if ($scope.nodeSubList[i].selected) {
				var agentId = {svrId :$scope.nodeSubList[i].svrId, id: $scope.nodeSubList[i].nodeId};
				selectedAgentIds.push(agentId);	
			}
		};
		
		if (selectedAgentIds.length < 1){
			Common.alertDialog("알림", "선택한 에이전트가 없습니다.");
			return;
		}else{
			var selectedGroup = {id:$scope.nodeSubList[0].nodeGroupId, name:$scope.nodeSubList[0].nodeGroupNm};
			selectedGroup.selectedAgent = selectedAgentIds;
			
			StorageManager.clearSelectedGroup();
			StorageManager.setSelectedGroup(selectedGroup);
			$rootScope.selectedGroup = StorageManager.getSelectedGroup();    		
			fnResetWorker();
			fnReloadXlogData();
			
		}
		
		$scope.isSelectNode = false;
	};
	
	$scope.nodeSubcancel = function(){
		$scope.isSelectNode = false;
	};
	
	$scope.$watch("nodeAllselected.select", function(newVal, oldVal) {
		if ($scope.nodeSubList == undefined){return;}
		for (var i = 0; i < $scope.nodeSubList.length; i++) {
			$scope.nodeSubList[i].selected = newVal;
		}
		
	});
	
	function fnStartCollectInterval() {
		if (angular.isDefined(isCollectInterval)){
        	return;
        }
		isAjaxCollectEnd = true;
		isAjaxLoadDataEnd = true;
		isFirstStart = true;
        $('#RealTimeActiveService').show();
    	$('#RealTimeActiveServiceEQ').show();
    	$('#RealTimeXlog').show();
    	$('#RealTimeProcessCPU').show();
    	$('#RealTimeSystemCPUEQ').show();
    	$('#RealTimeHeapMemory').show();
    	$('#RealTimeActiveThreadList').show();
    	$('#RealTimeDBCounter').show();
    	
    	$rootScope.groupIds = [];
    	var nextGroup = [];
    	var nextid = 0;
    	
    	for (var i=0; i<$rootScope.allAgent.length; i++) {
    		$rootScope.groupIds.push($rootScope.allAgent[i].nodeGroupId);
    		if ($rootScope.allAgent[i].nodeGroupId == $rootScope.selectedGroup.id){
    			nextid = i;
    		}
    	}
    	
    	nextid = fnGetNextGroupidx(nextid, $rootScope.selectedGroup.id);
    	nextGroup = {nodeGroupId: $rootScope.allAgent[nextid].nodeGroupId, nodeGroupNm: $rootScope.allAgent[nextid].nodeGroupNm};
		nextGroup.serverList = $rootScope.allAgent[nextid].serverList;
		
    	$rootScope.selectedAgentIds = [];
    	for (var i=0; i<$rootScope.selectedGroup.selectedAgent.length; i++) {
    		var agentId = $rootScope.selectedGroup.selectedAgent[i].svrId + "_" + $rootScope.selectedGroup.selectedAgent[i].id;
    		$rootScope.selectedAgentIds.push(agentId);	
    	};
    	var past = 0;

    	if (isFirstStart == true){
			past = 1;
		}
    	var params = {
    					oid:$rootScope.selectedAgentIds.toString(','), 
    					currentUserLoadDate: $rootScope.loadDates.currentUserLoadDate,
    					serviceCallLoadDate: $rootScope.loadDates.serviceCallLoadDate,
    					visitorLoadDate: $rootScope.loadDates.visitorLoadDate,
    					nodeGroupId: $rootScope.selectedGroup.id,
    					PAST: past
    	}
    	
    	if (isFirstStart == true){
    		isFirstStart == false;
    		fnCollectSearch(params);
    		fnLoadDataSearch(params);
    	}
    	
    	params.PAST = 0;
    	
        isCollectInterval = $interval(function() {
        	if (isAjaxCollectEnd && collectSearchCnt >= 10 && $scope.isSlickAutoMove){
        		$scope.selectGroup(nextGroup);
        		collectSearchCnt = 0;
        		$timeout(function() {
	        		var slider = $("#groupList");
	        		slider[0].slick.slickGoTo(nextid);
        		}, 1000);
        		return;
        	}
        	
        	fnCollectSearch(params);        	
        }, 2000);
    };
    
    function fnGetNextGroupidx(startIdx, selectedGroupId){
    	var startIdxVal = startIdx;
    	var nextid = 0;
    	
    	if (startIdxVal + 1 >= $rootScope.allAgent.length){
    		startIdxVal = 0;
    	}else{
    		startIdxVal = startIdxVal + 1;
    	}	
    	
    	for (var i = startIdxVal; i < $rootScope.allAgent.length; i++) {
    		if ($rootScope.allAgent[i].nodeGroupId == selectedGroupId){
    			nextid = startIdx;
    			break;
    		}
    		if ($rootScope.allAgent[i].serverList.length > 0){
    			nextid = i;
    			break;
    		}
    	}
    	
    	if (nextid == 0){
    		for (var i = 0; i < $rootScope.allAgent.length; i++) {
        		if ($rootScope.allAgent[i].nodeGroupId == selectedGroupId){
        			nextid = startIdx;
        			break;
        		}
        		if ($rootScope.allAgent[i].serverList.length > 0){
        			nextid = i;
        			break;
        		}
        	}
    	}
    	
    	return nextid;
    }
    function fnStartLoadDataInterval(){
		if (angular.isDefined(isLoadDataInterval)){
        	return;
        }
		isAjaxCollectEnd = true;
    	$('#CounterTodayTPS').show();
    	$('#CounterTodayVisitor').show();
    	$('#CounterTodayCurrentUser').show();
    	
    	var params = {
    					oid:$rootScope.selectedAgentIds.toString(','), 
    					currentUserLoadDate: $rootScope.loadDates.currentUserLoadDate,
    					serviceCallLoadDate: $rootScope.loadDates.serviceCallLoadDate,
    					visitorLoadDate: $rootScope.loadDates.visitorLoadDate,
    					type:"svc",
    					uxid:uxid,
    					nodeGroupId: $rootScope.selectedGroup.id,
    					PAST: 0
    	}
    	
    	
        isLoadDataInterval = $interval(function() {
        	fnLoadDataSearch(params);    	
        }, 5000);
    };
    
    function fnStopInterval() {
    	collectSearchCnt = 0;
        if (angular.isDefined(isCollectInterval)) {
            $interval.cancel(isCollectInterval);
            isCollectInterval = undefined;
        }
        if (angular.isDefined(isLoadDataInterval)) {
            $interval.cancel(isLoadDataInterval);
            isLoadDataInterval = undefined;
            $scope.prev5TotalResponseTime = "0"; 
        	$scope.prev5TotalTpsTime = "0";	
        	$scope.prev5TotalPrev5minUser = "0";
        	
        	$scope.week5TotalResponseTime = "0"; 
        	$scope.week5TotalTpsTime = "0";	
        	$scope.week5TotalPrev5minUser = "0";
        }
        
        //스피드바 중지
        if (realTimeSpeedBar != undefined) {
			realTimeSpeedBar.reset();
		}
    };
    
    function fnCollectSearch(params){
    	params.uxid=uxid;
    	params.type="svc";
    	
    	if (params.PAST != 1){
	    	if (!$scope.config.visible){
	    		return;
	    	}
	    	if (isCollectInterval == undefined){
	    		return;
	    	}
	    	if (isAjaxCollectEnd == false){
	    		return;
	    	}
    	}
    	isAjaxCollectEnd = false;
    	
		Data.ajax({url:'dashBoard/selectDashBoardCollectData', param:params, errorCallback:$scope.errorCallback, successCallback:function(data, status) {
			try {
				isAjaxCollectEnd = true;
				if(data) {
					if ($rootScope.selectedGroup.id != data.nodeGroupId){
						return;
					}
					if (data.counterRecents != null && data.counterRecents != undefined){
						fnSetCounterRecent(data.counterRecents);
					}
					if (data.realtimeGraphs != null && data.realtimeGraphs != undefined){
						fnSetRealtimeGraph(data.realtimeGraphs);
					}
					if (data.xLogCntInfo != null && data.xLogCntInfo != undefined){
						fnSetXlogData(data.xLogCntInfo);
					}
					if (data.speedBarData != null && data.speedBarData != undefined){
						fnSetSpeedBar(data.speedBarData);
					}
					collectSearchCnt ++;
			    	$('#RealTimeActiveService').hide();
			    	$('#RealTimeActiveServiceEQ').hide();
			    	$('#RealTimeXlog').hide();
			    	$('#RealTimeProcessCPU').hide();
			    	$('#RealTimeSystemCPUEQ').hide();
			    	$('#RealTimeHeapMemory').hide();
			    	$('#RealTimeActiveThreadList').hide();
			    	$('#RealTimeDBCounter').hide();
				}
			} catch(ex) {}
		}});
    }
    
    var toastCnt = 1;
    function fnLoadDataSearch(params){
    	if (params.PAST != 1){
	    	if (!$scope.config.visible){
	    		return;
	    	}
	    	if (isCollectInterval == undefined){
	    		return;
	    	}
	    	if (isAjaxLoadDataEnd == false){
	    		return;
	    	}
    	}
    	isAjaxLoadDataEnd = false;
    	    	
		Data.ajax({url:'dashBoard/selectDashBoardLoadData', param:params, errorCallback:$scope.errorCallback, successCallback:function(data, status) {
			try {
				isAjaxLoadDataEnd = true;
				if(data) {
					if ($rootScope.selectedGroup.id != data.nodeGroupId){
						return;
					}
					
					if (data.counterExceptions != null && data.counterExceptions != undefined){
						fnSetCounterException(data.counterExceptions);
					}
					if (data.groupExceptionCounter.groupResults != null && data.groupExceptionCounter.groupResults != undefined){
						fnSetGroupStatus(data.groupExceptionCounter);
					}
					
					if(data.counterRecentsStats != null && data.counterRecentsStats != undefined){
						for (var i=0; i<data.counterRecentsStats.length; i++) {
							switch (data.counterRecentsStats[i].key) {
								case "TotalElapsedTime":
									if (data.counterRecentsStats[i].prev5Total == null || data.counterRecentsStats[i].prev5Total == undefined){
										$scope.prev5TotalResponseTime = "-";
									}else{
										$scope.prev5TotalResponseTime = Common.formatNumber(Math.floor(data.counterRecentsStats[i].prev5Total));
									}
									
									if (data.counterRecentsStats[i].week5Total == null || data.counterRecentsStats[i].week5Total == undefined){
										$scope.week5TotalResponseTime = "-";
									}else{
										$scope.week5TotalResponseTime = Common.formatNumber(Math.floor(data.counterRecentsStats[i].week5Total));
									}
									
									break;
								case "TotalTpsTime":
									if (data.counterRecentsStats[i].prev5Total == null || data.counterRecentsStats[i].prev5Total == undefined){
										$scope.prev5TotalTpsTime = "-";
									}else{
										$scope.prev5TotalTpsTime = Common.formatNumber(Math.floor(data.counterRecentsStats[i].prev5Total));
									}
									
									if (data.counterRecentsStats[i].week5Total == null || data.counterRecentsStats[i].week5Total == undefined){
										$scope.week5TotalTpsTime = "-";
									}else{
										$scope.week5TotalTpsTime = Common.formatNumber(Math.floor(data.counterRecentsStats[i].week5Total));
									}
									
									break;
								case "TotalPrev5minUser":
									if (data.counterRecentsStats[i].prev5Total == null || data.counterRecentsStats[i].prev5Total == undefined){
										$scope.prev5TotalPrev5minUser = "-";
									}else{
										$scope.prev5TotalPrev5minUser = Common.formatNumber(Math.floor(data.counterRecentsStats[i].prev5Total));
									}
									
									if (data.counterRecentsStats[i].week5Total == null || data.counterRecentsStats[i].week5Total == undefined){
										$scope.week5TotalPrev5minUser = "-";
									}else{
										$scope.week5TotalPrev5minUser = Common.formatNumber(Math.floor(data.counterRecentsStats[i].week5Total));
									}
									break;
								}
						}
					}
					if (data.loadtimeGraphs != null && data.loadtimeGraphs != undefined){
						fnSetLoadtimeGraph(data.loadtimeGraphs);
						$('#CounterTodayTPS').hide();
				    	$('#CounterTodayVisitor').hide();
				    	$('#CounterTodayCurrentUser').hide();
					}
					if (data.exceptionsList != null){
						for (var i=0; i<data.exceptionsList.length; i++) {
							var toastrMsg;
							if (data.exceptionsList[i].sttsLvl == "warn"){								
								toastrMsg = data.exceptionsList[i].nodeGroupNm + ' / ' + data.exceptionsList[i].nodeNm + '<br>' + data.exceptionsList[i].eventMsg;
								Common.toastr(toastrMsg, "warning", data.exceptionsList[i].eventDiv, data.exceptionsList[i], $scope.toastrCallback);
							} else if (data.exceptionsList[i].sttsLvl == "critical"){	
								toasterMsg = data.exceptionsList[i].nodeGroupNm + ' / ' + data.exceptionsList[i].nodeNm + '<br>' + data.exceptionsList[i].eventMsg;
								Common.toastr(toasterMsg, "error", data.exceptionsList[i].eventDiv, data.exceptionsList[i], $scope.toastrCallback);
							}
							if (i > 1){
								return;
							}
						}						
					}			
				}
			} catch(ex) {}
		}});
    }    
    
    $scope.toastrCallback = function(eventData) {
    	$mdDialog.show({
            controller: $scope.eventDetailController,
            templateUrl: 'views/modal/eventDetailDialog.html',
            parent: angular.element(document.getElementById("wrap")),
            targetEvent: event,
            clickOutsideToClose:true,
            locals : {
           	 item : eventData
            }
        }).then(function(formData) {
       	var params = formData;
        	Data.ajax({url:'dashBoard/updateHistException', param:params, successCallback:function(data, status) {
        		try {
        			if(data) {
	                	if (data.result == "1") {
	                		Common.alertDialog("해소 완료", "["+params.nodeGroupNm +"]그룹의 [" + params.nodeNm +"] 정보가 해소되었습니다.");
	               		 	$scope.getErrorList();
	                	}else{
	                		Common.alertDialog("오류", data.resultMsg);
	                	}
        			}
        		} catch(ex) {}
        	}});
        }, function() {
        });
    }
    
    function fnCalendar(){
		var korDate = ['일','월','화','수','목','금','토'];
		var nowDateTime = new Date();
		var hour = nowDateTime.getHours();
		var ampm = '오전';
		if(hour > 12){
			ampm = '오후';
			hour = hour - 12 ;
		}
		$scope.currentDate = nowDateTime.getFullYear() + '년 ' + (nowDateTime.getMonth()+1) +'월 ' + nowDateTime.getDate() + '일 (' + korDate[nowDateTime.getDay()] +')';
		$scope.currentTime = ampm + ' '+ hour + '시 ' + nowDateTime.getMinutes() + '분 ';// + nowDateTime.getSeconds() + '초' ;
	}
    
    $scope.errorCallback = function(){
    	
    };
    
    $scope.$on('$destroy', function() {
        fnStopInterval();
        fnRemoveDashboard();
    });
// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// rest controller -->
// ===============================================================================
	function fnSetCounterRecent(data) {
		for (var i=0; i<data.length; i++) {
			switch (data[i].key) {
				case "TotalElapsedTime":
					$scope.totalResponseTime = data[i].value; 
					break;
				case "TotalTpsTime":
					$scope.totalTpsTime = data[i].value; 
					break;
				case "TotalCurrentActive":
					$scope.totalCurrentActive = data[i].value; 
					break;
				case "TotalAgentCount":
					$scope.totalAgentCount = data[i].value; 
					break;
				case "TotalPrev5minUser":
					$scope.totalPrev5minUser = data[i].value; 
					break;
				case "TotalTodayUser":
					$scope.totalTodayUser = data[i].value; 
					break;
			}
		}
	};
	
	function fnSetCounterException(data) {
		for (var i=0; i<data.length; i++) {
			switch (data[i].key) {
				case "ExceptionCritical":
					$scope.exceptionCritical = data[i].value; 
					break;
				case "ExceptionWarn":
					$scope.exceptionWarn = data[i].value; 
					break;
				case "ExceptionNormal":
					$scope.exceptionNormal = data[i].value; 
					break;
			}
		}         
	};
	
	function fnSetRealtimeGraph(data) {        	
		for (var i=0; i<data.length; i++) {
			switch (data[i].key) {
				case "ActiveService":
					if (realTimeActiveService != undefined) {
						realTimeActiveService.update(data[i].values);
					}   
					break;
				case "RealActiveService":
					if (realTimeActiveServiceEQ != undefined) {
						realTimeActiveServiceEQ.update(data[i].values);
					}        					
					break;
				case "ProcCpu":
					if (realTimeProcessCPU != undefined) {
						realTimeProcessCPU.update(data[i].values);
					}        					
					break;
				case "HeapUsed":
					if (realTimeHeapMemory != undefined) {
						realTimeHeapMemory.update(data[i].values);
					} 
					
					break;
				case "CompCpu":
					if (realTimeSystemCPUEQ != undefined) {
						realTimeSystemCPUEQ.update(data[i].values);
					}
					
					break;
				case "ConDBConnect":
					if (realTimeDbCounter != undefined) {
						realTimeDbCounter.update(data[i].values);
					}
					break;
				case "ActiveThreadList":
					if (realTimeActiveThreadList != undefined) {
						realTimeActiveThreadList.update(data[i].values);
					}
					break;					
			}
		}        	
	};
	
	function fnSetLoadtimeGraph(data) {
		for (var i=0; i<data.length; i++) {
			switch (data[i].key) {
				case "CurrentUser24":
					if (counterTodayCurrentUser != undefined) {
						counterTodayCurrentUser.update(data[i].values);
					}
					break;
				case "ServiceCount24":
					if (counterTodayTPS != undefined) {
						counterTodayTPS.update(data[i].values);
					} 
					break;
				case "VisitorCount24":
					if (counterTodayVisitor != undefined) {
						counterTodayVisitor.update(data[i].values);
					} 
					break;
			}
		}        	        
	};
	
	function fnSetXlogData(data) {
		if (realTimeXlog != undefined) {
			realTimeXlog.update(/*$('#autoAxisY').is(':checked'), $('#normalFilter').is(':checked'), $('#errorFilter').is(':checked'), */data);
		} 
	};
	
	function fnReloadXlogData(data) {
		if (realTimeXlog != undefined) {
			realTimeXlog.reload();
		} 
	};
	
	function fnSetSpeedBar(data) {
		if (realTimeSpeedBar != undefined) {
			realTimeSpeedBar.update(data);
		} 
	};
	
	function fnSetGroupStatus(data) {
		for (var i=0; i<data.groupResults.length; i++) {
			for (var j=0; j<$rootScope.allAgent.length; j++) {
				if (data.groupResults[i].nodeGroupId == $rootScope.allAgent[j].nodeGroupId) {
					$rootScope.allAgent[j].nodeStatus = data.groupResults[i].nodeStatus; 
				}
			};
		}
	};
	
// ===============================================================================
// rest controller <--
// ===============================================================================

// ===============================================================================
// functions -->
// ===============================================================================
	
	//단절된 노드
	$scope.disconnectedNodeBtn = function (){
		$scope.openNodeConfigDialog();
	};
	
	function fnResizeDashboard() {
		//agentList 테이블 리사이즈
		var com1 = $(".box-content").height();
		var com2 = $(".box-header").height();
		var com3 = $("#com3").height();
		
		if (com3 > com1){
			com1 = com3;
		}
		$("#com3").css("height", (com1-com2-4) + "px");
		  
		if ($scope.dashboard.widgets == undefined) { return; }
		if ($scope.dashboard.widgets.length > 0) {
			for (var i=0; i<$scope.dashboard.widgets.length; i++) {
				if ($scope.dashboard.widgets[i].component != null) {
					$scope.dashboard.widgets[i].component.resize();
				}
			}
		};
	};
	
	function fnRemoveDashboard() {	
		if (realTimeSpeedBar != undefined) { 
			realTimeSpeedBar.remove();
		};
		
		if ($scope.dashboard.widgets == undefined) { return; }
		if ($scope.dashboard.widgets.length > 0) {
			for (var i=0; i<$scope.dashboard.widgets.length; i++) {
				if ($scope.dashboard.widgets[i].component != null) {
					$scope.dashboard.widgets[i].component.remove();
				}
			}
		}
		$scope.dashboard = {};
	};
	
	function fnCreateDashboard() {
		realTimeSpeedBar = new RealTimeSpeedBar("speedBar", $scope, $rootScope, $interval, Data, 0);
		
		$scope.dashboard = angular.copy($rootScope.myDashboards[myDashboardId]) ; //create Dom
		$scope.widgetCount = $scope.dashboard.widgets.length;
		$scope.dashboard.widgets = fnCreateWidgets($scope.dashboard.widgets);
		
		$scope.$watch('dashboard.widgets', function(items) {
			var tempWidgets = [];
			for (var i=0; i<items.length; i++) {
				tempWidgets[i] = {
					id: items[i].id,
					elementId:items[i].elementId,
					col: items[i].col,
					row: items[i].row,
					sizeX: items[i].sizeX,
					sizeY: items[i].sizeY,
					type: items[i].type,
				}
			};		
			
			tempWidgets = objSorting("row", tempWidgets);
			
			$rootScope.myDashboards[myDashboardId].widgets = tempWidgets;
			StorageManager.setMyDashboards($rootScope.myDashboards);
		}, true);
	};
	
	function objSorting(sortingField, items) {
		items.sort(function (a, b) {
			return a[sortingField] - b[sortingField];
		});
		return items;
	};
	
	
	function fnCreateWidgets(widgets) {		
		var tempWidgets = [];
		for (var i=0; i<widgets.length; i++) {
			var tempWidget = angular.copy(widgets[i]);
			var widgetInfo = WidgetInfoManager.getWidgetInfo(tempWidget.id);
		
			tempWidget.elementId = "id_"+ myDashboardId + "_" + i;
			tempWidget.title = widgetInfo.title;
			tempWidget.tooltip = widgetInfo.tooltip;
			tempWidget.type = widgetInfo.type;
	        if (tempWidget.type == "RealTimeActiveService") { 
	        	tempWidget.component = 
	        		new RealTimeActiveService(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	realTimeActiveService = tempWidget.component;	        	
	        } else if (tempWidget.type == "RealTimeActiveServiceEQ") { 
	        	tempWidget.component = 
	        		new RealTimeActiveServiceEQ(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	realTimeActiveServiceEQ = tempWidget.component;
	        } else if (tempWidget.type == "RealTimeXlog") { 
	        	tempWidget.component = 
	        		new RealTimeXlog(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	realTimeXlog = tempWidget.component;
	        } else if (tempWidget.type == "RealTimeProcessCPU") { 
	        	tempWidget.component = 
	        		new RealTimeProcessCPU(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	realTimeProcessCPU = tempWidget.component;
	        } else if (tempWidget.type == "RealTimeSystemCPUEQ") { 
	        	tempWidget.component = 
	        		new RealTimeSystemCPUEQ(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	realTimeSystemCPUEQ = tempWidget.component;
	        } else if (tempWidget.type == "RealTimeHeapMemory") { 
	        	tempWidget.component = 
	        		new RealTimeHeapMemory(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	realTimeHeapMemory = tempWidget.component;
	        } else if (tempWidget.type == "CounterTodayTPS") { 
	        	tempWidget.component = 
	        		new CounterTodayTPS(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	counterTodayTPS = tempWidget.component;
	        } else if (tempWidget.type == "RealTimeActiveThreadList") {  
	        	tempWidget.component = 
	        		new RealTimeActiveThreadList(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	realTimeActiveThreadList = tempWidget.component;
	        } else if (tempWidget.type == "CounterTodayVisitor") { 
	        	tempWidget.component = 
	        		new CounterTodayVisitor(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	counterTodayVisitor = tempWidget.component;
	        } else if (tempWidget.type == "CounterTodayCurrentUser") { 
	        	tempWidget.component = 
	        		new CounterTodayCurrentUser(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	counterTodayCurrentUser = tempWidget.component;	        
	        } else if (tempWidget.type == "RealTimeDBCounter") { 
	        	tempWidget.component = 
	        		new RealTimeDBCounter(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	realTimeDbCounter = tempWidget.component;	        
	        };

	        tempWidgets.push(tempWidget);
		}
		return tempWidgets;
	};

	$scope.$watch("isSlickAutoMove", function(newVal, oldVal) {
	   	if (newVal !== oldVal) { 
	   		if (newVal) {
	   			
	   		} else {
	   		/*	$timeout(function() {
	   				$("#groupList").slick({
	   					infinite:false,
	   					variableWidth: true,
	   					slidesToScroll:5
	   				});
	   				
	   			}, 1000);*/
	   			
	   			var slider = $("#groupList");
        		slider[0].slick.reinit();
	   		}
		};
    });
	
	$scope.toggleSetting = function() {
		$scope.config.setting = !$scope.config.setting;
		$scope.config.visible = !$scope.config.setting;
		if ($scope.config.visible) {
			//grid 패널이 하단 버튼을 덮는 문제로 리로드 필요함.!
			$route.reload();
		}else{
			fnChartReset();
			fnStopInterval();
			
		};
	};
	
	$scope.selectGroup = function (group) {		
		if ($rootScope.selectedGroup.id == group.nodeGroupId) { return; }

		if (group.serverList.length==0) { 
			alert('하위 에이전트가 없습니다.');
			return; 
		}
		
		fnStopInterval();
		
		fnChartReset();
		//XLog 과거 데이터 가져오기 위한 서버시간 초기화
		uxid = (new Date()).getTime();      	
		
		var obj = {id: group.nodeGroupId, name: group.nodeGroupNm};
		var selectedGroup = obj;
		selectedGroup.selectedAgent = [];
			
		for (var i=0; i<group.serverList.length; i++) {
			var server =  group.serverList[i];
			for (var j=0; j<server.nodeList.length; j++) {
				var node = server.nodeList[j];				
				selectedGroup.selectedAgent.push({id:node.nodeId, name:node.nodeNm, svrId:node.svrId});
			}
		};
		
		StorageManager.clearSelectedGroup();
		StorageManager.setSelectedGroup(selectedGroup);
		$rootScope.selectedGroup = StorageManager.getSelectedGroup();
		
		/********** ivh tree needs **********/
		$rootScope.ivhGroupFlag = true;
		$rootScope.ivhGroupSelected = group;
		/********** // ivh tree needs **********/
		
		$rootScope.xlogYMax = StorageManager.getXlogYMax($rootScope.selectedGroup);
		fnReloadXlogData();
		fnResetWorker();
    	
    };
    
    function fnChartReset(){
    	//chart reset
		if (realTimeActiveService != undefined) {
			realTimeActiveService.reset();
		}
		
		if (realTimeProcessCPU != undefined) {
			realTimeProcessCPU.reset();
		}
		
		if (realTimeHeapMemory != undefined) {
			realTimeHeapMemory.reset();
		}
		
		if (realTimeActiveThreadList != undefined) {
			realTimeActiveThreadList.reset();
		}
		
		if (counterTodayCurrentUser != undefined) {
			counterTodayCurrentUser.reset();
		}
		
		if (counterTodayTPS != undefined) {
			counterTodayTPS.reset();
		}
		
		if (counterTodayVisitor != undefined) {
			counterTodayVisitor.reset();
		}
		
		if (realTimeDbCounter != undefined) {
			realTimeDbCounter.reset();
		}
		
		if (realTimeActiveServiceEQ != undefined) {
			realTimeActiveServiceEQ.reset();
		}  
		
		if (realTimeSystemCPUEQ != undefined) {
			realTimeSystemCPUEQ.reset();
		}
		
		if (realTimeSpeedBar != undefined) {
			realTimeSpeedBar.reset();
		}
    };
    
    function fnResetWorker() {
    	fnStopInterval();
		$('#RealTimeActiveService').show();
    	$('#RealTimeActiveServiceEQ').show();
    	$('#RealTimeXlog').show();
    	$('#RealTimeProcessCPU').show();
    	$('#RealTimeSystemCPUEQ').show();
    	$('#RealTimeHeapMemory').show();
    	$('#CounterTodayTPS').show();
    	$('#CounterTodayTPS').show();
    	$('#RealTimeActiveThreadList').show();
    	$('#CounterTodayVisitor').show();
    	$('#CounterTodayCurrentUser').show();
    	$('#RealTimeDBCounter').show();
    	realTimeActiveThreadList.reset();
		fnStartCollectInterval();
		fnStartLoadDataInterval();
    };
    
    
    

// ===============================================================================
// functions <--
// ===============================================================================
//===============================================================================
// Modal, Popup -->
//===============================================================================
    $scope.openMenu = function($mdOpenMenu, ev) {
        var originatorEv = ev;
        $mdOpenMenu(ev);
    };

    function nvl(s) {
		 return (s==null || s=='null') ? '' : s;
	}
    
    $scope.openPopup = function(type, num) {
    	var popupX = (window.screen.width/2) - (1280/2);
    	var popupY = (window.screen.height/2) - (720/2);
    	var widgetType = type;
    	if (widgetType == "RealTimeXlog") {
    		popupY = (window.screen.height/2) - (800/2);
    		fnOpenXLogPopup(popupX, popupY);      	
    	} else if (widgetType == "RealTimeActiveService") {
    		fnOpenActiveServicePopup(popupX, popupY); 
    	} else if (widgetType == "RealTimeProcessCPU") {
    		fnOpenProcessCPUPopup(popupX, popupY); 
    	} else if (widgetType == "RealTimeHeapMemory") {
    		fnOpenHeapMemoryPopup(popupX, popupY); 
    	} else if (widgetType == "RealTimeDBCounter") {
    		fnOpenDBCounterPopup(popupX, popupY); 
    	} else if (widgetType == "ErrorLarge") {
    		fnOpenErrorPopup(num, popupX, popupY); 
    	} else if (widgetType == "RealTimeActiveThreadList") {
    		$scope.openActiveThreadListDialog($rootScope.selectedAgentIds.toString(',')); 
    	};
    };
    
    function fnOpenXLogPopup(popupX, popupY) {
    	window.selectedGroupId = $rootScope.selectedGroup.id;
        window.open(serviceBase + "popup.html#/xlog_large", "popup_xlog", "width=1280, height=800, left="+popupX+", top="+popupY);
    };
    
    function fnOpenActiveServicePopup(popupX, popupY) {
        window.open(serviceBase + "popup.html#/activeservice_large", "popup_active_service", "width=1280, height=720,left="+popupX+", top="+popupY);
    };
    
    function fnOpenProcessCPUPopup(popupX, popupY) {
        window.open(serviceBase + "popup.html#/processcpu_large", "popup_process_cpu", "width=1280, height=720, left="+popupX+", top="+popupY);
    };
    
    function fnOpenHeapMemoryPopup(popupX, popupY) {
        window.open(serviceBase + "popup.html#/heapmemory_large", "popup_heap_memory", "width=1280, height=720, left="+popupX+", top="+popupY);
    };
    
    function fnOpenDBCounterPopup(popupX, popupY) {
        window.open(serviceBase + "popup.html#/dbcounter_large", "popup_db_counter", "width=1280, height=720, left="+popupX+", top="+popupY);
    };
    
    function fnOpenErrorPopup(num, popupX, popupY) {
        window.open(serviceBase + "popup.html#/error_large/"+num, "popup_error", "width=1280, height=720, left="+popupX+", top="+popupY);
    };
    
//===============================================================================
// <-- Modal, Popup
//===============================================================================
//===============================================================================
// Agent List -->
//===============================================================================
    $scope.openAgentList = function() {
    	//서버연동 일시중지
        $mdDialog.show({
            controller: $scope.agentListController,
            templateUrl: 'views/modal/agentList.html',
            parent: angular.element(document.getElementById("wrap")),
            targetEvent: event,
            clickOutsideToClose:true,
        }).then(function(selectedGroup) {
            	StorageManager.clearSelectedGroup();
        		StorageManager.setSelectedGroup(selectedGroup);
        		$rootScope.selectedGroup = StorageManager.getSelectedGroup();    		
        		fnResetWorker();
        		fnReloadXlogData();
        	//};        
        }, function() {
            //$scope.status = "cancel";
        });
    };
    
    $scope.agentListController = function($scope, $rootScope, $timeout, $mdDialog, StorageManager, ivhTreeviewBfs, ivhTreeviewMgr) {    	
    	$scope.agentTreeCreated = false;
	    $scope.agentTree = undefined;	    
	    $scope.selectedGroupNode = {};
	    $scope.selectedGroup = $rootScope.selectedGroup;	    
	    
	    $scope.instanceName = "";
		$scope.applicationVersion = "";
		$scope.javaVersion = "";
		$scope.serverVersion = "";
		$scope.hostName = "";
		$scope.serverName = "";
		$scope.serviceName = "";
		$scope.expirationDate = "";
		$scope.nodeStatus = "";
				
		/********** ivh tree **********/
		// ivh tree 에서 사용할 수 있는 형태로 데이터 재가공 (= 공통 사용 위해 ivh-treeview.js 에 함수 정의 replaceTreeData )		
		if (typeof $rootScope.ivhTreeData !== "undefined") {
			$scope.treeData = $rootScope.ivhTreeData;
		} else {
			// 최초 한번만 기본 트리 데이터 생성
			$scope.treeData = ivhTreeviewMgr.replaceTreeData(StorageManager.getAllAgent(), $rootScope.selectedGroup.id);			
		}
		
	    $scope.agentTree = $scope.treeData;
	    /**
	     * Agent 선택 후 조회 or 상단 바에서 Agent그룹을 선택한경우 실행 함수
	     */
	    $scope.changeCallback = function(ivhNode, ivhTree) {
			var execFlag = false;				
			for (var i = 0; i < ivhTree.length; i++) {			
				if (ivhNode.nodeGroupId == ivhTree[i].nodeGroupId && !execFlag) {					
					// 현재 선택된 그룹					
					if ($rootScope.ivhGroupFlag) {
						// groupList Bar 에서 그룹을 선택한 경우에만 실행
						ivhTreeviewMgr.select(ivhTree, ivhTree[i]);						
					}
					$scope.ivhLastGroupIndex = i;
					execFlag = true;						
				} else {
					// 현재 선택된 그룹이 아니면 un select
					ivhTreeviewMgr.deselect(ivhTree, ivhTree[i]);
				}					
			}
		
			$scope.treeData = ivhTree; // 트리 데이터 갱신
			$rootScope.ivhTreeData = ivhTree;
			$scope.getSelectedNodes(ivhTree);		    
		};
		
		/**
		 * 포맷에 맞게 조회 시 데이터를 넘겨주기위해 선택된 노드 가공 ($scope.selectedGroup)
		 */
		$scope.getSelectedNodes = function(tree) {
			var nodesToSelect = [], done = false;

			ivhTreeviewBfs(tree, function(node) {
				if (done) {
					return false;
				}				
				if (!node.children) {
					if (node.selected) {
						nodesToSelect.push(node);
					}				
				}				
				return !done;
			});
			// select
			var ivhSelectedAgent = {};	
			if (nodesToSelect.length > 0) {				
				ivhSelectedAgent = {id:nodesToSelect[0].nodeGroupId, name:nodesToSelect[0].agentGroupNm, selectedAgent:nodesToSelect};				
			}

			$scope.selectedGroup = ivhSelectedAgent;			
		}
		
		if ($rootScope.ivhGroupFlag) {
			// groupList Bar 에서 그룹을 선택한 경우 Tree Select 변경
			$scope.changeCallback($rootScope.ivhGroupSelected, $scope.treeData);
			$rootScope.ivhGroupFlag = false;
		}		
	    /********** //ivh tree **********/
		
    	$(document).ready(function(){
            $(".agent-list-box").mCustomScrollbar();
                        
    	});
    	    	
    	
    	$scope.selectAgent = function(node) {
        	var currentSelected = node.data.selected;
    		if (!currentSelected) {    			
    			if (node.depth == 1) {
    				//그룹선택    				
    				$scope.unSelectAll();
    				$scope.selectedGroupNode = node;
    				
    			} else if (node.depth == 2) {
    				//호스트 선택   
    				if (Object.keys($scope.selectedGroupNode).length === 0) {
        				//선택된 그룹이 없다.
    					$scope.selectedGroupNode = node.parent;
    					$scope.agentTree.select(node.parent.index);
    				} else {
    					if (node.parent.data.id == $scope.selectedGroupNode.data.id) {
        					//같은 그룹 내에서 선택
        					if (!node.parent.data.selected) {
        						$scope.agentTree.select(node.parent.index);	
        					};
        					
        				} else {
        					//다른 그룹 선택    					
        					$scope.unSelectAll();
        					$scope.selectedGroupNode = node.parent;
        					$scope.agentTree.select(node.parent.index);
        				};	
    				};
    				
    			} else {    				
    				//에이전트 선택    				
    				//선택된 그룹이 없다.
    				if (Object.keys($scope.selectedGroupNode).length === 0) {
        				//선택된 그룹이 없다.
    					$scope.selectedGroupNode = node.parent.parent;
    					$scope.agentTree.select(node.parent.parent.index);
    					$scope.agentTree.select(node.parent.index);
    				} else if (node.depth == 3) {
    					if (node.parent.parent.data.id == $scope.selectedGroupNode.data.id) {
        					//같은 그룹 내에서 선택
        					if (!node.parent.parent.data.selected) {
        						$scope.agentTree.select(node.parent.parent.index);	
        					};
        					
        					if (!node.parent.data.selected) {
        						$scope.agentTree.select(node.parent.index);	
        					};
        					
        				} else {
        					//다른 그룹 선택
        					$scope.unSelectAll();
        					$scope.selectedGroupNode = node.parent.parent;					
        					$scope.agentTree.select(node.parent.parent.index);
        					$scope.agentTree.select(node.parent.index);
        				};	
    				};
    			};
    			
    			$scope.agentTree.select(node.index); 
    			
    			if (node.children.length > 0) {    			
        			for (var i=0; i<node.children.length; i++) {
        				$scope.selectChild(node.children[i]);	
            		}    					
        		};
    		};
    	};
    	
    	$scope.unSelectAgent = function(node) {
    		var currentSelected = node.data.selected;
    		if (currentSelected) {
    			if (node.depth == 1) {
    				//그룹 선택 해제
    				$scope.selectedGroupNode = {};
    			} else if (node.depth == 2) {
    				//호스트 선택 해제
    				//다른 선택된 호스트가 그룹내에 있는지 체크
    				var check = false;
    				for (var i=0; i<node.parent.children.length; i++) {
    					if (node.parent.children[i].data.selected && node.parent.children[i].data.id != node.data.id) {
    						//다른 선택된 호스트가 있음.
    						check = true;
    					}
    				};
    				
    				if (!check) {
    					//그룹 선택 해제
    					$scope.agentTree.select(node.parent.index);
        				$scope.selectedGroupNode = {};
    				};
    				
    			} else if (node.depth == 3) {
    				//에이전트 선택 해제
    				//다른 선택된 에이전트가 호스트에 있는지 체크
    				var check = false;
    				for (var i=0; i<node.parent.children.length; i++) {
    					if (node.parent.children[i].data.selected && node.parent.children[i].data.id != node.data.id) {
    						//다른 선택된 호스트가 있음.
    						check = true;
    					}
    				}; 
    				
    				if (!check) {
    					//호스트 선택 해제
    					$scope.agentTree.select(node.parent.index);
    					
    					//다른 선택된 호스트가 그룹내에 있는지 체크
    					check = false;
    					for (var i=0; i<node.parent.parent.children.length; i++) {
        					if (node.parent.parent.children[i].data.selected && node.parent.parent.children[i].data.id != node.parent.data.id) {
        						//다른 선택된 호스트가 있음.
        						check = true;
        					}
        				}; 
        				
        				if (!check) {
        					//그룹 선택 해제
        					$scope.agentTree.select(node.parent.parent.index);
            				$scope.selectedGroupNode = {};
        				};
    				};
    			};
    			
    			$scope.agentTree.select(node.index);
    			
    			//unselect child
    			if (node.children.length > 0) {    			
        			for (var i=0; i<node.children.length; i++) {
        				$scope.unSelectChild(node.children[i]);	
            		}    					
        		}; 
    		};
    	};
    	
    	$scope.selectChild = function(node) {
    		var currentSelected = node.data.selected;
    		if (!currentSelected) {
    			$scope.agentTree.select(node.index);    			
    		};
    		if (node.children.length > 0) {    			
    			for (var i=0; i<node.children.length; i++) {
    				$scope.selectChild(node.children[i]);	
        		}    					
    		};
    	};
    	
    	$scope.unSelectChild = function(node) {
    		var currentSelected = node.data.selected;
    		if (currentSelected) {
    			$scope.agentTree.select(node.index);    			
    		};
    		if (node.children.length > 0) {    			
    			for (var i=0; i<node.children.length; i++) {
    				$scope.unSelectChild(node.children[i]);	
        		}    					
    		};
    	};
        
    	$scope.changedSelectAgent = function() {
    		$scope.selectedGroup = {};
    	    $scope.selectedGroup.selectedAgent = [];
    		
    		var treeList = $scope.agentTree.listAll();    		
    		for (var i=0; i<treeList.length; i++) {
    			var node = treeList[i];    			    		
    			
    			if (node.data.selected == true) {
    				//var obj = {index: node.index, title: node.data.title, depth: node.depth, nodeId: node.data.id};
    				var obj = {id: node.data.id, name: node.data.title};
    				
    				if (node.depth == 1) {    					 					
    					$scope.selectedGroup = obj;
    					$scope.selectedGroup.selectedAgent = [];
    				}
    				
    				if (node.depth == 3) {
    					obj.svrId = node.data.obj.svrId;
    					$scope.selectedGroup.selectedAgent.push(obj);
    				}    				
    			};
    		};
    		
    	};
    	
    	$scope.selectAll = function () {
        	var root = $scope.agentTree.get("0").parent;
        	$scope.selectChild(root);
        	$scope.changedSelectAgent();
        };
        
        $scope.unSelectAll = function () {
        	var root = $scope.agentTree.get("0").parent;
        	$scope.unSelectChild(root);
        	$scope.changedSelectAgent();
        };
        
    	$scope.showAgentDetail = function(node) { 
    		$timeout(function() {
    			$scope.instanceName = node.data.obj.nodeNm;
    			$scope.applicationVersion = node.data.obj.appVer;
    			$scope.javaVersion = node.data.obj.javaVer;
    			$scope.serverVersion = node.data.obj.svrVer;
    			$scope.hostName = node.data.obj.hostNm;
    			$scope.serverName = node.data.obj.svrNm;
    			$scope.serviceName = node.data.obj.serviceNm;
    			$scope.expirationDate = node.data.obj.expirationDt;
    			$scope.nodeStatus = node.data.obj.nodeStts;

    			//angular rendering 오류 때문에 적용
    			$scope.$apply();
			}, 200);
    	};
    	
		$scope.answer = function() { 			
			if (Object.keys($scope.selectedGroup).length === 0) {
				alert('그룹이 선택되지 않았습니다.');
			} else {
				if ($scope.selectedGroup.selectedAgent.length==0) {
					alert('에이전트가 선택되지 않았습니다.');
				} else {
					$mdDialog.hide($scope.selectedGroup);		
				};
			};
	    };
       
        $scope.cancel = function() {
        	$mdDialog.cancel();
        };

    };
//===============================================================================
// <-- Agent List
//===============================================================================
//===============================================================================
// XLog Profile -->
//===============================================================================
    $scope.openXLogProfile = function(selectedData) {
    	var width=1280;
    	var height=800;
    	var left = (window.screen.width/2) - (width/2);
    	var top = (window.screen.height/2) - (height/2);
    	window.selectedData=selectedData;
    	window.userInfo=$scope.userInfo;
    	window.selectedAgentIds=$rootScope.selectedAgentIds;
    	window.xlogYMax=$rootScope.xlogYMax;
    		
       	window.normalFilter=$('#normalFilter').is(':checked');
       	window.errorFilter=$('#errorFilter').is(':checked');
    	
        window.open(serviceBase + "popup.html#/xlog_real", "xlog_real", "width="+width+", height="+height+", left="+left+", top="+top);
    };
    
    
 //===============================================================================
 // XLogChartOpt Dialog -->
 //===============================================================================
     $scope.openXLogChartOpt = function(type) {
     	var widgetType = type;
     	var param = {
     			widgetType : widgetType
             }
     	$mdDialog.show({
             controller: $scope.XLogChartOptController,
             templateUrl: 'views/modal/XLogChartOpt.html',
             parent: angular.element(document.getElementById("wrap")),
             targetEvent: event,
             clickOutsideToClose:true,
             locals : {
             	param : param
             }
         }).then(function(ret) {
        	 fnReloadXlogData();
        	 uxid = (new Date()).getTime();
         }, function(XLogChartOpt) {
         	$mdDialog.cancel();
         });
     };
     
     $scope.triggerXlog = function(typ) {
    	 if(typ==1||typ==2){
	    	 $scope.normalFilter=$('#normalFilter').is(':checked');
	    	 $scope.errorFilter=$('#errorFilter').is(':checked');
    	 } else {
    		 $scope.autoAxisY=$('#autoAxisY').is(':checked');
    	 }
     };

	$scope.XLogChartOptController = function($scope, $mdDialog, Data, param) {
     	$(document).ready(function(){
        	$(".list-box").mCustomScrollbar();
        	$scope.init();
     	});
     	
     	
     	$scope.init = function() {
     		
          	var grp=StorageManager.getSelectedGroup();
          	$scope.xlogYMax=StorageManager.getXlogYMax(grp);
          	$scope.axisYSelectedIndex = 10000;
          	
          	$scope.formData = [{id:0, val:5000, name: "5초"},{id:1, val:10000, name: "10초"},
          						{id:2,val:15000, name: "15초"},{id:3,val:20000, name: "20초"},
          						{id:4,val:30000, name: "30초"}, {id:5,val:60000, name: "60초"},
          						{id:6,val:150000, name: "150초"}];
          	
          	if ($scope.xlogYMax == null || $scope.xlogYMax == undefined){
          		$scope.xlogYMax = 10000;
          	}
          	
          	for(var i = 0; i<$scope.formData.length; i++){
          		if ($scope.xlogYMax == $scope.formData[i].val){
          			$scope.axisYSelectedIndex = $scope.formData[i].id;
          			break;
          		}
          	}
          	if ($scope.axisYSelectedIndex > 4){
          		$(".list-box").mCustomScrollbar("scrollTo", 300);
          	}
         };
         
         $scope.cancel = function() {
         	$mdDialog.cancel();
         };
         
         $scope.save = function() {        	
          	var grp=StorageManager.getSelectedGroup();
         	StorageManager.setXlogYMax(grp, $scope.formData[$scope.axisYSelectedIndex].val);
         	
         	if($rootScope.xlogYMax == $scope.formData[$scope.axisYSelectedIndex].val){
         		$mdDialog.cancel();
         	}
         	$rootScope.xlogYMax=$scope.formData[$scope.axisYSelectedIndex].val;
         	$mdDialog.hide("ok");	
         };
     }; //XLogChartOptController
     
 //===============================================================================
 // <-- XLogChartOpt Dialog
 //===============================================================================    
    
//===============================================================================
// Date Dialog -->
//===============================================================================
    $scope.openDateDialog = function(type) {
    	var widgetType = type;
    	var param = {
    			widgetType : widgetType,
            	currentUserLoadDate : $scope.datePicker.currentUserLoadDate,
            	serviceCallLoadDate : $scope.datePicker.serviceCallLoadDate,
            	visitorLoadDate : $scope.datePicker.visitorLoadDate
            }
    	$mdDialog.show({
            controller: $scope.dateDialogController,
            templateUrl: 'views/modal/dateDialog.html',
            parent: angular.element(document.getElementById("wrap")),
            targetEvent: event,
            clickOutsideToClose:true,
            locals : {
            	param : param
            }
        }).then(function() {
            //$scope.status = "success";
        }, function(date) {
        	
        	$mdDialog.cancel();
        	var temp = date.split('/');
        	var selectedDate = temp.join('');
        	//close modal
        	$('#CounterTodayCurrentUser').show();
        	$('#CounterTodayTPS').show();
        	$('#CounterTodayVisitor').show();
        	if (widgetType == "CounterTodayCurrentUser") {
        		$rootScope.loadDates.currentUserLoadDate = selectedDate;
        		$scope.datePicker.currentUserLoadDate = date;
        	} else if (widgetType == "CounterTodayTPS") {
        		$rootScope.loadDates.serviceCallLoadDate = selectedDate;
        		$scope.datePicker.serviceCallLoadDate = date;
        	} else if (widgetType == "CounterTodayVisitor") {
        		$rootScope.loadDates.visitorLoadDate = selectedDate;
        		$scope.datePicker.visitorLoadDate = date;
        	};
        	
        	fnResetWorker();
        });
    };
    

    $scope.dateDialogController = function($scope, $mdDialog, Data, param) {
    	//variables
        $scope.yesterday = function () {
        	var date = new Date();
        	date.setDate(date.getDate()-1);
        	var year = date.getFullYear();
        	var month = (1+date.getMonth());
        	month = month>=10? month:'0'+month;
        	var day = date.getDate();
        	day = day>=10? day:'0'+day;
        	return year + '/' + month + '/' + day;
        };
        
        $scope.prevWeek = function () {
        	var date = new Date();
        	date.setDate(date.getDate()-7);
        	var year = date.getFullYear();
        	var month = (1+date.getMonth());
        	month = month>=10? month:'0'+month;
        	var day = date.getDate();
        	day = day>=10? day:'0'+day;
        	return year + '/' + month + '/' + day;
        };
        
        $scope.prevMonth = function () {
        	var date = new Date();
        	date.setMonth(date.getMonth()-1);
        	var year = date.getFullYear();
        	var month = (1+date.getMonth());
        	month = month>=10? month:'0'+month;
        	var day = date.getDate();
        	day = day>=10? day:'0'+day;
        	return year + '/' + month + '/' + day;
        };
        
        $scope.tranDate = function (yyyymmdd) {
        	var date = new Date(yyyymmdd);
        	date.setMonth(date.getMonth()-1);
        	var year = date.getFullYear();
        	var month = (1+date.getMonth());
        	month = month>=10? month:'0'+month;
        	var day = date.getDate();
        	day = day>=10? day:'0'+day;
        	return year + '/' + month + '/' + day;
        };
    	
        $scope.selectedDate = "";
        if (param.widgetType == "CounterTodayCurrentUser") {
        	$scope.selectedDate = param.currentUserLoadDate;
    	} else if (param.widgetType == "CounterTodayTPS") {
    		$scope.selectedDate = param.serviceCallLoadDate;
    	} else if (param.widgetType == "CounterTodayVisitor") {
    		$scope.selectedDate = param.visitorLoadDate;
    	};
    	
        //$scope.selectedDate = $scope.yesterday();
    	//$scope.selectedType = "yesterday";
    	$scope.datePicker = undefined;

    	$(document).ready(function(){
        	$scope.init();
    	});
    	
        $scope.init = function() {
        	jui.ready(["ui.datepicker"], function(datepicker) {			
        		$scope.datePicker = datepicker("#datePicker", {
    	            titleFormat: "yyyy.MM",
    	            format: "yyyy/MM/dd",
    				event: {
    	            	select: function(item, data) {
    	            		$scope.selectedDate = item;
    	            	}
    	            },
    	            tpl: {
    	            	date: $("#tpl_date").html()
    	            }
    	        });
        		$scope.datePicker.select($scope.selectedDate);
    		});     
        };
        
        $scope.cancel = function() {
        	$mdDialog.cancel($scope.selectedDate);
        };
        
        $scope.onChoice = function() {        	
        	if ($scope.selectedType == "yesterday") {
        		$scope.selectedDate = $scope.yesterday();
        	} else if ($scope.selectedType == "lastweek") {
        		$scope.selectedDate = $scope.prevWeek();
        	} else if ($scope.selectedType == "lastmonth") {
        		$scope.selectedDate = $scope.prevMonth();
        	};
        	$scope.datePicker.select($scope.selectedDate);
        };
    }; //dateDialogController
    
//===============================================================================
// <-- Date Dialog
//===============================================================================    
  //===============================================================================
 // ActiveThreadListDialog -->
 //===============================================================================
 	//에이전트 스레드 상세 데이터
 	$scope.openActiveThreadListDialog = function(nodeId) {
 		var params = {
 				oid: nodeId
 		}
		if($scope.openActiveThreadListDialogCnt){
			return;
		}
 		$scope.openActiveThreadListDialogCnt=1;
 		Data.ajax({url:'dashBoard/activeThreadList', param:params, successCallback:function(data, status) {
			if(data) {
				$mdDialog.show({
					controller: $scope.activeThreadListDialogController,
					templateUrl: 'views/modal/activeThreadListDialog.html',
					parent: angular.element(document.getElementById("wrap")),
					targetEvent: event,
					clickOutsideToClose:true,
					locals : {
						userInfo : $scope.userInfo,
						threadList : data
					}
				}).then(function() {
					$scope.openActiveThreadListDialogCnt=0;
     	        }, function() {
     	        	$scope.openActiveThreadListDialogCnt=0;
     	        	$mdDialog.cancel();
     	        });
			}
 		}});
 	};

 	$scope.activeThreadListDialogController = function($scope, $mdDialog, $timeout, Common, Data, threadList) {
 		//variables
 		$scope.threadList = threadList;
		$(document).ready(function() {
			$scope.init();
      	});
 		$scope.init = function() {    
 			jui.ready([ "grid.xtable" ], function(juiXTable) {
            	$scope.profileList = juiXTable("#profileListXtable", {
                    data:$scope.threadList,
                    event: {
		            	 select: function(row, e) {
//		            		if ($(row.element).hasClass("selected")) {
//		            			//this.unselect(row.index);
//		            		} else {
//		            			this.select(row.index);
//		            			$scope.getProfileText(row, e);
//		            			$scope.getTopologyData(row, e);
//		            		};	            			            		              	
		            	 }
	                 },
                    tpl: {
                        row: angular.element("#tpl_row_thread").html(),
		                none: angular.element("#tpl_none_thread").html(),
		                loading: angular.element("#tpl_loading").html()                        
                    },
                    resize: true,
                    sort: true,
                    fields: ["objName", "serviceName", "elapsed"],                    
                    buffer: "scroll",
                    bufferCount: 20,
                    scrollHeight: 220
                });
            });
 		};
 		
 		
 		$scope.cancel = function() { 
 			$mdDialog.cancel();
 		};
 	}; //activeThreadListDialogController
 	
 	//에이전트 스레드 상세 데이터2
 	$scope.openCpuThreadListDialog = function(nodeId) {
 		var spNodeId = nodeId.split('_')[1];
 		
 		var processParams = {tabName:"hostProcessTab", nodeId: spNodeId};
		if($scope.openActiveThreadListDialogCnt){
			return;
		}
 		$scope.openActiveThreadListDialogCnt=1;
 		
 		$scope.processListData = [];
 		
 		var processParams = {tabName:"hostProcessTab", nodeId: spNodeId};
 		Data.ajax({url:'performance/performance', param:processParams, successCallback:function(data, status) {
			if(data) {
				if (data.processInfo == undefined){
					$scope.openActiveThreadListDialogCnt=0;
					return;
				}
				if (data.processInfo.length > 0) {
					for (var i=0; i< data.processInfo.length; i++) {
	     				var obj = data.processInfo[i];
	     				obj.no = i + 1;
	     				obj.sPid = nvl(data.processInfo[i].sPid);
	     				obj.sUser = nvl(data.processInfo[i].sUser);
	     				obj.sCpu = nvl(data.processInfo[i].sCpu);
	     				obj.sMem = nvl(data.processInfo[i].sMem);
	     				obj.sTime = nvl(data.processInfo[i].sTime);
	     				obj.sName = nvl(data.processInfo[i].sName);
	    				
	     				$scope.processListData.push(obj);
	     			}
				}
				
				$mdDialog.show({
					controller: $scope.cpuThreadListDialogController,
					templateUrl: 'views/modal/openThreadListDialog.html',
					parent: angular.element(document.getElementById("wrap")),
					targetEvent: event,
					clickOutsideToClose:true,
					locals : {
						userInfo : $scope.userInfo,
						threadList : $scope.processListData
					}
				}).then(function() {
					$scope.openActiveThreadListDialogCnt=0;
     	        }, function() {
     	        	$scope.openActiveThreadListDialogCnt=0;
     	        	$mdDialog.cancel();
     	        });
			}
 		}});
 	};

 	$scope.cpuThreadListDialogController = function($scope, $mdDialog, $timeout, Common, Data, threadList) {
 		//variables
 		$scope.threadList = threadList;
 		$(document).ready(function() {
			$timeout(function() {
				$scope.init()
			}, 200);
      	});
 		$scope.init = function() {    
 			jui.ready([ "grid.xtable" ], function(juiXTable) {
            	$scope.profileList = juiXTable("#profileListXtable", {
                    data:$scope.threadList,
                    event: {
		            	 select: function(row, e) {
		            	 }
	                 },
                    tpl: {
                        row: angular.element("#tpl_row_thread").html(),
		                none: angular.element("#tpl_none_thread").html(),
		                loading: angular.element("#tpl_loading").html()                        
                    },
                    resize: true,
                    sort: true,
                    fields: ["no", "name", "stat", "cpu", "txid", "elapsed", "service"],                    
                    buffer: "scroll",
                    bufferCount: 20,
                    scrollHeight: 220
                });
            });
 		};
 		
 		
 		$scope.cancel = function() { 
 			$mdDialog.cancel();
 		};
 	};
 	
  //===============================================================================
  // <-- ActiveThreadListDialog
  //===============================================================================

//===============================================================================
// ActiveThreadDialog -->
//===============================================================================
    
    //단절된노드
    $scope.openNodeConfigDialog = function() {
    	$mdDialog.show({
            controller: $scope.openConfigNodeDialogController,
            templateUrl: 'views/modal/disconnectedNode.html',
            parent: angular.element(document.getElementById("wrap")),
            targetEvent: event,
            clickOutsideToClose:true,  
            locals : {
            	selectedData : ""
            }
        }).then(function() {

        }, function() {
        	//close modal
        });
    };
    
    
    
    $scope.disConnectedNodeList = [];
    $scope.openConfigNodeDialogController = function($scope, $mdDialog, $timeout, Data, selectedData) {
    	
		Data.ajax({url:'dashBoard/disconnectedAgentList', param:"", successCallback:function(data, status) {
    		try {
    			if(data) {
                    $scope.disConnectedNodeList = data.resultList;
    			}
    		} catch(ex) {}
    	}});
		
    	$(document).ready(function(){
//    		$(".list-box").mCustomScrollbar();
    	});
    	
        $scope.init = function() {
        };
        $scope.answer = function(){
        };
        
        $scope.cancel = function() {
            $mdDialog.cancel();
        };
        
    };
    
	//에이전트 스레드 상세 데이터
	$scope.openActiveThreadDialog = function(parmData) {
		var params = {
				nodeId: parmData[0].data.objHash, 
				threadId: parmData[0].data.id,
				txId: parmData[0].data.txid,
				elapsed : Math.round(parmData[0].data.elapsed)
		}
    	
		Data.ajax({url:'dashBoard/runTimeProfileText', param:params, successCallback:function(data, status) {
			$scope.agentThreadDtlData = [];
			try {
				if(data) {
					if (data.result == '1') {
						 var selectedData = {
				 			blockedCount:data.threadDtlData.BlockedCount,
				 			blockedTime: data.threadDtlData.BlockedTime,
				 			lockName: data.threadDtlData.LockName,
				 			lockOwnerId: data.threadDtlData.LockOwnerId,
				 			lockOwnerName: data.threadDtlData.LockOwnerName,
				 			state: data.threadDtlData.State,
				 			threadCpuTime: data.threadDtlData.ThreadCpuTime,
				 			threadId: data.threadDtlData.ThreadId,
				 			threadName: data.threadDtlData.ThreadName,
				 			threadUserTime: data.threadDtlData.ThreadUserTime,
				 			waitedCount: data.threadDtlData.WaitedCount,
				 			waitedTime: data.threadDtlData.WaitedTime,
				 			stackTrace: data.threadDtlData.StackTrace,
				 			threadIdKey: params.threadId,
				 			nodeId: params.nodeId, 
				 			runTimeProfileText:data.threadDtlData.profileText
							};
						 
						
						$mdDialog.show({
							controller: $scope.activeThreadDialogController,
							templateUrl: 'views/modal/activeThreadDashBoardDialog.html',
							parent: angular.element(document.getElementById("wrap")),
							targetEvent: event,
							clickOutsideToClose:true,
							locals : {
								selectedData : selectedData
								, userInfo : $scope.userInfo
							}
						}).then(function(formData) {
		     	        	
		     	        }, function() {
		     	        	//close modal
		     	        });
						
					}
				}
			} catch(ex) {}
		}});
	};

	$scope.activeThreadDialogController = function($scope, $mdDialog, $timeout, Common, Data, selectedData, userInfo) {
		//variables
		$scope.userInfo = userInfo;
		
		$scope.formData = {};
    		
		$scope.formData = selectedData;
    	
		$scope.threadAction = 0;
		
		$(document).ready(function() {
			$(".list-box").mCustomScrollbar();
			$scope.init();
      	});
	      	
		$scope.init = function() {    

		};
		
		$scope.threadControlAction = function (action) {
			$scope.threadAction = 0;
	    	var agentId = $scope.formData.nodeId;
			if (agentId == ""){
				return;
			}
	    	
			if ($scope.currentThreadId < 1){
				return;
			}
			
			var threadId = $scope.formData.threadIdKey;
			
			if (threadId == ""){
				return;
			}
	    	
			if (action < 1 && action > 4){
				return;
			}
			
			var actionNm = "";
			
			if (action == 1){
				actionNm = "Interrupt";
				
			}else if (action == 2){
				actionNm = "Stop";
				
			}else if (action == 3){
				actionNm = "Suspend";
				
			}else if (action == 4){
				actionNm = "Resume";
				
			}
			
			if (actionNm != ""){
				Common.confirmDialog("알림", actionNm + "명령을 수행 하시겠습니까?", $scope.threadControlActionRun, $scope.cancel);
			}
	    	
			$scope.threadAction = action;
	    };
	    
		$scope.threadControlActionRun = function (agentId, threadId, action){
			var params = {nodeId: $scope.formData.nodeId, threadId: $scope.formData.threadIdKey, action: $scope.threadAction};
			
			Data.ajax({url:'performance/threadControlAction', param:params, successCallback:function(data, status) {
				try {
					if(data) {
			     		if (data.result == "1") {
			     			Common.alertDialog("알림", "Thread Control Success");
			     		}else{
			     			Common.alertDialog("오류", "Thread Control Fail");
			     		}
					}
				} catch(ex) {}
			}});
		}
		
		$scope.dumpActionBtnHandler = function(){
			var params = {nodeId: $scope.formData.nodeId, dumpAction: 3};
			
			Data.ajax({url:'performance/dumpAction', param:params, successCallback:function(data, status) {
				try {
					if(data) {
			     		if (data.result == "1") {
			     			Common.alertDialog("알림", "덤프가 성공적으로 처리 되었습니다.");
			     		}else{
			     			Common.alertDialog("오류", "덤프중 오류가 발생하였습니다.");
						}
					}
				} catch(ex) {}
			}});
		}
		
		
		$scope.cancel = function() {        	       	        
			$mdDialog.cancel();
		};
	}; //activeThreadDialogController
	
	$scope.eventDetailController = function($scope, $timeout, $mdDialog, item) {
		$scope.formData = {
   				userId : $rootScope.userInfo.userId, 
   				userNm : $rootScope.userInfo.userNm, 
   				deptNm : $rootScope.userInfo.deptNm, 
   				mobile : $rootScope.userInfo.mobile, 
   				eventDt : item.eventDt,
   	 			nodeId : item.nodeId,
   	 			eventId : item.eventId,
   	 			eventCheckDt : item.eventCheckDt,
   	 			nodeGroupNm : item.nodeGroupNm,
   	 			nodeNm : item.nodeNm
   			};
	   	 var itemObj = [];
	   	 itemObj.data = item;
	   	 $scope.item = itemObj;
	   	 $scope.cancel = function() {
	            $mdDialog.cancel();
	        };
	        $scope.answer = function() {      
	            $mdDialog.hide($scope.formData);
	        };
    };
    
 //===============================================================================
 // <-- ActiveThreadDialog
 //===============================================================================
    
});//controller