'use strict';
angular.module('mainApp').controller('DashBoardSettingCtrl', function ($window, $scope, $rootScope, $timeout, $log, Common, StorageManager, WidgetInfoManager, $location) {
	//variables
	var myDashboardId = 0;
	var isResize = false;
	
	$scope.config = {visible : false, setting: false};
	$scope.dashboard = {};
	
	$scope.gridsterOptions = {
		margins : [ 10, 10 ],
		columns : 9,
		rowHeight : 180
	};
	
	$(document).ready(function(){
        $("html").css("background-color", "#151b25");

        if ($rootScope.userInfo == undefined){        	
        	$scope.sessionCheck = true;
    		Common.alertDialog("알림", "세션 정보를 찾을수 없습니다. 다시 로그인 하세요.");
    		$location.path("/login");
    		return;
    	}else{
    		$scope.userTyp = $rootScope.userInfo.userTyp;
    	}
        
        if($scope.userTyp != "user"){
        	var html = '<a class="dropdown-button" data-activates="settings">구성관리<i class="material-icons right">arrow_drop_down</i></a>';
        	$("#settingsTag").html(html);
        }
        
        $(".dropdown-button").dropdown();
		
        $scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;
    	
    	createDashboard();
	});
	
	angular.element(window).on('resize', function(e) {
		if (isResize) { return;}
		isResize = true;
		
		$timeout(function() {
			isResize = false;
		}, 200)		
	});

	$scope.$on('gridster-resized', function(gridster, size) {		
		if (isResize) { return;}
		isResize = true;
		
		$timeout(function() {
			isResize = false;
		}, 200)
	});

	$scope.toggleSetting = function() {
		$location.path("/dashboard");
	};
	
	function createDashboard() {
		$scope.dashboard = angular.copy($rootScope.myDashboards[myDashboardId]) ; //create Dom
		$scope.dashboard.widgets = createWidgets($scope.dashboard.widgets);
		
		$scope.$watch('dashboard.widgets', function(items) {
			var tempWidgets = [];
			for (var i=0; i<items.length; i++) {
				tempWidgets[i] = {
					id: items[i].id,
					elementId:items[i].elementId,
					col: items[i].col,
					row: items[i].row,
					sizeX: items[i].sizeX,
					sizeY: items[i].sizeY,
					type: items[i].type,
				}
			};		
			
			tempWidgets = objSorting("row", tempWidgets);
			
			$rootScope.myDashboards[myDashboardId].widgets = tempWidgets;
			StorageManager.setMyDashboards($rootScope.myDashboards);
		}, true);
	};
	
	function createWidgets(widgets) {		
		var tempWidgets = [];
		for (var i=0; i<widgets.length; i++) {
			var tempWidget = angular.copy(widgets[i]);
			var widgetInfo = WidgetInfoManager.getWidgetInfo(tempWidget.id);
		
			tempWidget.elementId = "id_"+ myDashboardId + "_" + i;
			tempWidget.title = widgetInfo.title;
			tempWidget.tooltip = widgetInfo.tooltip;
			tempWidget.type = widgetInfo.type;

	        tempWidgets.push(tempWidget);
		}
		return tempWidgets;
	};

	function objSorting(sortingField, items) {
		items.sort(function (a, b) {
			return a[sortingField] - b[sortingField];
		});
		return items;
	};
});//controller