'use strict';
angular.module('mainApp')
    .controller('LoginCtrl', function ($scope, $rootScope, $location, $timeout, Data, Common, StorageManager, $mdDialog) {
// ===============================================================================
// initialize -->
// ===============================================================================
        $scope.login = {plainUserId:"", plainScrtNo:""};
        $scope.siteAdmin = {siteAdminName:"", siteAdminEmail:""};
        $scope.loginErrorCode = "";
        $scope.btnFlag = true;
        
		$scope.ready = function () {
            //loading or transition
        };

        $(document).ready(function() {
        	$scope.imageUrl = $rootScope.appImageLogoUrl;
        	$scope.apmNm = $rootScope.appName;
        	
            $scope.init();
            
            $timeout(function() {        			
    			var focusField = angular.element("#id");
    			focusField.focus();	
    		}, 200);
            
        });

        $scope.init = function() {
        	var params = {};

        	Data.ajax({url:'init/siteAdminInfo', param:params, successCallback:function(data, status) {
        		try {
        			if(data) {
	                	if (data.resultCode == "1") {
	                		$scope.siteAdmin.siteAdminName = data.SITE_ADMIN_NM;
	                		$scope.siteAdmin.siteAdminEmail = data.SITE_ADMIN_EMAIL;
	
	                	} else {
	                		$scope.siteAdmin.siteAdminName = "";
	                		$scope.siteAdmin.siteAdminEmail = "";
	                	}
        			}else{
        				$scope.btnFlag = true;
        				Common.alertDialog("오류", "담당자 정보 조회중 오류 발생");
        			}
    			} catch(ex) {}
            	
        	}});
        };

// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// login -->
// ===============================================================================
        $scope.gotoSignup = function () {
        	if($rootScope.connectMode!='kt'){
        	}
        	$location.path('/signup');
        };
        
        $scope.doLogin = function (login) {
        	$scope.btnFlag = false;
        	var loginId = login.plainUserId;
        	var passwd = login.plainScrtNo;   
        	$scope.loginErrorCode = "";
        	
        	if (loginId == "" || loginId == undefined){
        		$scope.btnFlag = true;
        		$scope.loginErrorCode = "0102";
        		Common.alertOkEventDialog("알림", "사용자ID를 입력하여 주세요", $scope.alertDialogOk);
        		return;
        	}else if(passwd =="" || passwd == undefined){
        		$scope.btnFlag = true;
        		$scope.loginErrorCode = "0106";
        		Common.alertOkEventDialog("알림", "비밀번호를 입력하여 주세요", $scope.alertDialogOk);
        		return;
        	}
        	
        	loginId = loginId.replace(/^\s*|\s*$/g,"");
        	
        	var params = {loginId: loginId, passwd: passwd};

        	Data.ajax({url:'auth/login', param:params, successCallback:function(data, status) {
        		try {
        			if(data) {
	                	if (data.resultCode == "1") {
	                		//success
	                		if ($scope.getAuthInfo){
	                			$scope.getAgents();
	                			$rootScope.logined = true;
	                		}else{
	                			Common.alertDialog("알림", "인증 정보를 찾을수 없습니다.");
	                		}
	                	} else {
	                		$scope.btnFlag = true;
	                		$scope.loginErrorCode = data.resultCode;
        			        $rootScope.logined = false;
	                		if (data.resultCode == "0102"){
	                			$rootScope.rcgnAuthenticationInfo = data.resultData;
	                			if($rootScope.connectMode == "kt"){
	                				Common.confirmDialog("알림", "등록된 사용자가 아닙니다.\n접근 권한을 신청 하시겠습니까?", $scope.gotoSignup, $scope.dialogCancel);
	                			}else{
	                				Common.alertOkEventDialog("알림", "올바른 사용자가 아닙니다." , $scope.alertDialogOk);
	                			}
	                		}else if (data.resultCode == "LDAPE2"){
	                			Common.alertOkEventDialog("알림", data.AuthMsg , $scope.alertDialogOk);
	                		}else if (data.resultCode == "0106"){
	                			Common.alertOkEventDialog("알림", data.AuthMsg , $scope.alertDialogOk);
	                		}else if (data.resultCode == "0120" || data.resultCode == "0121"){
		                		Common.confirmDialog("알림", data.resultMsg, $scope.registerBtnClickHandler, $scope.dialogCancel);
	                		}else{
	                			Common.alertOkEventDialog("알림", data.resultMsg, $scope.alertDialogOk);
	                		}
	                	}
        			}
        		} catch(ex) {}
        	}});
        };  
        
        $scope.alertDialogOk = function (){
        	if ($scope.loginErrorCode != ""){
        		var focusField;
            	
    			if ($scope.loginErrorCode == "0102"){
    				focusField = angular.element("#id");
    				
    			}else if ($scope.loginErrorCode == "0106"){
    				focusField = angular.element("#pwd");
    				
    			}else{
    				focusField = angular.element("#id");
    				
    			}
    			focusField.focus();	
        	}
        };
        
        $scope.dialogCancel = function (){
        	$rootScope.rcgnAuthenticationInfo = [];
        };
        
        $scope.getAgents = function () {
        	var params = {family: 'javaee'};

        	Data.ajax({url:'cmmn/agentNodeList', param:params, successCallback:function(data, status) {
        		try {
        			if(data) {
	            		if (data.length > 0) {
	            			$scope.setAgents(data);
	                	} else {
                                        $location.path('/dashboard');
                                         return;
	                		//$scope.btnFlag = true;
	                		//Common.alertDialog("오류", "에이전트 리스트 취득 실패");
	                	}
        			}
        		} catch(ex) {}
        	}});
    	};
    	
    	$scope.getAuthInfo = function(){
	    	Data.ajax({url:'cmmn/authInfo', successCallback:function(data, status) {
				try {
					if(data) {
						// success 
						if (data == "" || 'anonymousUser'== data.name) {
							return false;
						}else {
							$rootScope.userInfo = data.userInfo;
							return true;
						};
					}
				} catch(ex) {
				}
			}});
    	}
        
    	$scope.setAgents = function (agents) {
    		StorageManager.clearAllAgent();
    		StorageManager.setAllAgent(agents);
    		$rootScope.allAgent = StorageManager.getAllAgent();
    		
//    		var selectedGroup = StorageManager.getSelectedGroup();
    		var selectedGroup = null;
    		
    		try{
    			selectedGroup = StorageManager.getSelectedGroup();
    		}catch(e){
    			$location.path('/dashboard');
    			return;
    		}
    		
    		var groupAllAgent = [];	
    		
    		//그룹 정보 변경. 체크 변경 시 저장된 그룹정보 삭제
    		if (selectedGroup != null && selectedGroup !=undefined) {
    			var groupCheck = false;
    			for (var i=0; i<$rootScope.allAgent.length; i++) {
	    			if ($rootScope.allAgent[i].nodeGroupId == selectedGroup.id) {
	    				groupCheck = true;	
	    				var group = $rootScope.allAgent[i];
	    				for (var j=0; j<group.serverList.length; j++) {
	    					var server =  group.serverList[j];
	    					for (var k=0; k<server.nodeList.length; k++) {
	    						var node = server.nodeList[k];				
	    						groupAllAgent.push({id:node.nodeId, name:node.nodeNm, svrId:node.svrId});
	    					}
	    				};
	    			};
	    		};
	    		
	    		if (!groupCheck) {
	    			selectedGroup = {};	
	    			selectedGroup.selectedAgent = [];
	    			StorageManager.clearSelectedGroup();
	        		StorageManager.setSelectedGroup(selectedGroup);
	        		$rootScope.selectedGroup = StorageManager.getSelectedGroup();
	    		} else {
	    			
	        		var selectedAgent = selectedGroup.selectedAgent;
	        		/*var newSelectedAgent = [];
	        		
	        		for (var i=0; i<groupAllAgent.length; i++) {
	        			for (var j=0; j<selectedAgent.length; j++) {	        		
		        			if (selectedAgent[j].id == groupAllAgent[i].id) {
	        					newSelectedAgent.push(selectedAgent[j]);
	        				};	        			
	        			};	
	    			};*/
	    			
	    			selectedGroup.selectedAgent = groupAllAgent;
	    			StorageManager.clearSelectedGroup();
	        		StorageManager.setSelectedGroup(selectedGroup);
	        		$rootScope.selectedGroup = StorageManager.getSelectedGroup();
	    		};
    		};
    		
    		$location.path('/dashboard');    		
    	};
        ///////----------------
    	
    	
    	//handler
    	$scope.registerBtnClickHandler = function() {
    		$scope.selectedData ={userId:$scope.login.plainUserId, password:$scope.login.plainScrtNo}
    		$scope.openUserDialog($scope.selectedData);
    	};
        
    	//dialog
    	$scope.openUserDialog = function(selectedData) {
      		$mdDialog.show({
                  controller: $scope.userDialogController,
                  templateUrl: 'views/modal/changePasswordDialog.html',
                  parent: angular.element(document.getElementById("wrap")),
                  targetEvent: event,
                  clickOutsideToClose:true,
                  locals :  {
		                  	selectedData : selectedData
                  			}
              }).then(function(formData) {
        		
              }, function(selectedData) {
            	  //close modal        	        	          	
              });
          };
          
          //controller
          $scope.userDialogController = function($scope, $mdDialog, $timeout, Common, Data, selectedData) {
      	  	//variables
        		$scope.selectedUserId = null;
    			$scope.selectedData = selectedData;
        		
				$scope.init = function() {    
				};
				$scope.answer = function() {
					if (selectedData.password1 == selectedData.password2){
						alert("기존 비밀번호와 변경할 비밀번호가 동일합니다.");
						return;
					}else if (selectedData.password2 != selectedData.password3){
						alert("입력한 비밀번호와 비밀번호 확인 값이 상이합니다.");
						return;
					}
					
					Data.ajax({url:'init/updateChgPwd', param:selectedData, successCallback:function(data, status) {
	        			try {
	        				if(data) {
			                	if (data.result == "1") {
			                		Common.alertDialog("알림", "비밀번호가 성공적으로 변경되었습니다.");
			                	} else {
			                		alert(data.resultMsg);
			                	}
	        				}
	        			} catch(ex) {
	        				
	        			}
	        		}});
				};

				$scope.cancel = function() {
					$mdDialog.cancel();
				};
        };
          
// ===============================================================================
// <-- login
// ===============================================================================
    });//controller

