'use strict';
angular.module('mainApp')
.controller('MonitoringCtrl', function ($window, $route, $scope, $rootScope, $cookies, $interval, $timeout, $log, $mdDialog, $mdMenu, $location, Data, Common, StorageManager, WidgetInfoManager, Paginator) {
// ===============================================================================
// initialize -->
// ===============================================================================
	
	var $table = $('table'),
	$bodyCells = $table.find('tbody tr:first').children(), colWidth;

	//Get the tbody columns width array
	colWidth = $bodyCells.map(function() {
		return $(this).width();
	}).get();

	//Set the width of thead columns
	$table.find('thead tr').children().each(function(i, v) {
	$(v).width(colWidth[i]);
	});
	
	$rootScope.$watch("networkConnected", function(newVal, oldVal) {
	   	if (newVal !== oldVal) { 
	   		var bool = newVal;
	   		if (!bool) {
	   			fnStopInterval();	   			
	   		} else {
	   			fnStartInterval();
	   		}	   		
		};
    });
	
	$scope.alertDialogOk = function (){
		$location.path("/login");
		return;
	}
	
	//variables
	var timeGap = 0;
	var hostindex = location.href.indexOf(location.host) + location.host.length;
    var serviceBase = location.href.substring(0, location.href.indexOf('/', hostindex + 1)) + "/";
	var ajaxLoadDataEnd = true;
    var realTimeXlogChart = undefined;
    var isResize = false;
    var isInterval;
    var ajaxXlogDatatEnd = true;
    var selectedGroup;
    var xLogData = [];
    var currentPage = 1;
    $scope.selectedGroupId = null;
    $scope.selectedGroupNm = null;
    $scope.selectedGroupStts = "normal";
	$scope.groupListData = [];
	//응답시간 분포도 필터
	$scope.normalFilter=true;
    $scope.errorFilter=true;
    $scope.autoAxisY=true;
    $scope.axisYSelectedIndex = 1;
    $scope.selectedSecond =[
    	{id:0, val:5000, name: "5초"}, {id:1, val:10000, name: "10초"},
    	{id:2, val:15000, name: "15초"}, {id:3, val:20000, name: "20초"},
    	{id:4, val:30000, name: "30초"}, {id:5, val:60000, name: "60초"},
    	{id:6, val:150000, name: "150초"}];
    
    var defaultScaleVal = 10000;
    
	$(document).ready(function(){
		if ($rootScope.userInfo == undefined){
    		Common.alertDialog("알림", "세션 정보를 찾을수 없습니다. 다시 로그인 하세요.");
    		$location.path("/login");
    		return;
    		
    	}else{
    		$scope.userTyp = $rootScope.userInfo.userTyp;
    	}
		
		$("#xlogOpt").on("click", function(){
			$("#axisYSelectBox").mCustomScrollbar();
			$("#layer_popup").toggle();
		});
		
		$("html").css("background-color", "#151b25");  
		
        if($scope.userTyp != "user"){
        	var html = '<a class="dropdown-button" data-activates="settings">구성관리<i class="material-icons right">arrow_drop_down</i></a>';
        	$("#settingsTag").html(html);
        }
        
        $scope.imageUrl = $rootScope.appImageLogoUrl;
        $scope.apmNm = $rootScope.appName;
        
		$(".dropdown-button").dropdown();			

		fnInit();
		fnResetLayout();
	});
	
	angular.element(window).on('resize', function(e) {
		if (isResize) { return;}
		isResize = true;
		
		$timeout(function() {
			fnResetLayout();			
		}, 200);
	});
	
	$scope.$on('$destroy', function() {
    	fnStopInterval();
    });
	
	$scope.groupBtnHandler = function(param){
		console.log("groupBtnHandler Start");
		if (param == null){return;}
		fnStopInterval();
		
		var isFirstSerarch = false;
		
		if ($scope.selectedGroupId != param.nodeGroupId){
			isFirstSerarch = true;
		}
		fnXlogChartReload();
		ajaxXlogDatatEnd = true;
		var loardParam = fnParmSetting(param);
		
    	if (isFirstSerarch){
    		loardParam.PAST = 0;
    		if (realTimeXlogChart != null){
    	    	xLogData = [];
    	    	realTimeXlogChart.axis(0).update(xLogData);
    	    	realTimeXlogChart.render();
        	}
    		fnLoadData(loardParam);
    	}
    	console.log("groupBtnHandler End");
        fnStartInterval();
    };
    
    function fnParmSetting(param){
    	console.log("fnParmSetting Start");
		selectedGroup = null;
		
    	var obj = {id: param.nodeGroupId, name: param.nodeGroupNm};
		var allAgent = StorageManager.getAllAgent();
		var group = {};
		
		selectedGroup = obj;
		
		$scope.selectedGroupId = param.nodeGroupId;
    	$scope.selectedGroupNm = param.nodeGroupNm;
    	
    	selectedGroup.selectedAgent = [];
		selectedGroup.selectedAgentIds = [];
		
		for (var i=0; i<allAgent.length;i++){
			if (allAgent[i].nodeGroupId == param.nodeGroupId){
				group = allAgent[i];
				break;
			}
		}
		
		for (var i=0; i < group.serverList.length; i++) {
			var server =  group.serverList[i];
			for (var j=0; j<server.nodeList.length; j++) {
				var node = server.nodeList[j];				
				selectedGroup.selectedAgent.push({id:node.nodeId, name:node.nodeNm, svrId:node.svrId});
			}
		};
		
		for (var i=0; i < selectedGroup.selectedAgent.length; i++) {
    		var agentId = selectedGroup.selectedAgent[i].svrId + "_" + selectedGroup.selectedAgent[i].id;
    		selectedGroup.selectedAgentIds.push(agentId);	
    	};
    	
    	var params = {
				oid:selectedGroup.selectedAgentIds.toString(','), 
				nodeGroupId: selectedGroup.id,
				uxid: (new Date()).getTime(),
				PAST: 0
    	}
    	console.log("fnParmSetting End");
    	return params;
    }
    
    function fnLoadData(param){
    	console.log("fnLoadData Start");
    	if (param == null){return;}
    	fnLoadXlogDataSearch(param);
    	console.log("fnLoadData End");
    }
    
    $scope.mainDashBoardMove = function(param){
    	var obj = {id: param.nodeGroupId, name: param.nodeGroupNm};
		var selectedGroup = obj;
		selectedGroup.selectedAgent = [];
		var allAgent = StorageManager.getAllAgent();
		var group = {};
		
		for (var i=0; i<allAgent.length;i++){
			if (allAgent[i].nodeGroupId == param.nodeGroupId){
				group = allAgent[i];
				break;
			}
		}
		
		for (var i=0; i<group.serverList.length; i++) {
			var server =  group.serverList[i];
			for (var j=0; j<server.nodeList.length; j++) {
				var node = server.nodeList[j];				
				selectedGroup.selectedAgent.push({id:node.nodeId, name:node.nodeNm, svrId:node.svrId});
			}
		};
		
    	StorageManager.clearSelectedGroup();
		StorageManager.setSelectedGroup(selectedGroup);
		$rootScope.selectedGroup = StorageManager.getSelectedGroup();
		$location.path("/dashboard");
    };
    
    $scope.openXLogProfile = function(selectedData) {
    	var width=1280;
    	var height=800;
    	var left = (window.screen.width/2) - (width/2);
    	var top = (window.screen.height/2) - (height/2);
    	
    	window.selectedData=selectedData;
    	window.userInfo = $scope.userInfo;
    	window.selectedAgentIds = selectedGroup.selectedAgentIds;
    	window.xlogYMax = $rootScope.xlogYMax;
    		
       	window.normalFilter=$('#normalFilter').is(':checked');
       	window.errorFilter=$('#errorFilter').is(':checked');
    	
        window.open(serviceBase + "popup.html#/xlog_real", "xlog_real", "width="+width+", height="+height+", left="+left+", top="+top);
    };
    
    function fnLoadXlogDataSearch(params){
    	if (ajaxXlogDatatEnd == false){
    		return;
    	}
    	ajaxXlogDatatEnd = false;
    	Data.ajax({url:'dashBoard/monitoringXLogData', param:params, errorCallback:$scope.errorCallback, successCallback:function(data, status) {
    		ajaxXlogDatatEnd = true;
			try {
				if (data != null && data != undefined){
					fnXlogUpdate(data);
				}
			} catch(ex) {
				
			}
		}});
    }
    
    $scope.openPopup = function(type, num) {
    	var popupX = (window.screen.width/2) - (1280/2);
    	var popupY = (window.screen.height/2) - (720/2);
    	var widgetType = type;
    	
    	if (widgetType == "RealTimeXlog") {
    		popupY = (window.screen.height/2) - (800/2);
    		fnOpenXLogPopup(popupX, popupY);
    		
    	} else if (widgetType == "groupBtnHandler2") {
    		fnGroupBtnHandler2(popupX, popupY);
    		
    	} else if (widgetType == "groupBtnHandler3") {
    		fnGroupBtnHandler3(popupX, popupY);
    		
    	} else if (widgetType == "monitoringjmxResponseRateLarge") {
    		fnMonitoringjmxResponseRateLarge(popupX, popupY, num);
    		
    	} else if (widgetType == "monitoringErrRateLarge") {
    		fnMonitoringErrRateLarge(popupX, popupY, num);
    		
    	} else if (widgetType == "monitoringChartSample") {
    		fnMonitoringChartSample(popupX, popupY);
    		
    	}else if (widgetType == "ErrorLarge") {
    		fnOpenErrorPopup(num, popupX, popupY);
    	}	
    };

    var eventCheckInfo = ['<div ng-if="row.entity.eventUserId==null && ' +  "row.entity.eventDiv=='Y'" + '">' +
		  '    <button type="button" class="btn waves-effect waves-light btn-inner kr margin-left" ng-click="grid.appScope.oneClick(row,COL_FIELD)">해소</button>' +
		  '</div>' +
		  '<div ng-if="row.entity.eventUserId!=null" class="ui-grid-cell-contents my-cell ng-binding ng-scope" ng-dbclick="grid.appScope.dbClick(row)" tabindex="0">' +
		  '    {{row.entity.eventCheckInfo}}' +
		  '</div>'].join('');
	
	$scope.monitoringGridOptions = {
			enablePaginationControls: false,	
 		    paginationPageSize: 8,
 			enableRowSelection: true,
 			enableSelectAll: true,
 			enableRowHeaderSelection: false,
 			modifierKeysToMultiSelect: false,
 			multiSelect: false,
			enableScrollbars: false,
			enableHorizontalScrollbar: 0,
			enableVerticalScrollbar: 0,
			enableColumnMenus: false,
			enableFiltering: false,
			showGridFooter:false,
			showColumnFooter:false,
			columnDefs: [
				  { field: 'no', name: "No",width: "50", cellClass:'grid-number'},
			      { field: 'eventDtFmt',name: "발생시간",width: "140"},
			      { field: 'nodeGroupNm',name: "서비스그룹",width: "15%"},
			      { field: 'nodeNm',name: "인스턴스",width: "15%"},
			      { field: 'sttsLvl',name: "오류레벨",width: "70", cellClass:'grid-number'},
			      { field: 'defaultChkVal',name: "기준치",width: "70", cellClass:'grid-number'},
			      { field: 'chkVal',name: "측정치",width: "70", cellClass:'grid-number'},
			      { field: 'retryCnt',name: "누적건수",width: "70" , cellClass:'grid-number'},
			      { field: 'metricNm',name: "예외/오류명",width: "8%"},
			      { field: 'eventCheckInfo',name: "해소정보",width: "150", cellClass:'grid-center', cellTemplate : eventCheckInfo},
			      { field: 'eventMsg',name: "상세",width: "*"},
			    ]
		};
	
	$scope.monitoringGridOptions.onRegisterApi = function(gridApi){
		$scope.monitoringGridApi = gridApi;
		
		gridApi.selection.on.rowSelectionChangedBatch($scope,function(rows){
		});
 		 
		$interval(function() {
			$scope.monitoringGridApi.core.handleWindowResize();
		}, 10, 10);
	};
	
	$scope.oneClick = function(row,COL_FIELD){
		$scope.openEventDetail(row.entity);
    }
	
	$scope.dblClick = function(row){//DoubleClick
		var item = [];
		item.data = row.entity;
		$scope.openErrorDetail(item);
    }
	
	$scope.triggerXlog = function(typ) {
		if(typ==1||typ==2){
			$scope.normalFilter=$('#normalFilter').is(':checked');
			$scope.errorFilter=$('#errorFilter').is(':checked');
		} else {
			$scope.autoAxisY=$('#autoAxisY').is(':checked');
		}	
	};
// ===============================================================================
// function -->
// ===============================================================================
	function fnInit() {
        $scope.userTyp = $rootScope.userInfo.userTyp;
        $scope.connectMode = $rootScope.userInfo.connectMode;
        
        timeGap = Number(StorageManager.getTimeGap());
        $scope.selectedGroupId = StorageManager.getSelectedGroup().id;
        $scope.selectedGroupNm = StorageManager.getSelectedGroup().name;
        
        if ($scope.selectedGroup == null){
			var allAgent = $rootScope.allAgent;
			
			if (allAgent.length < 1){
				allAgent = StorageManager.getAllAgent();
			}
			for (var i = 0; i < allAgent.length; i++) {
				if(0 < allAgent[i].serverList.length){
					$scope.selectedGroupId = allAgent[i].nodeGroupId;
					$scope.selectedGroupNm = allAgent[i].nodeGroupNm;
					break;
				}
			}
        }
        
        fnGetGroupList();
        fnCreateXLog();
        
        $timeout(function() {
			$(".monitoring-box").slick({
				autoplay:true,
				autoplaySpeed: 5000,
				slidesToShow: 7,
				slidesToScroll: 7,
				rows:3,
				/*infinite:true,*/
				arrows:false,
				dots:true/*,
				vertical: false*/
			});
		}, 1000);
        
        fnStartInterval();
        
	};	
    
	function fnStartInterval() {
        if (angular.isDefined(isInterval)) {
        	return; 
        }  
        
        isInterval = $interval(function() {
        	if (isResize) { return; }
            fnGetGroupStatus();
            var parm = {nodeGroupId:$scope.selectedGroupId, nodeGroupNm:$scope.selectedGroupNm};
            
            var loadParm = fnParmSetting(parm);
            fnLoadData(loadParm);
            
        }, 5000);
        
    };
    
    function fnStopInterval() {
        if (angular.isDefined(isInterval)) {
            $interval.cancel(isInterval);
            isInterval = undefined;
        }
    };
	
    function fnResetLayout() {
    	var tableHeader = Math.floor($(".table-header").width());
    	var tableHeight = 300;
    	var tableScrollbar = 20;
    	var margin = 10;
    	
    	var bodyHeight = Math.floor($("body").height()); 
    	var navHeight = Math.floor($(".navbar-fixed").height());
    	
    	var contentHeight = Math.floor(bodyHeight - navHeight - tableHeight);
    	$(".content").css("height", (contentHeight)+"px");
    	
    	var pagingBoxHeight = 80;
    	var monitorBoxWidth = $(".monitoring-container").width();
    	var monitorBoxHeight = contentHeight - margin;

    	$(".monitoring-box").css("height", monitorBoxHeight);
    	$('.chart_content').css("height", bodyHeight - monitorBoxHeight - 30 + "px");
    	$("#monitoringGrid").css("height", bodyHeight - monitorBoxHeight - 64 + "px");
    	
    	var a = document.body.scrollHeight;
    	var b = document.body.offsetHeight;
    	var c = window.innerHeight;
    	var d = window.outerHeight;
    	var f = contentHeight + tableHeight + navHeight;
    	
    	monitorBoxHeight = Math.floor($(".monitoring-box").height());
    	
    	var gridItemWidth = (monitorBoxWidth/ 7) - margin; 
    	var gridItemHeight = Math.floor(monitorBoxHeight/ 3); 
    	
    	$(".grid-getItem").css("width", gridItemWidth+"px");
    	$(".grid-getItem").css("height", gridItemHeight+"px");
    	
    	$(".content").css("height", "550px");//상단 리스트 높이 고정
    	$(".content").css("padding", "15px 15px 5px 15px");//축소시 깨짐 방지
    	
    	var xLogChartElement = angular.element(".box-content");
    	if (xLogChartElement != undefined && realTimeXlogChart != undefined) {
    		if (xLogChartElement[0].clientWidth != 0 && xLogChartElement[0].clientHeight != 0){
    			realTimeXlogChart.setSize(Common.getElementWidth(xLogChartElement), Common.getElementHeight(xLogChartElement) - 10);
    	    	realTimeXlogChart.render();
			}
    	}
    	isResize = false;
	};
	
    function fnGroupBtnHandler2(popupX, popupY) {
        window.open(serviceBase + "popup.html#/groupBtnHandler2", "group_Btn_Handler2", "width=1280, height=720,left="+popupX+", top="+popupY);
    };
    
    function fnGroupBtnHandler3(popupX, popupY) {
        window.open(serviceBase + "popup.html#/groupBtnHandler3", "group_Btn_Handler3", "width=1280, height=720,left="+popupX+", top="+popupY);
    };
    
    function fnMonitoringjmxResponseRateLarge(popupX, popupY, num) {
        window.open(serviceBase + "popup.html#/monitoringjmxResponseRateLarge?param="+num, "monitoringjmxResponseRateLarge", "width=1280, height=720,left="+popupX+", top="+popupY);
//        window.open(serviceBase + "popup.html#/monitoringjmxResponseRateLarge?nodeGroupId="+$scope.group.nodeGroupId, "monitoringjmxResponseRateLarge", "width=1280, height=720,left="+popupX+", top="+popupY);
    };
    
    function fnMonitoringErrRateLarge(popupX, popupY, num) {
        window.open(serviceBase + "popup.html#/monitoringErrRateLarge?param="+num, "monitoringErrRateLarge", "width=1280, height=720,left="+popupX+", top="+popupY);
    };
    
    function fnMonitoringChartSample(popupX, popupY) {
    	window.open(serviceBase + "popupNew.html#/monitoringChartSample", "monitoringChartSample", "width=1280, height=720,left="+popupX+", top="+popupY);
    };
    
    function fnOpenErrorPopup(num, popupX, popupY) {
        window.open(serviceBase + "popup.html#/error_large/"+num, "popup_error", "width=1280, height=720, left="+popupX+", top="+popupY);
    };
    
    function fnOpenXLogPopup(popupX, popupY) {
    	window.selectedGroupId = $scope.selectedGroupId;
        window.open(serviceBase + "popup.html#/xlog_large", "popup_xlog", "width=1280, height=800, left="+popupX+", top="+popupY);
    };
    
	function fnGetGroupList() {
		var data = [];	
		var allAgent = StorageManager.getAllAgent();
		
    	for (var i=0; i<allAgent.length; i++) {
    		var obj = {
    					nodeGroupNm:allAgent[i].nodeGroupNm, 
	    				nodeGroupId:allAgent[i].nodeGroupId, 
	    				errRate:0, 
	    				metricNm:"", 
	    				criticalCnt:0, 
	    				warnCnt:0,
	    				svcStatsAllCnt:0,
	    				svcStatsSuccessCnt:0,
	    				svcStatsErrorCnt:0,
	    				elapseTimeCurrentCnt:0,
	    				elapseTimeRealTimeCnt:0,
	    				elapseTimeCompareCnt:0,
	    				status:"normal"
    				};
    		data.push(obj);
    	};
    	
    	$scope.groupListData = data;
    	
    	$timeout(function() {
    		fnResetLayout();		
		}, 500)
	};
	
	function fnGetGroupStatus() {
		if (ajaxLoadDataEnd == false){
    		return;
    	}

		ajaxLoadDataEnd == false;
		
    	Data.ajax({url:'dashBoard/monitoringInfo', successCallback:function(result, status) {
    		try {
    			ajaxLoadDataEnd = true;
    			if(result) {
    				var nodeGroupInfo = result.groupExceptionInfo;
    				
    				for (var i=0; i<nodeGroupInfo.length; i++) {
    					for (var y=0; y< $scope.groupListData.length; y++){
    						if (nodeGroupInfo[i].nodeGroupId == $scope.selectedGroupId){
    							$scope.selectedGroupStts = nodeGroupInfo[i].nodeStatus;
    						}
    						if ($scope.groupListData[y].nodeGroupId == nodeGroupInfo[i].nodeGroupId){
    							$scope.groupListData[y].status = nodeGroupInfo[i].nodeStatus;
    							
    							if (nodeGroupInfo[i].metricNm == null || nodeGroupInfo[i].metricNm == undefined){
    								$scope.groupListData[y].metricNm = "";
    							}else {
    								$scope.groupListData[y].metricNm = nodeGroupInfo[i].metricNm;
    							}
    							
    							if (nodeGroupInfo[i].critical == null || nodeGroupInfo[i].critical == undefined){
    								$scope.groupListData[y].criticalCnt = 0;
    							}else {
    								$scope.groupListData[y].criticalCnt =  Math.floor(nodeGroupInfo[i].critical);
    							}
    							
    							if (nodeGroupInfo[i].warn == null || nodeGroupInfo[i].warn == undefined){
    								$scope.groupListData[y].warnCnt = 0;
    							}else {
    								$scope.groupListData[y].warnCnt =  Math.floor(nodeGroupInfo[i].warn);
    							}
    							
    							if (nodeGroupInfo[i].svcStatsCnt == null || nodeGroupInfo[i].svcStatsCnt == undefined){
    								$scope.groupListData[y].svcStatsAllCnt = 0;
    							}else {
    								$scope.groupListData[y].svcStatsAllCnt =  Common.formatNumber(Math.floor(nodeGroupInfo[i].svcStatsCnt));
    							}
    							
    							
    							if (nodeGroupInfo[i].svcStatsErrorCnt == null || nodeGroupInfo[i].svcStatsErrorCnt == undefined){
    								$scope.groupListData[y].svcStatsErrorCnt = 0;
    							}else {
    								$scope.groupListData[y].svcStatsErrorCnt =  Common.formatNumber(Math.floor(nodeGroupInfo[i].svcStatsErrorCnt));
    							}
    							
    							$scope.groupListData[y].svcStatsSuccessCnt = Common.formatNumber(nodeGroupInfo[i].svcStatsCnt - nodeGroupInfo[i].svcStatsErrorCnt);
    							if (nodeGroupInfo[i].elapseTimeCurrentCnt == null || nodeGroupInfo[i].elapseTimeCurrentCnt == undefined){
    								$scope.groupListData[y].elapseTimeCurrentCnt = 0;
    							}else {
    								$scope.groupListData[y].elapseTimeCurrentCnt =  Common.formatNumber(Math.floor(nodeGroupInfo[i].elapseTimeCurrentCnt));
    							}
    							
    							if (nodeGroupInfo[i].elapseTimeRealTimeCnt == null || nodeGroupInfo[i].elapseTimeRealTimeCnt == undefined){
    								$scope.groupListData[y].elapseTimeRealTimeCnt = 0;
    							}else {
    								$scope.groupListData[y].elapseTimeRealTimeCnt =  Common.formatNumber(Math.floor(nodeGroupInfo[i].elapseTimeRealTimeCnt));
    							}
    							
    							if (nodeGroupInfo[i].elapseTimeCompareCnt == null || nodeGroupInfo[i].elapseTimeCompareCnt == undefined){
    								$scope.groupListData[y].elapseTimeCompareCnt = 0;
    							}else {
    								$scope.groupListData[y].elapseTimeCompareCnt = Common.formatNumber(Math.floor(nodeGroupInfo[i].elapseTimeCompareCnt));
    							}
    							
    							$scope.groupListData[y].errRate = 100 - Math.floor(nodeGroupInfo[i].errorRate);
    							
    							break;
    						}
    						
    					}
    					
    				}
    				
    		    	if (result.eventHistList != null) {
    		    		var eventHistList = [];
    		    		for (var i=0; i< result.eventHistList.length; i++) {
		     				var obj = result.eventHistList[i];
		     				obj.no = i + 1;
		     				if (result.eventHistList[i].eventCheckDtFmt != null ){
								 obj.eventCheckInfo = result.eventHistList[i].eventCheckDtFmt + "(" + result.eventHistList[i].eventUserId + ")";
							}else{
								obj.eventCheckInfo = "";
							}
		     				eventHistList.push(obj);
    		    		}
    		    		
    		    		$scope.monitoringGridOptions.data = eventHistList;
    				};
    				
    				/********** ui-grid custom(그리드, 페이징) **********/
	     			/*$timeout(function() {
	     				// 최초 실행 시 첫 Row 선택
	     				if($scope.monitoringGridApi.selection.selectRow){
	     				  $scope.monitoringGridApi.selection.selectRow($scope.monitoringGridOptions.data[0]);
	     				}
	     			});*/
	     			Paginator.setScopeParamAdd($scope, $scope.monitoringGridOptions, $scope.monitoringGridApi);
	     			$scope.paging = function(page) {
	     				currentPage = page;
	     				Paginator.setPage(page);
	     			}
	     			$scope.paging(currentPage); 
	     			/********** ui-grid custom(그리드, 페이징) **********/
    				
    			}
    			
    		} catch(ex) {}
    	}});
		
	};
	
	function fnCreateXLog() {  
    	if (realTimeXlogChart != undefined) { return }   
    	jui.ready(["chart.builder"], function (juiChart) {
    		var style = {					
    				colors: ["#38c3ff",  "#ffb500", "#ff474c", "#ff474c", "#123456"],
			        backgroundColor: "#00000000",
			        axisBorderColor: "#00000000",
			        axisBorderWidth: 1,
			        axisBorderRadius: 5,
			        gridXFontSize: 10,
			        gridXFontColor: "#c2c6c9",
			        gridYFontSize: 10,
			        gridYFontColor: "#c2c6c9",	    
			        gridXAxisBorderWidth: 1,
			        gridXAxisBorderColor: "#c2c6c9",
			        gridYAxisBorderWidth: 1,
			        gridYAxisBorderColor: "#c2c6c9",
					gridBorderColor:"#464a62",
			        tooltipFontColor:"#fff",
			        tooltipBackgroundColor:"#1b1b1b",
			        lineBorderWidth: 1
			};	
    		realTimeXlogChart = juiChart("#xLogChart", {
    			padding: { left: 40, top: 30, right: 20, bottom: 25 },
    			canvas: true,
    		    axis : {
    		        x : {
    		        	type: "date",  		        
    		            domain : Common.pastTimeInterval(5, timeGap),
    		            interval: 1,
    		            realtime: "minutes",
    		            format: "HH:mm",
    		            key: "time",
    		            line : true
    		        },
    		        y : {
    		            type : "range",
    		            domain :  [0, 10000],
    		            step : 5,
    		            line : true,
    		            format : function(d) {
		            		return (d/1000) + "(S)";
			            } 
    		        },
    		        data : xLogData,
    		    },
			    brush : [
			    	{
				    	type : "canvas.scatter",
				        size : 3,
				        target : "elapsed",		       
				        symbol: "circle",
			            colors: function (d) {
			            	if($scope.normalFilter && d.error!=2)
			            		return d.error;
			            	else 
			            		return 4;
			            }
		            },
			    	{
			    		type : "canvas.scatter",
			    		size : 6,
			    		target : "errTk",		       
				        symbol: "cross",
			    		colors: function (d) {
			    			if( $scope.errorFilter && d.error==2) 
			    				return d.error;
			            	else 
			            		return 4;
			    		}
			    	}
			    ],
    		    widget : [{
    		        type : "dragselect",
    		        dataType : "area" // "list"
    		    }, {
    		        type : "tooltip",
    		        format : function(data, key) {
    	                return {
    	                    key: data[key],
    	                    value: (data.elapsed) + "ms"
    	                }
    	            }
    		    }],
    		    event : {
    		        "dragselect.end": function(data) {
    		        	$scope.openXLogProfile(data);    		        	
    		        }
    		    },
    		    style: style,
    		    render: false
    		});    		    		    		
    	});
	};
	
	function fnXlogChartReload(){
		if (realTimeXlogChart == null || realTimeXlogChart == undefined) { return; }
		xLogData = [];
		fnXlogUpdate(xLogData);		
	}
	
	function fnXlogUpdate(data){
		if (data == undefined || data == null){
			return;
		}
		
		if (xLogData.length == 1 && xLogData[0].time == undefined) {
			xLogData = [];
		}
		
		var xDomain;
		
		if (data.length == 0){
			return;
		}
		xDomain = Common.pastTimeInterval(5, timeGap);
		
		realTimeXlogChart.axis(0).set("x", {domain: xDomain});
		realTimeXlogChart.axis(0).set("x", {interval: 1});
		realTimeXlogChart.axis(0).set("x", {format: "HH:mm"});
		
		for (var i = 0; i < data.length; i++) {
            data[i].time = new Date(data[i].eTime);
			if(data[i].error==2) {
				data[i].errTk=data[i].elapsed;
				data[i].elapsed=undefined;
			}
            
			xLogData.push(data[i]);
        }		

		var y3=0;
		if (xLogData.length > 0){
			var currentTime = xDomain[0].getTime();
	    	
	    	var arrCnt = 0;
	    	while(arrCnt < xLogData.length) {
	    		if (xLogData.length <= arrCnt){
	    			break;
	    		}
	    		var dt1= xLogData[arrCnt];
	    		if (currentTime >= dt1.time.getTime() - 3000){
	    			xLogData.splice(arrCnt , 1);
	    		}else {
	    			if(dt1.errTk){
	    				y3=Math.max(dt1.errTk,y3);
	    			}else if(dt1.elapsed){
	    				y3=Math.max(dt1.elapsed,y3);
	    			}
	    			arrCnt ++;
	    		}
	        }
		}
		
		
		var yMax;
		if(!$scope.autoAxisY) {
			yMax = defaultScaleVal;
		} else {
			y3=Math.min(170000,y3);
			y3=(Math.floor(y3/5000)+1)*5000;
			yMax=y3;
		}
		var yDomain = [0, yMax];
		realTimeXlogChart.axis(0).set("y", {domain: yDomain});
		realTimeXlogChart.axis(0).update(xLogData);
		realTimeXlogChart.render();	
	}
//===============================================================================
// Detail popup -->
//===============================================================================
     $scope.openErrorDetail = function(item) {
         $mdDialog.show({
             controller: $scope.errorDetailController,
             templateUrl: 'views/modal/errorDetailDialog.html',
             parent: angular.element(document.getElementById("wrap")),
             targetEvent: event,
             clickOutsideToClose:true,
             locals : {
            	 item : item
             }
         }).then(function() {
         }, function() {
         	//close modal
         });
     };

     $scope.errorDetailController = function($scope, $rootScope, $timeout, $mdDialog, item) {
    	 $scope.item = item;
    	 
    	 $scope.cancel = function() {
             $mdDialog.cancel();
         };
     };
     
     
     $scope.openEventDetail = function(item) {
         $mdDialog.show({
             controller: $scope.eventDetailController,
             templateUrl: 'views/modal/eventDetailDialog.html',
             parent: angular.element(document.getElementById("wrap")),
             targetEvent: event,
             clickOutsideToClose:true,
             locals : {
            	 item : item
             }
         }).then(function(formData) {
        	var params = formData;
         	Data.ajax({url:'dashBoard/updateHistException', param:params, successCallback:function(data, status) {
         		try {
         			if(data) {
 	                	if (data.result == "1") {
 	                		Common.alertDialog("해소 완료", "["+params.nodeGroupNm +"]그룹의 [" + params.nodeNm +"] 정보가 해소되었습니다.");
 	                		$scope.getGroupStatus();
 	               		 	$scope.autoScroll();
 	                	}else{
 	                		Common.alertDialog("오류", data.resultMsg);
 	                	}
         			}
         		} catch(ex) {}
         	}});
         }, function() {
//        	 $scope.getGroupStatus();
//     		 $scope.autoScroll();
         	//close modal
         });
     };

     $scope.eventDetailController = function($scope, $rootScope, $timeout, $mdDialog, item) {
    	 $scope.formData = {
 				userId : $rootScope.userInfo.userId, 
 				userNm : $rootScope.userInfo.userNm, 
 				deptNm : $rootScope.userInfo.deptNm, 
 				mobile : $rootScope.userInfo.mobile, 
 				eventDt : item.eventDt,
 	 			nodeId : item.nodeId,
 	 			eventId : item.eventId,
 	 			eventCheckDt : item.eventCheckDt,
 	 			nodeGroupNm : item.nodeGroupNm,
 	 			nodeNm : item.nodeNm
 			};
    	 var itemObj = [];
	 	 itemObj.data = item;
	 	 $scope.item = itemObj;
	 	 $scope.cancel = function() {
	 		 $mdDialog.cancel();
	 	 };

	 	 $scope.answer = function() {      
	 		 $mdDialog.hide($scope.formData);
	 	 };
     };
     
     $scope.axisYAnswer = function(){
    	 $scope.autoAxisY = false;
    	 defaultScaleVal = $scope.selectedSecond[$scope.axisYSelectedIndex].val;
    	 $("#layer_popup").toggle();
     };
     
     $scope.axisYcancel = function(){
    	 $("#layer_popup").toggle();
     };
//===============================================================================
// <-- Detail popup
//===============================================================================
});//controller