'use strict';
angular.module('mainApp')
    .controller('reportCtrl', function ($window, $scope, $rootScope, $cookies, $interval, $timeout, $log, $mdDialog, $mdMenu, Data, Common, StorageManager, WidgetInfoManager, $location, Paginator, ivhTreeviewBfs, ivhTreeviewMgr) {
// ===============================================================================
// initialize -->
// ===============================================================================
    	
	$scope.allAgent = [];
	$scope.selectedAgentIds = [];
	
	//variables
	$scope.title_name = "애플리케이션"; 
	$scope.currentYearMonth = null;
	$scope.currentDay = null;
	$scope.currentTime = null;         
    $scope.userTyp = null;
	$scope.searchOptions=
		{
			 oid: "", 
			 startDt: "", 
			 endDt: "",
			 selectCode: "",
			 searchText: ""
		 };
    //tree
    $scope.agentTreeCreated = false;
    $scope.agentTree = undefined;
      
	// 검색 시작 시간 자동 생성
    $scope.startTime = function () {
    	var date = new Date();
    	
    	var eHH = date.getHours()-1;
    	var emm = date.getMinutes();
    	
    	eHH = eHH >= 10 ? eHH : '0' + eHH;
    	emm = emm >= 10 ? emm : '0' + emm;
    	return eHH + ":" + emm;
    };
    //검색 종료 시간 자동 생성    
    $scope.endTime = function () {
    	var date = new Date();
    	
    	var eHH = date.getHours();
    	var emm = date.getMinutes();
    	
    	eHH = eHH >= 10 ? eHH : '0' + eHH;
    	emm = emm >= 10 ? emm : '0' + emm;
    	return eHH + ":" + emm;
    };
        
    //날짜 선택
    $scope.startYm = {yyyymm : Common.getToday()};
    $scope.startDtOption = {yyyymmdd : Common.getToday()};        
    $scope.startHour = ($scope.startTime().substr(0,2)); //시작시간
    $scope.startMin = ($scope.startTime().substr(3,2)); //시작분
    $scope.endDtOption = {yyyymmdd : Common.getToday()}; 
    $scope.endHour = ($scope.endTime().substr(0,2)); //종료시간
    $scope.endMin = ($scope.endTime().substr(3,2)); //종료분

    //통계구분 항목선택 id,name 추가
	$scope.selectCode = [];
	$scope.selectCode.push({id:"1", name:"애플리케이션"});
	$scope.selectCode.push({id:"2", name:"SQL"});
	$scope.selectCode.push({id:"3", name:"API CALL"});
	$scope.selectCode.push({id:"4", name:"예외/오류"});
	
	var paramSearch = {};
	
    $scope.resetLayout = function() {
   	 	var bodyHeight = $("body").prop("scrollHeight");
   	 	var sideHeight = $(".sidenav").prop("scrollHeight");
   	 	if (bodyHeight == 0 || sideHeight == 0) { return; } 
   	 	bodyHeight -= 56; //toolbar height : 56 
   	 	
   	 	if (bodyHeight > sideHeight) {
   	 		$(".sidenav").css("height", (bodyHeight)+"px");	
   	 	} else if (bodyHeight < sideHeight) {
   	 		//$("body").css("height", sideHeight+"px");
   	 	}	       	 
   	 	$("body").css("background-color", "#eeeeee");
        $(".sidenav").css("background-color", "#151b25"); 
   };
       
   angular.element(window).on('resize', function(e) {
		$scope.resetLayout();
   });
       

   $(document).ready(function(){
	   $("html").css("background-color", "#eeeeee");
    	
		if ($rootScope.userInfo == undefined){
			Common.alertDialog("알림", "세션 정보를 찾을수 없습니다. 다시 로그인 하세요.");
			$location.path("/login");
			return;
		}else{
			$scope.userTyp = $rootScope.userInfo.userTyp;
		}
		
		if($scope.userTyp != "user"){
			var html = '<a class="dropdown-button" data-activates="settings">구성관리<i class="material-icons right">arrow_drop_down</i></a>';
			$("#settingsTag").html(html);
		}
		
		$scope.imageUrl = $rootScope.appImageLogoUrl;
		$scope.apmNm = $rootScope.appName;
		$(".dropdown-button").dropdown();
		$("select").material_select();    
		$scope.getAgents();            
		$timeout(function() {
			$scope.resetLayout();            	
		}, 1000);
   });
   
   //init
	$scope.init = function() {
	    $scope.isLoading = true;
	    $scope.createUIComponentStDt();
	    $scope.createUIComponentEdDt();
	};
        
	//달력 시작날짜 선택
	$scope.createUIComponentStDt = function() {
		jui.ready(["ui.property"], function(PropertyView) {
			var datePicker = new PropertyView("#startDtPicker", {
	            items:[
	            	{type: 'date', key: 'date-picker'}],
	            event: {
	            	change: function(item, data) {
	            		$scope.startDtOption.yyyymmdd = data;
	            	}
	            }
	        });
		});
	};
    	
	//달력 종료날짜 선택
	$scope.createUIComponentEdDt = function() {
		jui.ready(["ui.property"], function(PropertyView) {
			var datePicker = new PropertyView("#endDtPicker", {
	            items:[
	            	{type: 'date', key: 'date-picker'}],
	            event: {
	            	change: function(item, data) {
	            		$scope.endDtOption.yyyymmdd = data;
	            	}
	            }
	        });
		});
	};
    	
	/* 그리드 */
	$scope.gridOptions = {
		/*paginationPageSizes: [25, 50, 75],*/
		enablePaginationControls: false,	
	    paginationPageSize: 20,
		enableRowSelection: true,
		enableSelectAll: true,
		enableRowHeaderSelection: false,
		modifierKeysToMultiSelect: false,
		multiSelect: false,
		/* Scrollbar  ::  0:disable, 1:enable, 2:enable when needed */
		enableScrollbars: false,
		enableHorizontalScrollbar: 0,
		enableVerticalScrollbar: 0,
		/* 선택 항목 유지 */
		/* 헤더 옵션 제거 */
		enableColumnMenus: false,
	    enableFiltering: false,
	    showGridFooter:false,
	    showColumnFooter:false,
	    columnDefs :
	    	[	
	    	  { field: 'no', name: "no",width: "5%", cellClass:'grid-number'},
		      { field: 'cnt',name: "호출 건수",width: "12%", cellClass:'grid-number'} ,
		      { field: 'errorCnt',name: "오류 건수",width: "12%", cellClass:'grid-number' },
		      { field: 'maxElap',name: "최대 응답시간(s)",width: "15%", cellClass:'grid-number'},
		      { field: 'avgElap',name: "평균 응답시간(s)",width: "12%", cellClass:'grid-number' },
		      { field: 'avgCpu',name: "평균 CPU시간(s)",width: "15%", cellClass:'grid-number' },
		      { field: 'avgMem',name: "평균 메모리사용량(bytes)",width: "12%", cellClass:'grid-number' },
		      { field: 'txt',name:"애플리케이션명",width: "*" }
		    ]
	};
	    
  	$scope.gridOptions.onRegisterApi = function(gridApi){	  		
  		//set gridApi on scope
  		$scope.gridApi = gridApi;
      gridApi.selection.on.rowSelectionChanged($scope,function(row){
    	  var msg = 'row selected ' + row.isSelected;
    	  $scope.selectStatisticsClickData = row.entity;
      });
      
      gridApi.selection.on.rowSelectionChangedBatch($scope,function(rows){
    	  var msg = 'rows changed ' + rows.length;
      });
      
      // 컬럼 클릭 시 적용 이벤트 
      gridApi.cellNav.on.navigate($scope, function(newRowCol, oldRowCol) {
    	  $(".ui-grid-focuser").remove(); // 최초 선택시 포커스가 아래로 향하여 스크롤 되는 경우 생김 (주석처리하면 해당 오류 테스트 가능)
    	  $scope.gridApi.selection.selectRow(newRowCol.row.entity); // 포커스된 셀이 포함된 행 전체를 선택
    	  
    	  // 애플리케이션명(txt) 컬럼 클릭 시
    	  if (newRowCol.col.colDef.field == "txt") {		    		  
    		  $scope.openAlertDialog(newRowCol.col.colDef.name + " 상세정보", newRowCol.row.entity.txt);
    	  }		    	  		    	 
      });
      	      
      $interval(function() {
    	 $scope.gridApi.core.handleWindowResize();
      }, 10, 10);
	};
    	
// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// rest controller -->
// ===============================================================================
	$scope.getAgents = function () {
		if (StorageManager.getAllAgent() != undefined && StorageManager.getAllAgent() != null) {
			$scope.allAgent = StorageManager.getAllAgent();
			$scope.init();
		} else {
			//Cant Create AgentList
		};
	};
		
	//항목 선택
    $scope.changeSelect = function (name, data) {
    	if(name == "statisticsGb"){
	    	if(data == "undefined" || data == null){
    			$scope.searchOptions.selectCode = "";
    		}else{
    			$scope.searchOptions.selectCode = $scope.statisticsGb.id;
    		}
    	}
    }
    // time validation
    $scope.stHourCheck = function (startHour) {
    	var intValue = parseInt(startHour);
    	if( $.isNumeric(intValue) == false ){
    		$scope.startHour= "";
    	}
    };
    $scope.stMinCheck = function (startMin) {
    	var intValue = parseInt(startMin);
    	if( $.isNumeric(intValue) == false ){
    		$scope.startMin= "";
    	}
    };
    $scope.enHourCheck = function (endHour) {
    	var intValue = parseInt(endHour);
    	if( $.isNumeric(intValue) == false ){
    		$scope.endHour= "";
    	}
    };
    $scope.enMinCheck = function (endMin) {
    	var intValue = parseInt(endMin);
    	if( $.isNumeric(intValue) == false ){
    		$scope.endMin= "";
    	}
    };
    //조회 시작
    $scope.searchBtnHandler = function () {
    	var startymd = $scope.startDtOption.yyyymmdd.substr(0,10).replace(/\//g,'-'); //정규식 replaceAll / => -으로
    	var starthh = $scope.startHour;
    	var startmm = $scope.startMin;
    	
    	var endymd = $scope.endDtOption.yyyymmdd.substr(0,10).replace(/\//g,'-');
    	var endhh = $scope.endHour;
        var endmm = $scope.endMin; 
        
		var oid = $scope.selectedAgentIds.toString(',');
		var startDt= startymd + " " + starthh + ":" + startmm + ":00";		
		var endDt = endymd + " " + endhh + ":" + endmm + ":59";
		var selectCode = $scope.searchOptions.selectCode;
		var searchText = $scope.searchText || "";
		
		$scope.startDt = startDt;
		$scope.endDt = endDt;			
		
		if(starthh==""||startmm==""){
			Common.alertDialog("날짜선택", "검색 시작 시간이 선택되지 않았습니다.");
			return;
		}else if(endhh==""||endmm==""){
			Common.alertDialog("날짜선택", "검색 종료 시간이 선택되지 않았습니다.");
			return;
		}else if(selectCode==""){
			Common.alertDialog("통계구분 항목선택", "통계구분이 선택되지 않았습니다.");
			return;
		}else if(searchText!=="" && searchText.length < 5){
			Common.alertDialog("검색어 입력", "검색어는 최소 5글자 이상 입력해주세요.");
			return;
		}else if(oid==""){
			Common.alertDialog("에이전트 미선택", "에이전트가 선택되지 않았습니다.");
			return;
		}
		
		var params = {
					 oid: oid, 
					 startDt: startDt, 
					 endDt: endDt,
					 selectCode: selectCode,
					 searchText: searchText
					 };
		$scope.searchOptions = params;
			
		// 통계구분 항목 선택 별 그리드 컬럼
		if(selectCode=="1"){
			$scope.gridOptions.columnDefs =
				[	
	  			  { field: 'no', name: "no",width: "5%", cellClass:'grid-number'},
			      { field: 'cnt',name: "호출 건수",width: "12%", cellClass:'grid-number', type:'numberStr'} ,
			      { field: 'errorCnt',name: "오류 건수",width: "12%", cellClass:'grid-number', type:'numberStr'},
			      { field: 'maxElap',name: "최대 응답시간(s)",width: "12%", cellClass:'grid-number', type:'numberStr'},
			      { field: 'avgElap',name: "평균 응답시간(s)",width: "12%", cellClass:'grid-number', type:'numberStr' },
			      { field: 'avgCpu',name: "평균 CPU시간(s)",width: "15%", cellClass:'grid-number', type:'numberStr' },
			      { field: 'avgMem',name: "평균 메모리사용량(bytes)",width: "12%", cellClass:'grid-number', type:'numberStr' },
			      { field: 'txt',name: "애플리케이션명",width: "*" }
			    ];
			$scope.title_name = "애플리케이션";
		}else if(selectCode=="2"){
			$scope.gridOptions.columnDefs =
				[
	  			  { field: 'no', name: "no",width: "5%", cellClass:'grid-number'},
			      { field: 'cnt',name: "호출 건수",width: "12%", cellClass:'grid-number', type:'numberStr'},
			      { field: 'errorCnt',name: "오류 건수",width: "12%", cellClass:'grid-number', type:'numberStr' },
			      { field: 'maxElap',name: "최대 응답시간(s)",width: "12%", cellClass:'grid-number', type:'numberStr'},
			      { field: 'avgElap',name: "평균 응답시간(s)",width: "12%", cellClass:'grid-number', type:'numberStr' },
			      { field: 'txt',name: "SQL문",width: "*" }
			    ];
			$scope.title_name = "SQL";
		}else if(selectCode=="3"){
			$scope.gridOptions.columnDefs =
				[
	  			  { field: 'no', name: "no",width: "5%", cellClass:'grid-number'},
			      { field: 'cnt',name: "호출 건수",width: "12%", cellClass:'grid-number', type:'numberStr'},
			      { field: 'errorCnt',name: "오류 건수",width: "12%", cellClass:'grid-number', type:'numberStr' },
			      { field: 'maxElap',name: "최대 응답시간(s)",width: "12%", cellClass:'grid-number', type:'numberStr'},
			      { field: 'avgElap',name: "평균 응답시간(s)",width: "12%", cellClass:'grid-number', type:'numberStr' },
			      { field: 'txt',name: "애플리케이션명",width: "*" }
			    ];
			$scope.title_name = "API CALL";
		}else if(selectCode=="4"){
			$scope.gridOptions.columnDefs =
				[
	  			  { field: 'no', name: "no",width: "5%", cellClass:'grid-number'},
			      { field: 'cnt',name: "발생 건수",width: "20%", cellClass:'grid-number', type:'numberStr'},
			      { field: 'txt',name: "예외/오류명",width: "*" }
			    ];
			$scope.title_name = "예외/오류";
		}
			
							
		$('#ajax-loading').show();
		Data.ajax({url:'stats/selectStatsAnalyze', param:params, successCallback:function(data, status) {
			try {
				if(data) {
					if(data.resultCode == "1"){
	         		//success
						$scope.gridOptions.data = [];
		     			for (var i=0; i<data.statsAnalyzeList.length; i++) {
		     				var obj = data.statsAnalyzeList[i];
		     				obj.no = i+1;
		     				obj.statsDt = Common.formatNumber(obj.statsDt);
		     				obj.cnt = Common.formatNumber(obj.cnt);
		     				obj.errorCnt = Common.formatNumber(obj.errorCnt);
		     				obj.maxElap = Common.formatNumber(obj.maxElap);
		     				obj.sumElap = Common.formatNumber(obj.sumElap);
		     				obj.avgElap = Common.formatNumber(obj.avgElap);
		     				obj.sumCpu = Common.formatNumber(obj.sumCpu);
		     				obj.avgCpu = Common.formatNumber(obj.avgCpu);
		     				obj.sumMem = Common.formatNumber(obj.sumMem);
		     				obj.avgMem = Common.formatNumber(obj.avgMem);
		     				$scope.gridOptions.data.push(obj);
		     				
		     			}
		     			$timeout(function() {
		     				// 최초 실행 시 첫 Row 선택
		     				if($scope.gridApi.selection.selectRow){
		     				  $scope.gridApi.selection.selectRow($scope.gridOptions.data[0]);
		     				}
		     			});
		     			
		     			/********** ui-grid custom 페이징 **********/ 
		     			Paginator.setScope($scope);
		     			$scope.paging = function(page) {			     				
		     				Paginator.setPage(page);
		     			}			     			
		     			$scope.paging(1); // 1페이지
		     			/********** // ui-grid custom 페이징 **********/
	     			}else{
						Common.alertDialog("오류", data.resultMsg);
					}
				} 
				$('#ajax-loading').hide();
				
			} 
			catch(ex) {
				$('#ajax-loading').hide();
			}
		}});
			
    } 
    
    // 상세내역 엑셀 저장
	$scope.exportExcelBtnHandler = function () {
		var url = '/stats/excelExportStatsAnalyze';
		var fileNm = null;
		var title = null;
		var target = $scope.searchOptions.selectCode;
		var exid = target;
		var currentDay = {yyyymmdd : Common.getToday().replace(/\//g,'-')};
		var startYm = $scope.startYm.yyyymm.substr(0,7).replace(/\//g,'-');
    	
		if(target == "1") {
			fileNm = "애플리케이션_성능비중순.xls";
			title = "애플리케이션 성능 비중순";
		} else if (target == "2") {
			fileNm = "SQL_성능비중순.xls";
			title = "SQL 성능 비중순";
		} else if (target == "3") {
			fileNm = "API_CALL_성능비중순.xls";
			title = "API CALL 성능 비중순";
		} else if (target == "4") {
			fileNm = "예외_오류_비중순.xls";
			title = "예외/오류 비중순";
		} else {				
			return;
		}
    	
		
    	if(target == "1" || target == "2" || target == "3" || target == "4"){
    		if($scope.gridOptions.data < 1){
    			Common.alertDialog(title, "조회된 데이터가 없습니다.");
				return;
    		}
    	}
    	
		if(url !==null && fileNm !== null) {
			if ($scope.selectedAgentIds.length > 0) {
				var oid =$scope.selectedAgentIds.toString(',');
				var startDt = $scope.startDt;
				var endDt = $scope.endDt;					
				var selectCode = $scope.searchOptions.selectCode;
				var searchText = $scope.searchText || "";					
				var object = {oid: oid, exid: exid, currentDay: currentDay, startYm:startYm, startDt: startDt, endDt: endDt, selectCode: selectCode, searchText: searchText};					
			    Data.fileDownload(url, object, fileNm);
			} else {
				Common.alertDialog("에이전트 미선택", "에이전트가 선택되지 않았습니다.");
			}
		} 
	};
	
	// 에이전트 선택 시
	$scope.selectAgent = function(node) {
     	var currentSelected = node.data.selected;
 		if (!currentSelected) {
 			$scope.agentTree.select(node.index);
 		};
 		
 		if (node.children.length > 0) {    			
 			for (var i=0; i<node.children.length; i++) {
 				$scope.selectAgent(node.children[i]);	
     		}    					
 		}; 
 	};
 	// 에이전트 미 선택 시
 	$scope.unSelectAgent = function(node) {
 		var currentSelected = node.data.selected;
 		if (currentSelected) {
 			$scope.agentTree.select(node.index);
 		};
 		
 		if (node.children.length > 0) {    			
 			for (var i=0; i<node.children.length; i++) {
 				$scope.unSelectAgent(node.children[i]);	
     		}    					
 		}; 
 	};
    // 에이전트 변경 시 
 	$scope.changedSelectAgent = function() {
 		var list = $scope.agentTree.listAll();
 		$scope.selectedAgentIds = [];
 		
 		for (var i=0; i<list.length; i++) {
 			var node = list[i];
 			if (node.depth == 3 && node.data.selected == true) {
 				
 				var dupCnt = 0;
 				for(var k=0; k<$scope.selectedAgentIds.length; k++){
 					if($scope.selectedAgentIds[k] == (node.data.obj.svrId + "_" + node.data.obj.nodeId) ){
 						dupCnt = 1;
     					continue;
 					}
 				}
 				if(dupCnt == 0){
     				$scope.selectedAgentIds.push(node.data.obj.svrId + "_" + node.data.obj.nodeId);
 				}
 				
 			}	//if
 		}	//for
 	};
 	
 	// 전체선택
 	$scope.selectAllBtnHandler = function () {
 		ivhTreeviewMgr.selectAll($scope.treeData);
 		$scope.getSelectedNodes($scope.treeData);
     };
     
     // 전체해제
     $scope.unSelectAllBtnHandler = function () {
     	ivhTreeviewMgr.deselectAll($scope.treeData);
     	$scope.getSelectedNodes($scope.treeData);
     };
     
// ===============================================================================
// rest controller <--
// ===============================================================================        
                
// ===============================================================================
// functions -->
// ===============================================================================
 	// 통계내역 더블 클릭 시 팝업창 으로 넘어가는 데이터
     $scope.dblClick = function(row){
     	paramSearch.svcTid = row.entity.svcTid;
     	paramSearch.sqlTid = row.entity.sqlTid;
     	paramSearch.apiTid = row.entity.apiTid;
     	paramSearch.errorTid = row.entity.errorTid;
     	paramSearch.txt = row.entity.txt;
     	paramSearch.startDt = $scope.searchOptions.startDt;
     	paramSearch.endDt = $scope.searchOptions.endDt;
     	paramSearch.oid = $scope.searchOptions.oid;
     	paramSearch.selectCode = $scope.searchOptions.selectCode;
     	window.paramSearch = paramSearch; 
     	
     	var hostindex = location.href.indexOf(location.host) + location.host.length;
     	var serviceBase = location.href.substring(0, location.href.indexOf('/', hostindex + 1)) + "/";
     	var popupX = (window.screen.width/2) - (1280/2);
     	var popupY = (window.screen.height/2) - (810/2);
     	 window.open(serviceBase + "popup.html#/statisticsAnalyzeDtl", "statisticsAnalyzeLarge", "width=1280, height=810, left="+popupX+", top="+popupY);
     }       
       
// ===============================================================================
// functions <--
// ===============================================================================
 // ===============================================================================
 // jui -->
 // ===============================================================================
	//Tree List
    /********** ivh tree **********/
    // ivh tree 에서 사용할 수 있는 형태로 데이터 재가공 (= 공통 사용 위해 ivh-treeview.js 에 함수 정의 replaceTreeData )
    $scope.treeData = ivhTreeviewMgr.replaceTreeData(StorageManager.getAllAgent(), ""); // 아무것도 선택되지 않은 상태로 하기위해 공백 처리
	
    /**
     * Agent 선택 시 실행 함수
     */
    $scope.changeCallback = function(ivhNode, ivhTree) {					
 	   $scope.treeData = ivhTree; // 트리 데이터 갱신
 	   $scope.getSelectedNodes(ivhTree);		    
    };
 		
    /**
     * 포맷에 맞게 조회 시 데이터를 넘겨주기위해 선택된 노드 가공 ($scope.selectedAgentIds)
     */
    $scope.getSelectedNodes = function(tree) {
    	var nodesToSelect = [], done = false;
    	ivhTreeviewBfs(tree, function(node) {
			if (done) {
				return false;
			}				
			if (!node.children) {
				if (node.selected) {
					nodesToSelect.push(node);
				}				
			}				
			return !done;
    	});
    	// select
    	var ivhSelectedAgent = new Array();	
    	if (nodesToSelect.length > 0) {				    		   
    		for (var i=0; i<nodesToSelect.length; i++) {
    			ivhSelectedAgent.push(nodesToSelect[i].svrId + "_" + nodesToSelect[i].id);    			   
			}
    	}    	       	   
    	$scope.selectedAgentIds = ivhSelectedAgent;
    }
 		
    if ($rootScope.ivhGroupFlag) {
    	// groupList Bar 에서 그룹을 선택한 경우 Tree Select 변경
    	$scope.changeCallback($rootScope.ivhGroupSelected, $scope.treeData);
    	$rootScope.ivhGroupFlag = false;
    }		
        /********** //ivh tree **********/
        
 // ===============================================================================
 // jui <--
 // ===============================================================================        
    
//===============================================================================
// alertDialog -->
//===============================================================================
    //txt 상세정보 
  	$scope.openAlertDialog = function(title, txt) {
  		var selectedData = { title: title, txt: txt };
		
		$mdDialog.show({
			controller: $scope.alertDialogController,
			templateUrl: 'views/modal/alertDialog.html',
			parent: angular.element(document.getElementById("wrap")),
			targetEvent: event,
			clickOutsideToClose:true,
			locals : {
				selectedData : selectedData
			}
		}).then(function(formData) {
        	
        }, function() {
        	//close modal
        });
  					
  	};

  	$scope.alertDialogController = function($scope, $mdDialog, $timeout, Common, Data, selectedData) {
  		//variables
  		$scope.formData = {title:"", txt:""};
  		$scope.formData = selectedData;
      	
  		$(document).ready(function() {
  			$(".list-box").mCustomScrollbar();
  			$scope.init();
        	});
  	      	
  		$scope.init = function() {    
  		};

  		$scope.cancel = function() {        	       	        
  			$mdDialog.cancel();
  		};
  	}; //alertDialogController
		  	
//===============================================================================
// <-- alertDialog
//===============================================================================	
}); //controller