'use strict';
angular.module('mainApp')
    .controller('SignupCtrl', function ($scope, $rootScope, $location, Data, Common) {
// ===============================================================================
// initialize -->
// ===============================================================================
    	$scope.signup = {};
        $scope.serviceList = [];
        $scope.ready = function () {
            //loading or transition
        };

        $(document).ready(function() {
			$(".list-box").mCustomScrollbar();
        	
            $scope.init();
        });

        $scope.init = function() {
        	$scope.imageUrl = $rootScope.appImageLogoUrl;
        	$scope.apmNm = $rootScope.appName;
        	$scope.signup = {userId:"", userNm:"", deptNm:"", telNo:"", email:""};
        	$scope.getRegUserDate();
        };

// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// signup -->
// ===============================================================================
        $scope.gotoLogin = function () { 
        	$location.path('/login');
        };  
        
        $scope.btnFlag = true;
        $scope.doSignup = function (signForm) {
        	
        	var userInfo = signForm.$$success.required;
        	$scope.btnFlag = false;
        	var userId = signForm.userId.$modelValue;
        	var userNm = signForm.userNm.$modelValue;   
        	var deptNm = signForm.deptNm.$modelValue;
        	var phone = signForm.telNo.$modelValue;
        	var email = signForm.email.$modelValue;
        	
        	
        	var serviceList = "";
        	for (var i=0; i<$scope.serviceList.length; i++) {
        		if ($scope.serviceList[i].selected) {
        			serviceList += $scope.serviceList[i].nodeGroupId + ",";
        		}
        	};

        	if($rootScope.connectMode != 'kt'){
        		if(!$scope.validation(userInfo)){
            		$scope.btnFlag = true;
            		return;
            	}
        	}
        	
        	
        	if (serviceList == ""){
        		$scope.btnFlag = true;
        		Common.alertDialog("권한신청", "서비스 항목을 선택하여 주십시요");
        		return;
        	}
        	
        	var params = {userId:userId, userNm:userNm, deptNm:deptNm, svcGrpList:serviceList, email:email, phone:phone};
        	Data.ajax({url:'init/insertUser', param:params, successCallback:function(data, status) {
        		try {
        			if(data) {
	                	if (data.result == "1") {
	                		Common.alertDialog("권한신청", "권한신청 하였습니다.");
	                		$location.path('/login');
	                		//success
	                		$scope.btnFlag = true;
	                	} else {
	                		Common.alertDialog("오류", data.resultMsg);
	                		$scope.btnFlag = true
	                	}
        			}
        		} catch(ex) {
        			
        		}
        	}});
        };
        
        
        $scope.getRegUserDate = function () {    
        	Data.ajax({url:'init/selectRegUserInfo', successCallback:function(data, status) {
        		try {
        			if(data) {
	            		if (data.result == "1") {
	            			if($rootScope.connectMode == 'kt'){
	            				$scope.signup.userId = data.regUserInfo.userId;
		                        $scope.signup.userNm = data.regUserInfo.userNm;
		                        $scope.signup.deptNm = data.regUserInfo.deptNm;
		                        $scope.signup.telNo = data.regUserInfo.phone;
		                        $scope.signup.email = data.regUserInfo.email;
		                        $scope.connectMode = data.regUserInfo.connectMode;
	            			}
	                        
		            		if (data.nodeGroups.length > 0) {
		            			for (var i=0; i< data.nodeGroups.length; i++) {
		            				$scope.serviceList.push({nodeGroupId:data.nodeGroups[i].nodeGroupId, nodeGroupNm: data.nodeGroups[i].nodeGroupNm, selected: false});	
		            			};
		                	}
	            		} else {
	                		Common.alertDialog("오류", data.resultMsg);
	                	}
        			}
        		} catch(ex) {}
        	}});
        };
        

        $scope.validation = function (userInfo) {
    		for (var i = 0; i < userInfo.length; i++) {
    			var key = userInfo[i].$name;
    			var value = userInfo[i].$modelValue;
    			var valid = userInfo[i].$valid;
    			var name = "";
    			
    			if(key == "userId"){
    				name = "사용자ID";
    			} else if(key == "userNm"){
    				name = "사용자명";
    			} else if(key == "deptNm"){
    				name = "소속";
    			} else if(key == "telNo"){
    				name = "휴대폰";
    			} else if(key == "email"){
    				name = "이메일";
    			}
    			
    			if(!valid){
    				if(key == "telNo"){
    					Common.alertDialog("알림", name + "의 양식을 확인해주세요.<br>예) 010-1234-1234");
    				}else if(key == "email"){
    					Common.alertDialog("알림", name + "의 양식을 확인해주세요.<br>예) user@email.com");
    				}else{
    					Common.alertDialog("알림", name + "의 양식을 확인해주세요.");
    				}
    				
    				
    				return;
    			}
    			
    			if(value==""){
    				Common.alertDialog("알림", name + "를 입력하세요.");
    				return;
    			}
    		
    		}
    		return true;
        }
        
        
// ===============================================================================
// <-- signup
// ===============================================================================
    });//controller

