'use strict';
angular.module('mainApp')
.controller('TopologyCtrl', function ($route, $scope, $rootScope, $interval, $timeout, $log, $mdDialog, Data, Common, StorageManager, WidgetInfoManager) {
// ===============================================================================
// initialize -->
// ===============================================================================
	$rootScope.$watch("networkConnected", function(newVal, oldVal) {
	   	if (newVal !== oldVal) { 
	   		var bool = newVal;
	   		if (!bool) {
	   			fnStopInterval();	   			
	   		} else {
	   			fnResetWorker();
	   		}	   		
		};
    });
	
	var myDashboardId = 1;
	var isLoadDataInterval;
	var ajaxLoadDataEnd = true;
	//dashBoard widget 
	var chartTopologyView = undefined;	
	var chartRealTimeHeapMemory = undefined;
	var chartRealTimeDbCounter = undefined;
	var chartRealTimeSystemCPUEQ = undefined;
	var chartRealTimeActiveServiceEQ = undefined;
	
	//variables	
	var isReady = false;
	var isResize = false;
	
	$scope.config = {visible : false, setting: false};
	$scope.dashboard = {};
	
	$scope.gridsterOptions = {
		margins : [ 10, 10 ],
		columns : 9
	};
	
	$(document).ready(function(){
		$("html").css("background-color", "#151b25"); 
		
    	$scope.userTyp = $rootScope.userInfo.userTyp;
        if($scope.userTyp != "user"){
        	var html = '<a class="dropdown-button" data-activates="settings">구성관리<i class="material-icons right">arrow_drop_down</i></a>';
        	$("#settingsTag").html(html);
        }
        
        $scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;

		$(".dropdown-button").dropdown();				
		fnInit();
	});
	
	angular.element(window).on('resize', function(e) {
		if (isResize) { return;}
		isResize = true;
		$timeout(function() {
			fnResizeDashboard();
			isResize = false;
		}, 200)		
	});

	$scope.$on('gridster-resized', function(gridster, size) {		
		if (isResize) { return;}
		isResize = true;
		$timeout(function() {
			fnResizeDashboard();
			isResize = false;
		}, 200)
	});
	
	$scope.$on('$destroy', function() {
		fnStopInterval();
		$scope.removeDashboard();
	});
	
	$scope.toggleSetting = function() {
		$scope.config.setting = !$scope.config.setting;
		$scope.config.visible = !$scope.config.setting;
		if ($scope.config.visible) {
			//grid 패널이 하단 버튼을 덮는 문제로 리로드 필요함.!
			$route.reload();
		};
	};
	
	$scope.selectGroup = function (group) {
		if ($rootScope.selectedGroup.id == group.nodeGroupId) {return; }
		
		if (group.serverList.length==0) { 
			alert('하위 에이전트가 없습니다.');
			return; 
		}
		
		if (chartRealTimeHeapMemory != undefined) {
			chartRealTimeHeapMemory.reset();
		}
		
		if (chartRealTimeActiveServiceEQ != undefined) {
			chartRealTimeActiveServiceEQ.reset();
		}
		
		if (chartRealTimeSystemCPUEQ != undefined) {
			chartRealTimeSystemCPUEQ.reset();
		}
		
		if (chartRealTimeDbCounter != undefined) {
			chartRealTimeDbCounter.reset();
		}
		
		if (chartTopologyView != undefined) {
			chartTopologyView.reset();
		}
		
		var obj = {id: group.nodeGroupId, name: group.nodeGroupNm};
		var selectedGroup = obj;
			selectedGroup.selectedAgent = [];
			
		for (var i=0; i<group.serverList.length; i++) {
			var server =  group.serverList[i];
			for (var j=0; j<server.nodeList.length; j++) {
				var node = server.nodeList[j];				
				selectedGroup.selectedAgent.push({id:node.nodeId, name:node.nodeNm, svrId:node.svrId});
			}
		};
		
		StorageManager.clearSelectedGroup();
		StorageManager.setSelectedGroup(selectedGroup);
		$rootScope.selectedGroup = StorageManager.getSelectedGroup();		
    	fnResetWorker();    	
    };
// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// rest controller -->
// ===============================================================================	
    function fnLoadDataSearch(params){
    	if (params.PAST != 1){
	    	if (!$scope.config.visible){
	    		return;
	    	}
	    	if (isLoadDataInterval == undefined){
	    		return;
	    	}
	    	if (ajaxLoadDataEnd == false){
	    		return;
	    	}
    	}
    	ajaxLoadDataEnd = false;
    	
		Data.ajax({url:'dashBoard/topologyData', param:params, errorCallback:$scope.errorCallback, successCallback:function(data, status) {
			try {
				ajaxLoadDataEnd = true;
				if(data) {
					if ($rootScope.selectedGroup.id != data.nodeGroupId){
						return;
					}
					
					if (data.topologyList != null && data.topologyList != undefined){
						fnSetTopology(data.topologyList);
					}
					
					if (data.realtimeGraphs != null && data.realtimeGraphs != undefined){
						fnSetRealtimeGraph(data.realtimeGraphs);
					}
					
					if (data.groupExceptionCounter.groupResults != null && data.groupExceptionCounter.groupResults != undefined){
						fnSetGroupStatus(data.groupExceptionCounter);
					}
					
				}
			} catch(ex) {}
		}});
    }
// ===============================================================================
// rest controller <--
// ===============================================================================

// ===============================================================================
// functions -->
// ===============================================================================
    function fnSetRealtimeGraph(data) {        	
		for (var i=0; i<data.length; i++) {
			switch (data[i].key) {				
				case "RealActiveService":
					if (chartRealTimeActiveServiceEQ != undefined) {
						chartRealTimeActiveServiceEQ.update(data[i].values);
					}        					
					break;				
				case "HeapUsed":
					if (chartRealTimeHeapMemory != undefined) {
						chartRealTimeHeapMemory.update(data[i].values);
					} 
					
					break;
				case "CompCpu":
					if (chartRealTimeSystemCPUEQ != undefined) {
						chartRealTimeSystemCPUEQ.update(data[i].values);
					}
					
					break;
				case "ConDBConnect":
					if (chartRealTimeDbCounter != undefined) {
						chartRealTimeDbCounter.update(data[i].values);
					}
					break;									
			}
		}        	
	};
		
	function fnSetTopology(data) {
		
		if (data == undefined || data == null || data.length == 0){
			return;
		}
		
		if (chartTopologyView != undefined) {
			var param = {
					groupId : $rootScope.selectedGroup.id,
					groupName : $rootScope.selectedGroup.name,
					list : data
			}
			
			chartTopologyView.update(param);
		}
	};
	
	function fnSetGroupStatus(data) {
		for (var i=0; i<data.groupResults.length; i++) {
			for (var j=0; j<$rootScope.allAgent.length; j++) {
				if (data.groupResults[i].nodeGroupId == $rootScope.allAgent[j].nodeGroupId) {
					$rootScope.allAgent[j].nodeStatus = data.groupResults[i].nodeStatus; 
				}
			};
		}
	};
	
	function fnInit() {
		$scope.userTyp = $rootScope.userInfo.userTyp;
        $scope.connectMode = $rootScope.userInfo.connectMode;
		
		$timeout(function() {
				isReady = true;
				$scope.config.visible = true;
			}, 200);
		
		$timeout(function() {
			$("#groupList").slick({
				slidesToScroll: 5,
				variableWidth: true,
				infinite:false
			});
		}, 1000);
		
		$scope.$watch('config.visible', function(bool){
			if (!isReady){
				return;
			}
			
			if (!bool) {
				//서버연동 일시중지
				//fnStopInterval();
				$scope.gridsterOptions = {
						margins : [ 10, 10 ],
						columns : 9,
						draggable : {
							enabled : true,
							handle : 'h3',
							start : function(event, $element, widget) {
							},
							stop : function(event, $element, widget) {
								$timeout(function() {
									if (widget.component){
										widget.component.resize();
									}
								}, 400)
							}
						},
						resizable : {
							enabled : true,
							//handles : [ 'n', 'e', 's', 'w', 'ne', 'se', 'sw', 'nw' ],
							start : function(event, $element, widget) {
							},
							resize : function(event, $element, widget) {
								if (widget.component){
									widget.component.resize();
								}
							},
							stop : function(event, $element, widget) {
								$timeout(function() {
									if (widget.component){
										widget.component.resize();
									}
								}, 400)
							}
						},
					};
			} else {
				//대시보드 gridster depth 문제로 인해 page reload가 필요함.
				$scope.gridsterOptions = {
						margins : [ 10, 10 ],
						columns : 9,
						draggable : { enabled : false },
						resizable : { enabled : false },
					};
			}
		}, true);
		
		fnCreateDashboard();	
		
		if (StorageManager.getAllAgent() != undefined && StorageManager.getAllAgent() != null) {
			$rootScope.allAgent = StorageManager.getAllAgent();			
		};
		
		if (StorageManager.getSelectedGroup() != undefined && StorageManager.getSelectedGroup() != null) {
			$rootScope.selectedGroup = StorageManager.getSelectedGroup();		
		} else {
			//선택된 그룹이 없을 경우 가장 처음그룹으로 자동선택
			var b = false;
			var allAgent = $rootScope.allAgent;
			for (var i = 0; i < allAgent.length; i++) {
				if(0 < allAgent[i].serverList.length){
					$scope.selectGroup(allAgent[i]);
					b=true;
					break;
				}
			}
			if(!b){
				$rootScope.selectedGroup = {};
				$rootScope.selectedGroup.selectedAgent = [];
				$scope.openAgentList();
			}
			return;
		};
		
		//play worker
		if ($rootScope.selectedGroup.selectedAgent.length > 0) {
			fnResetWorker();			
		} else {			
			//선택된 그룹이 없을 경우 가장 처음그룹으로 자동선택
			var b = false;
			var allAgent = $rootScope.allAgent;
			for (var i = 0; i < allAgent.length; i++) {
				if(0 < allAgent[i].serverList.length){
					$scope.selectGroup(allAgent[i]);
					b = true;
					break;
				}
			}
			if(!b){
				$rootScope.selectedGroup.selectedAgent = [];
				$scope.openAgentList();
			}
			return;
		};
		//get topology
	};	
	

	function fnStartInterval() {
		$scope.firstStart = true;
		
		if (angular.isDefined(isLoadDataInterval)){
        	return;
        }
    	
		$rootScope.groupIds = [];
    	for (var i=0; i<$rootScope.allAgent.length; i++) {
    		$rootScope.groupIds.push($rootScope.allAgent[i].nodeGroupId);
    	}
    	
    	$rootScope.selectedAgentIds = [];
    	for (var i=0; i<$rootScope.selectedGroup.selectedAgent.length; i++) {
    		var agentId = $rootScope.selectedGroup.selectedAgent[i].svrId + "_" + $rootScope.selectedGroup.selectedAgent[i].id;
    		$rootScope.selectedAgentIds.push(agentId);	
    	};
    	
		var past = 0;

    	if ($scope.firstStart == true){
			past = 1;
		}
    	
    	var params = {
    					oid:$rootScope.selectedAgentIds.toString(','), 
    					type:"svc",
    					nodeGroupId: $rootScope.selectedGroup.id,
    					PAST: past
    	}
    	
    	if ($scope.firstStart == true){
    		fnLoadDataSearch(params);
    	}
    	
    	params.PAST = 0;
    	
        isLoadDataInterval = $interval(function() {
        	fnLoadDataSearch(params);    	
        }, 5000);
    };
    
    function fnStopInterval() {
    	if (angular.isDefined(isLoadDataInterval)) {
            $interval.cancel(isLoadDataInterval);
            isLoadDataInterval = undefined;
        }	
    };
    
	function fnResizeDashboard() {
		if ($scope.dashboard.widgets == undefined) { return; }
		if ($scope.dashboard.widgets.length > 0) {
			for (var i=0; i<$scope.dashboard.widgets.length; i++) {
				if ($scope.dashboard.widgets[i].component != null) {
					$scope.dashboard.widgets[i].component.resize();
				}
			}
		};
	};
	
	$scope.removeDashboard = function() {	
		if ($scope.dashboard.widgets == undefined) { return; }
		if ($scope.dashboard.widgets.length > 0) {
			for (var i=0; i<$scope.dashboard.widgets.length; i++) {
				if ($scope.dashboard.widgets[i].component != null) {
					$scope.dashboard.widgets[i].component.remove();
				}
			}
		}
		$scope.dashboard = {};
	};
	
	function fnCreateDashboard() {
		$scope.dashboard = angular.copy($rootScope.myDashboards[myDashboardId]) ; //create Dom
		$scope.widgetCount = $scope.dashboard.widgets.length;
		$scope.dashboard.widgets = fnCreateWidgets($scope.dashboard.widgets);
		
		$scope.$watch('dashboard.widgets', function(items) {
			var tempWidgets = [];
			for (var i=0; i<items.length; i++) {
				tempWidgets[i] = {
					id: items[i].id,
					elementId:items[i].elementId,
					col: items[i].col,
					row: items[i].row,
					sizeX: items[i].sizeX,
					sizeY: items[i].sizeY,
					type: items[i].type,
				}
			};		
			
			tempWidgets = objSorting("row", tempWidgets);
			
			$rootScope.myDashboards[myDashboardId].widgets = tempWidgets;
			StorageManager.setMyDashboards($rootScope.myDashboards);
		}, true);
	};
	
	function objSorting(sortingField, items) {
		items.sort(function (a, b) {
			return a[sortingField] - b[sortingField];
		});
		return items;
	};
	
	
	function fnCreateWidgets(widgets) {		
		var tempWidgets = [];
		for (var i=0; i<widgets.length; i++) {
			var tempWidget = angular.copy(widgets[i]);
			var widgetInfo = WidgetInfoManager.getWidgetInfo(tempWidget.id);
		
			tempWidget.elementId = "id_"+ myDashboardId + "_" + i;
			tempWidget.title = widgetInfo.title;
			tempWidget.type = widgetInfo.type;

			if (tempWidget.type == "RealTimeDBCounter") { 
	        	tempWidget.component = 
	        		new RealTimeDBCounter(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	chartRealTimeDbCounter = tempWidget.component;
			}else if (tempWidget.type == "RealTimeActiveServiceEQ") { 
	        	tempWidget.component = 
	        		new RealTimeActiveServiceEQ(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	chartRealTimeActiveServiceEQ = tempWidget.component;	        	        
	        } else if (tempWidget.type == "RealTimeSystemCPUEQ") { 
	        	tempWidget.component = 
	        		new RealTimeSystemCPUEQ(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	chartRealTimeSystemCPUEQ = tempWidget.component;
	        } else if (tempWidget.type == "RealTimeHeapMemory") { 
	        	tempWidget.component = 
	        		new RealTimeHeapMemory(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0);
	        	chartRealTimeHeapMemory = tempWidget.component;	        
	        } else if (tempWidget.type == "TopologyView") { 
	        	tempWidget.component = 
	        		new TopologyView(tempWidget.elementId, $scope, $rootScope, $interval, Data, 0, $timeout);
	        	chartTopologyView = tempWidget.component;
	        };
	        tempWidgets.push(tempWidget);
		}
		return tempWidgets;
	};

    function fnResetWorker(){
    	if (Object.keys($rootScope.selectedGroup).length === 0) {
    		return;
    	};
    	
    	if ($rootScope.selectedGroup.selectedAgent.length === 0) {
    		return;
    	};
    	
    	fnStopInterval();
    	
		fnStartInterval();
    };
    

// ===============================================================================
// functions <--
// ===============================================================================
    
//===============================================================================
// Modal, Popup -->
//===============================================================================
    $scope.openMenu = function($mdOpenMenu, ev) {
        var originatorEv = ev;
        $mdOpenMenu(ev);
    };
    
    $scope.openPopup = function(type, num) {
    	var hostindex = location.href.indexOf(location.host) + location.host.length;
    	var serviceBase = location.href.substring(0, location.href.indexOf('/', hostindex + 1)) + "/";
    	
    	var popupX = (window.screen.width/2) - (1280/2);
    	var popupY = (window.screen.height/2) - (720/2);
    	var widgetType = type;    	
    	if (widgetType == "RealTimeHeapMemory") {
    		$scope.openHeapMemoryPopup(serviceBase, popupX, popupY); 
    	} else if (widgetType == "RealTimeDBCounter") {
    		$scope.openDBCounterPopup(serviceBase, popupX, popupY); 
    	}
    };
    
    $scope.openHeapMemoryPopup = function(serviceBase, popupX, popupY) {
        window.open(serviceBase + "popup.html#/heapmemory_large", "popup_heap_memory", "width=1280, height=720, left="+popupX+", top="+popupY);
    };
    
    $scope.openDBCounterPopup = function(serviceBase, popupX, popupY) {
        window.open(serviceBase + "popup.html#/dbcounter_large", "popup_db_counter", "width=1280, height=720, left="+popupX+", top="+popupY);
    };
    
//===============================================================================
// <-- Modal, Popup
//===============================================================================
//===============================================================================
// Agent List -->
//===============================================================================
    $scope.openAgentList = function() {
    	//서버연동 일시중지
        $mdDialog.show({
            controller: $scope.agentListController,
            templateUrl: 'views/modal/agentList.html',
            parent: angular.element(document.getElementById("wrap")),
            targetEvent: event,
            clickOutsideToClose:true,
        }).then(function(selectedGroup) {
            	StorageManager.clearSelectedGroup();
        		StorageManager.setSelectedGroup(selectedGroup);
        		$rootScope.selectedGroup = StorageManager.getSelectedGroup();    		
        		fnResetWorker();
        	//};        
        }, function() {
            //$scope.status = "cancel";
        });
    };
    
    $scope.agentListController = function($scope, $rootScope, $timeout, $mdDialog, StorageManager, ivhTreeviewBfs, ivhTreeviewMgr) {    	
    	$scope.agentTreeCreated = false;
	    $scope.agentTree = undefined;	    
	    $scope.selectedGroupNode = {};
	    $scope.selectedGroup = $rootScope.selectedGroup;	    
	    
	    $scope.instanceName = "";
		$scope.applicationVersion = "";
		$scope.javaVersion = "";
		$scope.serverVersion = "";
		$scope.hostName = "";
		$scope.serverName = "";
		$scope.serviceName = "";
		$scope.expirationDate = "";
		$scope.nodeStatus = "";
				
		/********** ivh tree **********/
		// ivh tree 에서 사용할 수 있는 형태로 데이터 재가공 (= 공통 사용 위해 ivh-treeview.js 에 함수 정의 replaceTreeData )		
		if (typeof $rootScope.ivhTreeData !== "undefined") {
			$scope.treeData = $rootScope.ivhTreeData;
		} else {
			// 최초 한번만 기본 트리 데이터 생성
			$scope.treeData = ivhTreeviewMgr.replaceTreeData(StorageManager.getAllAgent(), $rootScope.selectedGroup.id);			
		}
		
	    $scope.agentTree = $scope.treeData;
	    /**
	     * Agent 선택 후 조회 or 상단 바에서 Agent그룹을 선택한경우 실행 함수
	     */
	    $scope.changeCallback = function(ivhNode, ivhTree) {
			var execFlag = false;				
			for (var i = 0; i < ivhTree.length; i++) {			
				if (ivhNode.nodeGroupId == ivhTree[i].nodeGroupId && !execFlag) {					
					// 현재 선택된 그룹					
					if ($rootScope.ivhGroupFlag) {
						// groupList Bar 에서 그룹을 선택한 경우에만 실행
						ivhTreeviewMgr.select(ivhTree, ivhTree[i]);						
					}
					$scope.ivhLastGroupIndex = i;
					execFlag = true;						
				} else {
					// 현재 선택된 그룹이 아니면 un select
					ivhTreeviewMgr.deselect(ivhTree, ivhTree[i]);
				}					
			}
		
			$scope.treeData = ivhTree; // 트리 데이터 갱신
			$rootScope.ivhTreeData = ivhTree;
			fnGetSelectedNodes(ivhTree);		    
		};
		
		/**
		 * 포맷에 맞게 조회 시 데이터를 넘겨주기위해 선택된 노드 가공 ($scope.selectedGroup)
		 */
		function fnGetSelectedNodes(tree) {
			var nodesToSelect = [], done = false;

			ivhTreeviewBfs(tree, function(node) {
				if (done) {
					return false;
				}				
				if (!node.children) {
					if (node.selected) {
						nodesToSelect.push(node);
					}				
				}				
				return !done;
			});
			// select
			var ivhSelectedAgent = {};	
			if (nodesToSelect.length > 0) {				
				ivhSelectedAgent = {id:nodesToSelect[0].nodeGroupId, name:nodesToSelect[0].agentGroupNm, selectedAgent:nodesToSelect};				
			}

			$scope.selectedGroup = ivhSelectedAgent;			
		}
		
		if ($rootScope.ivhGroupFlag) {
			// groupList Bar 에서 그룹을 선택한 경우 Tree Select 변경
			$scope.changeCallback($rootScope.ivhGroupSelected, $scope.treeData);
			$rootScope.ivhGroupFlag = false;
		}		
	    /********** //ivh tree **********/
		
    	$(document).ready(function(){
            $(".agent-list-box").mCustomScrollbar();
                        
    	});
    	    	
    	
    	$scope.selectAgent = function(node) {
        	var currentSelected = node.data.selected;
    		if (!currentSelected) {    			
    			if (node.depth == 1) {
    				//그룹선택    				
    				$scope.unSelectAll();
    				$scope.selectedGroupNode = node;
    				
    			} else if (node.depth == 2) {
    				//호스트 선택   
    				if (Object.keys($scope.selectedGroupNode).length === 0) {
        				//선택된 그룹이 없다.
    					$scope.selectedGroupNode = node.parent;
    					$scope.agentTree.select(node.parent.index);
    				} else {
    					if (node.parent.data.id == $scope.selectedGroupNode.data.id) {
        					//같은 그룹 내에서 선택
        					if (!node.parent.data.selected) {
        						$scope.agentTree.select(node.parent.index);	
        					};
        					
        				} else {
        					//다른 그룹 선택    					
        					$scope.unSelectAll();
        					$scope.selectedGroupNode = node.parent;
        					$scope.agentTree.select(node.parent.index);
        				};	
    				};
    				
    			} else {    				
    				//에이전트 선택    				
    				//선택된 그룹이 없다.
    				if (Object.keys($scope.selectedGroupNode).length === 0) {
        				//선택된 그룹이 없다.
    					$scope.selectedGroupNode = node.parent.parent;
    					$scope.agentTree.select(node.parent.parent.index);
    					$scope.agentTree.select(node.parent.index);
    				} else if (node.depth == 3) {
    					if (node.parent.parent.data.id == $scope.selectedGroupNode.data.id) {
        					//같은 그룹 내에서 선택
        					if (!node.parent.parent.data.selected) {
        						$scope.agentTree.select(node.parent.parent.index);	
        					};
        					
        					if (!node.parent.data.selected) {
        						$scope.agentTree.select(node.parent.index);	
        					};
        					
        				} else {
        					//다른 그룹 선택
        					$scope.unSelectAll();
        					$scope.selectedGroupNode = node.parent.parent;					
        					$scope.agentTree.select(node.parent.parent.index);
        					$scope.agentTree.select(node.parent.index);
        				};	
    				};
    			};
    			
    			$scope.agentTree.select(node.index); 
    			
    			if (node.children.length > 0) {    			
        			for (var i=0; i<node.children.length; i++) {
        				$scope.selectChild(node.children[i]);	
            		}    					
        		};
    		};
    	};
    	
    	$scope.unSelectAgent = function(node) {
    		var currentSelected = node.data.selected;
    		if (currentSelected) {
    			if (node.depth == 1) {
    				//그룹 선택 해제
    				$scope.selectedGroupNode = {};
    			} else if (node.depth == 2) {
    				//호스트 선택 해제
    				//다른 선택된 호스트가 그룹내에 있는지 체크
    				var check = false;
    				for (var i=0; i<node.parent.children.length; i++) {
    					if (node.parent.children[i].data.selected && node.parent.children[i].data.id != node.data.id) {
    						//다른 선택된 호스트가 있음.
    						check = true;
    					}
    				};
    				
    				if (!check) {
    					//그룹 선택 해제
    					$scope.agentTree.select(node.parent.index);
        				$scope.selectedGroupNode = {};
    				};
    				
    			} else if (node.depth == 3) {
    				//에이전트 선택 해제
    				//다른 선택된 에이전트가 호스트에 있는지 체크
    				var check = false;
    				for (var i=0; i<node.parent.children.length; i++) {
    					if (node.parent.children[i].data.selected && node.parent.children[i].data.id != node.data.id) {
    						//다른 선택된 호스트가 있음.
    						check = true;
    					}
    				}; 
    				
    				if (!check) {
    					//호스트 선택 해제
    					$scope.agentTree.select(node.parent.index);
    					
    					//다른 선택된 호스트가 그룹내에 있는지 체크
    					check = false;
    					for (var i=0; i<node.parent.parent.children.length; i++) {
        					if (node.parent.parent.children[i].data.selected && node.parent.parent.children[i].data.id != node.parent.data.id) {
        						//다른 선택된 호스트가 있음.
        						check = true;
        					}
        				}; 
        				
        				if (!check) {
        					//그룹 선택 해제
        					$scope.agentTree.select(node.parent.parent.index);
            				$scope.selectedGroupNode = {};
        				};
    				};
    			};
    			
    			$scope.agentTree.select(node.index);
    			
    			//unselect child
    			if (node.children.length > 0) {    			
        			for (var i=0; i<node.children.length; i++) {
        				$scope.unSelectChild(node.children[i]);	
            		}    					
        		}; 
    		};
    	};
    	
    	$scope.selectChild = function(node) {
    		var currentSelected = node.data.selected;
    		if (!currentSelected) {
    			$scope.agentTree.select(node.index);    			
    		};
    		if (node.children.length > 0) {    			
    			for (var i=0; i<node.children.length; i++) {
    				$scope.selectChild(node.children[i]);	
        		}    					
    		};
    	};
    	
    	$scope.unSelectChild = function(node) {
    		var currentSelected = node.data.selected;
    		if (currentSelected) {
    			$scope.agentTree.select(node.index);    			
    		};
    		if (node.children.length > 0) {    			
    			for (var i=0; i<node.children.length; i++) {
    				$scope.unSelectChild(node.children[i]);	
        		}    					
    		};
    	};
        
    	$scope.changedSelectAgent = function() {
    		$scope.selectedGroup = {};
    	    $scope.selectedGroup.selectedAgent = [];
    		
    		var treeList = $scope.agentTree.listAll();    		
    		for (var i=0; i<treeList.length; i++) {
    			var node = treeList[i];    			    		
    			
    			if (node.data.selected == true) {
    				//var obj = {index: node.index, title: node.data.title, depth: node.depth, nodeId: node.data.id};
    				var obj = {id: node.data.id, name: node.data.title};
    				
    				if (node.depth == 1) {    					 					
    					$scope.selectedGroup = obj;
    					$scope.selectedGroup.selectedAgent = [];
    				}
    				
    				if (node.depth == 3) {
    					obj.svrId = node.data.obj.svrId;
    					$scope.selectedGroup.selectedAgent.push(obj);
    				}    				
    			};
    		};
    		
    	};
    	
    	$scope.selectAll = function () {
        	var root = $scope.agentTree.get("0").parent;
        	$scope.selectChild(root);
        	$scope.changedSelectAgent();
        };
        
        $scope.unSelectAll = function () {
        	var root = $scope.agentTree.get("0").parent;
        	$scope.unSelectChild(root);
        	$scope.changedSelectAgent();
        };
        
    	$scope.showAgentDetail = function(node) { 
    		$timeout(function() {
    			$scope.instanceName = node.data.obj.nodeNm;
    			$scope.applicationVersion = node.data.obj.appVer;
    			$scope.javaVersion = node.data.obj.javaVer;
    			$scope.serverVersion = node.data.obj.svrVer;
    			$scope.hostName = node.data.obj.hostNm;
    			$scope.serverName = node.data.obj.svrNm;
    			$scope.serviceName = node.data.obj.serviceNm;
    			$scope.expirationDate = node.data.obj.expirationDt;
    			$scope.nodeStatus = node.data.obj.nodeStts;

    			//angular rendering 오류 때문에 적용
    			$scope.$apply();
			}, 200);
    	};
    	
		$scope.answer = function() { 			
			if (Object.keys($scope.selectedGroup).length === 0) {
				alert('그룹이 선택되지 않았습니다.');
			} else {
				if ($scope.selectedGroup.selectedAgent.length==0) {
					alert('에이전트가 선택되지 않았습니다.');
				} else {
					$mdDialog.hide($scope.selectedGroup);		
				};
			};
	    };
       
        $scope.cancel = function() {
        	$mdDialog.cancel();
        };

    };
//===============================================================================
// <-- Agent List
//===============================================================================

    
});//controller