'use strict';
angular.module('popupApp')
.controller('ActiveServiceLargeCtrl', function ($scope, $rootScope, $interval, $timeout, $filter, Data, Common, StorageManager) {
// ===============================================================================
// initialize -->
// ===============================================================================
	//variables	
	$scope.allAgent = [];
	$scope.selectedGroup = {};
	$scope.groupAllAgent = [];	
	$scope.selectedAgent = [];
	
	
	$scope.chart = undefined;
	$scope.chartElement = undefined;	
	$scope.chartData = [];
	
	$scope.today = function () {
    	var date = new Date();
    	var year = date.getFullYear();
    	var month = (1+date.getMonth());
    	month = month>=10? month:'0'+month;
    	var day = date.getDate();
    	day = day>=10? day:'0'+day;
    	return year + '/' + month + '/' + day;
    };	
    
	$scope.searchOptions = {yyyymmdd:$scope.today(), selectedAgent:[], counter: "ActiveService"};
	$scope.isLoading = true;
		
	$scope.resetLayout = function() {
        if ($scope.chart != undefined && $scope.chartElement != undefined) {
        	$scope.resizeChart();
        };              
    };
   
    angular.element(window).on('resize', function(e) {		
		$scope.resetLayout();
    });
	
	$scope.ready = function () {
		$scope.isLoading = false;		
		if (StorageManager.getAllAgent() != undefined && StorageManager.getAllAgent() != null) {
			$scope.allAgent = StorageManager.getAllAgent();
		};
		
		if (StorageManager.getSelectedGroup() != undefined && StorageManager.getSelectedGroup() != null) {
			$scope.selectedGroup = StorageManager.getSelectedGroup();
			$scope.groupAllAgent = [];			
			for (var i=0; i<$scope.allAgent.length; i++) {
    			if ($scope.allAgent[i].nodeGroupId == $scope.selectedGroup.id) {
    				var group = $scope.allAgent[i];
    				for (var j=0; j<group.serverList.length; j++) {
    					var server =  group.serverList[j];
    					for (var k=0; k<server.nodeList.length; k++) {
    						var node = server.nodeList[k];				
    						$scope.groupAllAgent.push({id:node.nodeId, name:node.nodeNm, svrId:node.svrId});
    					}
    				};
    			};
    		};
    		$scope.selectedAgent = $scope.selectedGroup.selectedAgent;
    		$scope.searchOptions.selectedAgent = $scope.selectedAgent;
		};				
    };	
    
    $(document).ready(function(){  
    	$("select").material_select();
    	$scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;
    	$scope.init();
    	$scope.getChartData();
	});
    
    $scope.init = function () {
		$scope.isLoading = false;
		
		$scope.createUIComponent();		
		$scope.createChart();			
    };	
    
    $scope.$on('$destroy', function() {                
    });
        
// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// rest controller -->
// ===============================================================================    
    $scope.getChartData = function() {
    	
    	var selectedAgentIds = [];	    		
		for (var i=0; i<$scope.searchOptions.selectedAgent.length; i++) {
			var param = $scope.searchOptions.selectedAgent[i].svrId + "_" + $scope.searchOptions.selectedAgent[i].id;
			selectedAgentIds.push(param);	
		};
		var split = $scope.searchOptions.yyyymmdd.split('/');
		var yyyymmdd = split.join(''); 
		var params = {oid: selectedAgentIds.toString(','), yyyymmdd: yyyymmdd, counter: $scope.searchOptions.counter};
		
		Data.ajax({url:'dashBoard/loadCounter', param:params, successCallback:function(data, status) {
			try {
				if(data) {
	        		$scope.chartData = [];
	        		if ($scope.chart != undefined) {        			
						$scope.updateChart(data);
					} 
				}
			} catch(ex) {}
		}});	
	};
// ===============================================================================
// rest controller <--
// ===============================================================================
// ===============================================================================
// jui -->
// ===============================================================================
	var style = {
            colors: ["#38c3ff", "#00ceae", "#ff474c", "#ffb500", "#e8e8e8", "#1bbe64", "#98dc08", "#cf0073", "#cf0073", "#576f83"]    
	};
	
	$scope.createUIComponent = function() {
		jui.ready(["ui.property"], function(PropertyView) {			
			var datePicker = new PropertyView("#datePicker", {
	            items:[
	            	{type: 'date', key: 'date-picker'}],
	            event: {
	            	change: function(item, data) {
	            		$scope.searchOptions.yyyymmdd = data; 		
	            	}
	            }
	        });
		});
	};
	
    $scope.createChart = function() {
    	if ($scope.chart != undefined) { return }   
    	$scope.chartElement = angular.element("#chart");    	
	   	var start = new Date(Common.getToday());
	   	var end = new Date(Common.getTomorrow());	   	
    	
    	jui.ready(["chart.builder"], function (juiChart) {
    		$scope.chart = juiChart(("#chart"), {
				padding: { left: 40, top: 22, right: 20, bottom: 62 },	
				height: 555,
				axis: {
	                x: {
	                	type: "dateblock",
				    	domain: [start, end],
				    	interval: 1000*60*60, //1시간
				    	format: function (d, i) {
				    		return i;
				    	}
	                },
	                y: {
	                    type : "range",
	                    domain : [ 0, 100 ],
	                    step : 5,
	                    line: true
	                }	                
	            },			 
	            brush: [{
	                    type: "line",
	                    target: []
	            }],	
	            widget: [
	            	/*{
	            		type: "cross",
	            		xFormat: function(d) {
	            			return Common.time.format(d, "HH:mm:ss");
	            		},
	            		yFormat: function(d) {
	            			return Math.round(d);
	            		}
	            	},*/
	            	{
	            		type : "tooltip",
	            		format : function(k,v){
	            			var key = v;
	            			return key;
	            		}
	            	}
	            ],
	            style: style,
	            format:function(v){
	            	return Common.formatNumber(v);
	            },
	            render: false
	        }); 		
		});
	};
	
	$scope.updateChart = function(data) {
		if ($scope.chart == undefined || $scope.chart == null) { return };
    	if (data == undefined || data == null || data.length == 0) { return };
    	var dataSource = getDataSource(data); 
		var yDomain = getDomain(data);
		var target = getTarget(data);
    	$scope.chart.axis(0).set("y", {domain: yDomain});
		$scope.chart.updateBrush(0, {target: target});			
		$scope.chart.axis(0).update(dataSource);
		$scope.chart.render();
    	 
    	 
	}; 
	
	$scope.resizeChart = function() {	
		var width = Common.getElementWidth($scope.chartElement);
        var height = 555;
   	 
   	 	$scope.chart.setSize(width, height);
	    $scope.chart.render();
	};
	
	
// ===============================================================================
// <-- jui 
// ===============================================================================    
// ===============================================================================
// function -->  
// ===============================================================================    
	function getDataSource(data){
    	var dataSource = [];
    	var today = Common.getToday();
    	var today = today.replace(/\//g,'');
    	
   		for (var i=0; i<288; i++) {
   			var obj = {};
   			for (var j=0; j<data.length; j++) {
   				var prop = data[j].nodeNm;
   				var value = data[j].list[i];
   				obj[prop] = value;
   			}
   			dataSource.push(obj);
   		}; //for
   		return dataSource;
   	};
   	
   	function getDomain(data, limit) {
   		var min = 0;
   		var max = 0;
   		limit = 0;
   		var temp = [];
   		for (var k = 0; k < data.length; k++) {
   			var arr = data[k].list;
   	   		for (var i=0; i<arr.length; i++) {
   	   			for (var j=0; j<arr.length; j++) {
   	   				if(max < arr[i]){
   	   					max = arr[i];
   	   				}
   	   			}   			
   	   		};
		}
   		//max = Math.max.apply(null, temp);	
   		if (max < limit) {max = limit;}
   		if (limit != 100) {max *= 1.2;}
   		return [Math.round(min), Math.round(max+1)];
   	};
   	
   	function getTarget(data) {
   		var target = [];
   		for (var i=0; i<data.length; i++) {
   			target.push(data[i].nodeNm);
   		}
   		return target;
   	};
	
	
// ===============================================================================
// <-- function 
// ===============================================================================    
				
});//controller


