'use strict';
angular.module('popupApp')
.controller('ErrorLargeCtrl', function ($scope, $rootScope, $interval, $timeout, $filter, Data, Common, StorageManager, $routeParams, $mdDialog, $window, Paginator) {
// ===============================================================================
// initialize -->
// ===============================================================================
	
	$scope.param = $routeParams['param'];
	
	$scope.searchOptions = {
				yyyymmdd : Common.getToday(),
				sHHmm : Common.getPerHours(6),
				eHHmm : Common.getThisTime(),
				metricNm : "",
				nodeNm : "",
				type : $scope.param==1?"critical":$scope.param==2?"warn":$scope.param==0?"all":"",
				unProcessEvent : true
	};
	
	$scope.searchMetricNm = "";
	$scope.searchAgentNm = "";
	
	$scope.errorList = undefined;
	$scope.nodeGroupNms = [];
	$scope.metricNms = [];
	
	$scope.isLoading = true;
	$scope.isReady = false;
	$scope.time = jui.include("util.time");
	$scope.isResize = false;
	$scope.unProcessEvent = true;
	
	window.onload = function(){
	}
	
    $(document).ready(function(){
    	$(".list-box").mCustomScrollbar();
   	 	$("body").css("background-color", "#eeeeee");
        $(".sidenav").css("background-color", "#151b25"); 
        
    	$scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;
    	$scope.init();
		$timeout(function() {
			$scope.getErrorList();
			$scope.isLoading = false;
			
		}, 2000)
	});
    
    $scope.init = function () {
    	if($scope.param==1){
    		$scope.searchOptions.type = "critical";
    	}else if($scope.param==2){
    		$scope.searchOptions.type = "warn";
    	}else if($scope.param==3){
    		$scope.searchOptions.type = "normal";
    	}
    	
    	$scope.config = {visible : true, setting: false};
		$scope.createUIComponent();	
		$scope.isLoading = true;
		
    };
    
    $scope.ready = function () {
    };
    
    $scope.$on('$destroy', function() {          
    });
    
    angular.element(window).on('resize', function(e) {
		if ($scope.isResize) { return;}
		$scope.isResize = true;
		
		$timeout(function() {
			$scope.resetLayout();			
		}, 200);
	});
    
    $scope.resetLayout = function() {
    	var bodywidth = $(".error-large-container").width();
    	var agentwidth = $(".agent-container").width();
    	
    	$(".bottomDetailInner").css("width", (bodywidth - agentwidth - 10) +"px");
    	$scope.gridApi.core.handleWindowResize();
    	$scope.isResize = false;
    };
// ===============================================================================
// initialize <--
// ===============================================================================
    
    $scope.clickGroupCheckBox = function (key, selected) {
    	$scope.filterErrorList();
    }
    
// ===============================================================================
// rest controller -->
// ===============================================================================
    $scope.getErrorList = function () {
    	if ($scope.searchOptions.unProcessEvent){
    		$scope.searchOptions.yyyymmdd = Common.getToday();
    		$('#sTime').val(Common.getPerHours(6));
    		$('#eTime').val(Common.getThisTime());
    	}
    	var param = {
    			yyyymmdd : $scope.searchOptions.yyyymmdd
    			, sTime : $('#sTime').val()
    			, eTime : $('#eTime').val()
				, nodeNm : $scope.searchOptions.nodeNm
				, metricNm : $scope.searchOptions.metricNm
    			, sttsLvl : $scope.searchOptions.type
    			, unProcessEvent: $scope.searchOptions.unProcessEvent
    	}
    	
    	$('#ajaxLoading').show();
    	
    	Data.ajax({url:'dashBoard/exceptionList', param:param, successCallback:function(data, status) {
    		try {
    			if(data) {
    				$scope.gridOptions.data = [];
    				$scope.errorListDataResult = [];
    				$scope.nodeGroupNms = [];
					$scope.metricNms = [];
					for (var i = 0; i < data.length; i++) {
						var obj = [];
						
						obj = data[i];
						obj.retryCnt = Common.formatNumber(data[i].retryCnt);
						obj.defaultChkVal = Common.formatNumber(data[i].defaultChkVal);
						obj.chkVal = Common.formatNumber(data[i].chkVal);
						
						if (data[i].eventCheckDtFmt != null ){
							 obj.eventCheckInfo = data[i].eventCheckDtFmt + "(" + data[i].eventUserId + ")";
						}else{
							obj.eventCheckInfo = "";
						}
						$scope.errorListDataResult.push(obj);
					}
    				
    				$scope.gridOptions.data = $scope.errorListDataResult;
					for (var i = 0; i < $scope.gridOptions.data.length; i++) {
						$scope.nodeGroupNms.push($scope.gridOptions.data[i].nodeGroupNm);
						$scope.metricNms.push($scope.gridOptions.data[i].metricNm);
					}
					//중복제거
					$scope.tmpNodeGroupNms = Array.from(new Set($scope.nodeGroupNms));
					$scope.tmpMetricNms = Array.from(new Set($scope.metricNms));
					
					$scope.nodeGroupNms = [];
					$scope.metricNms = [];
					
					for (var int = 0; int < $scope.tmpNodeGroupNms.length; int++) {
						var obj1 = {key : $scope.tmpNodeGroupNms[int] , selected : true}
						$scope.nodeGroupNms.push(obj1);
					}
					
					for (var int = 0; int < $scope.tmpMetricNms.length; int++) {
						var obj1 = {key : $scope.tmpMetricNms[int] , selected : true}
						$scope.metricNms.push(obj1);
					}
				
					/********** ui-grid custom(그리드, 페이징) **********/
	     			$timeout(function() {
	     				// 최초 실행 시 첫 Row 선택
	     				if($scope.gridApi.selection.selectRow){
	     				  $scope.gridApi.selection.selectRow($scope.gridOptions.data[0]);
	     				}
	     			});
	     			Paginator.setScope($scope);
	     			$scope.paging = function(page) {			     				
	     				Paginator.setPage(page);
	     			}			     			
	     			$scope.paging(1); // 1페이지
	     			/********** ui-grid custom(그리드, 페이징) **********/
    				$('#ajaxLoading').hide();
					
    			}else{
	     			$('#ajaxLoading').hide();
    			}
    		} catch(ex) {
    			$('#ajaxLoading').hide();
    		}
    	}});
    	
	};
    
	$scope.filterErrorList = function () {
		$scope.gridOptions.data = [];
		var filterData = [];
		
		for (var i = 0; i < $scope.nodeGroupNms.length; i++) {
			if($scope.nodeGroupNms[i].selected == true){
				for (var j = 0; j < $scope.errorListDataResult.length; j++) {
					if($scope.nodeGroupNms[i].key == $scope.errorListDataResult[j].nodeGroupNm){
						filterData.push($scope.errorListDataResult[j]);
					}
				}
			}
		}
		
		for (var i = 0; i < $scope.metricNms.length; i++) {
			if($scope.metricNms[i].selected == true){
				for (var j = 0; j < filterData.length; j++) {
					if($scope.metricNms[i].key == filterData[j].metricNm){
						$scope.gridOptions.data.push(filterData[j]);
					}
				}
			}
		}
		/********** ui-grid custom(그리드, 페이징) **********/
		$timeout(function() {
			// 최초 실행 시 첫 Row 선택
			if($scope.gridApi.selection.selectRow){
			  $scope.gridApi.selection.selectRow($scope.gridOptions.data[0]);
			}
		});
		Paginator.setScope($scope);
		$scope.paging = function(page) {			     				
			Paginator.setPage(page);
		}			     			
		$scope.paging(1); // 1페이지
		/********** ui-grid custom(그리드, 페이징) **********/
	};
// ===============================================================================
// rest controller <--
// ===============================================================================
// ===============================================================================
// jui -->
// ===============================================================================
	/* 그리드 */
	var eventCheckInfo = ['<div ng-if="row.entity.eventUserId==null && ' +  "row.entity.eventDiv=='Y'" + '">' +
						  '    <button type="button" class="btn waves-effect waves-light btn-inner kr margin-left" ng-click="grid.appScope.oneClick(row,COL_FIELD)">해소</button>' +
						  '</div>' +
						  '<div ng-if="row.entity.eventUserId!=null" class="ui-grid-cell-contents my-cell ng-binding ng-scope" ng-dbclick="grid.appScope.dbClick(row)" tabindex="0">' +
						  '    {{row.entity.eventCheckInfo}}' +
						  '</div>'].join('');
	
	$scope.gridOptions = {
		/*paginationPageSizes: [25, 50, 75],*/
		enablePaginationControls: false,	
		paginationPageSize: 13,
		enableRowSelection: true,
		enableSelectAll: true,
		enableRowHeaderSelection: false,
		modifierKeysToMultiSelect: false,
		multiSelect: false,
		/* Scrollbar  ::  0:disable, 1:enable, 2:enable when needed */
		enableScrollbars: false,
		enableHorizontalScrollbar: 1,
		enableVerticalScrollbar:1,
		/* 선택 항목 유지 */
		// noUnselect: true,
		/* 헤더 옵션 제거 */
		enableColumnMenus: false,
		/*
	    useExternalPagination: true,
	    useExternalSorting: true,    */
	    enableFiltering: false,
	    showGridFooter:false,
	    showColumnFooter:false,
  		columnDefs: [
		      { field: 'eventDtFmt',name: "발생시간",width: "140"},
		      { field: 'lastEventDtFmt',name: "최근발생시간",width: "140"},
		      { field: 'nodeNm',name: "에이전트",width: "15%"},
		      { field: 'sttsLvl',name: "오류레벨",width: "70"},
		      { field: 'metricNm',name: "예외/오류명",width: "15%"},
		      { field: 'retryCnt',name: "건수",width: "70", cellClass:'grid-number'},
		      { field: 'defaultChkVal',name: "기준치",width: "70", cellClass:'grid-number'},
		      { field: 'chkVal',name: "측정치",width: "70", cellClass:'grid-number'},
		      { field: 'eventCheckInfo',name: "해소정보",width: "140", cellClass:'grid-center', cellTemplate : eventCheckInfo},
		      { field: 'eventMsg',name: "상세",width: "*" },
		    ]
	};
	
	$scope.gridOptions.onRegisterApi = function(gridApi){
		$scope.gridApi = gridApi;
		gridApi.selection.on.rowSelectionChanged($scope,function(row){
			$scope.selectScoutServerClickData = row.entity;
		});

		gridApi.selection.on.rowSelectionChangedBatch($scope,function(rows){
			var msg = 'rows changed ' + rows.length;
		});
  		      
		$interval(function() {
			$scope.gridApi.core.handleWindowResize();
		}, 10, 10);
	};
	
	$scope.oneClick = function(row,COL_FIELD){
		$scope.openEventDetail(row.entity);
    }
	
	$scope.dblClick = function(row){//DoubleClick
		var item = [];
		item.data = row.entity;
		$scope.openErrorDetail(item);
    }
	
	$scope.createUIComponent = function() {
		jui.ready(["ui.property"], function(PropertyView) {			
			var datePicker = new PropertyView("#datePicker", {
	            items:[
	            	{type: 'date', key: 'date-picker'}],
	            event: {
	            	change: function(item, data) {
	            		$scope.searchOptions.yyyymmdd = data; 		
	            	}
	            }
	        });
		});
	};
	
// ===============================================================================
// <-- jui 
// ===============================================================================    
// ===============================================================================
// function -->  
// ===============================================================================  
	$scope.$watch('searchMetricNm', function(newValue, oldValue) {
		$scope.searchOptions.metricNm = newValue;
	});
	
	$scope.$watch('searchAgentNm', function(newValue, oldValue) {
		$scope.searchOptions.nodeNm = newValue;
	});
	
	$scope.$watch("searchOptions.unProcessEvent", function(newVal, oldVal) {
		if (newVal){
			$scope.searchOptions.yyyymmdd = Common.getToday();
    		$('#sTime').val(Common.getPerHours(6));
    		$('#eTime').val(Common.getThisTime());
		}
		$scope.unProcessEvent = !$scope.unProcessEvent;
	});
// ===============================================================================
// <-- function
// ===============================================================================
	
//===============================================================================
// Detail popup -->
//===============================================================================
     $scope.openErrorDetail = function(item) {
         $mdDialog.show({
             controller: $scope.errorDetailController,
             templateUrl: 'views/modal/errorDetailDialog.html',
             parent: angular.element(document.getElementById("wrap")),
             targetEvent: event,
             clickOutsideToClose:true,
             locals : {
            	 item : item
             }
         }).then(function() {
         }, function() {
         	//close modal
         });
     };

     $scope.errorDetailController = function($scope, $rootScope, $timeout, $mdDialog, item) {
    	 $scope.item = item;
    	 
    	 $(document).ready(function(){
    		 
    	 });
    	 $scope.cancel = function() {
             $mdDialog.cancel();
         };
     };
     
     $scope.openEventDetail = function(item) {
         $mdDialog.show({
             controller: $scope.eventDetailController,
             templateUrl: 'views/modal/eventDetailDialog.html',
             parent: angular.element(document.getElementById("wrap")),
             targetEvent: event,
             clickOutsideToClose:true,
             locals : {
            	 item : item
             }
         }).then(function(formData) {
        	var params = formData;
         	Data.ajax({url:'dashBoard/updateHistException', param:params, successCallback:function(data, status) {
         		try {
         			if(data) {
 	                	if (data.result == "1") {
 	                		Common.alertDialog("해소 완료", "["+params.nodeGroupNm +"]그룹의 [" + params.nodeNm +"] 정보가 해소되었습니다.");
 	               		 	$scope.getErrorList();
 	                	}else{
 	                		Common.alertDialog("오류", data.resultMsg);
 	                	}
         			}
         		} catch(ex) {}
         	}});
         }, function() {
//        	 $scope.getGroupStatus();
//     		 $scope.autoScroll();
         	//close modal
         });
     };

     $scope.eventDetailController = function($scope, $timeout, $mdDialog, item) {
    	 $scope.formData = {
    				userId : $rootScope.userInfo.userId, 
    				userNm : $rootScope.userInfo.userNm, 
    				deptNm : $rootScope.userInfo.deptNm, 
    				mobile : $rootScope.userInfo.mobile, 
    				eventDt : item.eventDt,
    	 			nodeId : item.nodeId,
    	 			eventId : item.eventId,
    	 			eventCheckDt : item.eventCheckDt,
    	 			nodeGroupNm : item.nodeGroupNm,
    	 			nodeNm : item.nodeNm
    			};
    	 var itemObj = [];
    	 itemObj.data = item;
    	 $scope.item = itemObj;
    	 $scope.cancel = function() {
             $mdDialog.cancel();
         };
         $scope.answer = function() {      
             $mdDialog.hide($scope.formData);
         };
     };
});//controller
//===============================================================================
// <-- Detail popup
//===============================================================================

