'use strict';
angular.module('popupApp')
.controller('monitoringChartSampleCntr', function ($scope, $rootScope, $interval, $timeout, $filter, Data, Common, StorageManager) {
// ===============================================================================
// initialize -->
// ===============================================================================
	//variables	
	$scope.allAgent = [];
	$scope.selectedGroup = {};
	$scope.groupAllAgent = [];	
	$scope.selectedAgent = [];
	
	
	
	$scope.chartData = [];
	
	$scope.today = function () {
    	var date = new Date();
    	var year = date.getFullYear();
    	var month = (1+date.getMonth());
    	month = month>=10? month:'0'+month;
    	var day = date.getDate();
    	day = day>=10? day:'0'+day;
    	return year + '/' + month + '/' + day;
    };	
    
	$scope.searchOptions = {yyyymmdd:$scope.today(), selectedAgent:[], counter: "ActiveService"};
	$scope.isLoading = true;
		
	//////////////////////////////////////////////////////////////////
	
	$scope.chart = undefined;
	$scope.chartElement = undefined;	
	var graphWidth = $("#monitoring2Large").width();
	var _maxValue = 10;
	
	var divCd = "chnl";
	var itemId = "OF";
	var itemNm = "올레패밀리앱 (1,436,082/1,357,654)";
	var _color = "black";
	var _compareDayFlag = "W";
	
	
	var itemNm2 = "A";
	
	if(_color){
		
	}else{
		_color = 'black';
	}
//////////////////////////////////////////////////////////////////
	
	$scope.resetLayout = function() {
        if ($scope.chart != undefined && $scope.chartElement != undefined) {
        	$scope.resizeChart();
        };              
    };
   
    angular.element(window).on('resize', function(e) {
		$scope.resetLayout();
    });
	
	$scope.ready = function () {
		$(".view-chart").css("position", "relative");//chart position default:absolute => relative
		
//		$scope.isLoading = false;		
		if (StorageManager.getAllAgent() != undefined && StorageManager.getAllAgent() != null) {
			$scope.allAgent = StorageManager.getAllAgent();
		};
		
		if (StorageManager.getSelectedGroup() != undefined && StorageManager.getSelectedGroup() != null) {
			$scope.selectedGroup = StorageManager.getSelectedGroup();
			$scope.groupAllAgent = [];			
			for (var i=0; i<$scope.allAgent.length; i++) {
    			if ($scope.allAgent[i].nodeGroupId == $scope.selectedGroup.id) {
    				var group = $scope.allAgent[i];
    				for (var j=0; j<group.serverList.length; j++) {
    					var server =  group.serverList[j];
    					for (var k=0; k<server.nodeList.length; k++) {
    						var node = server.nodeList[k];				
    						$scope.groupAllAgent.push({id:node.nodeId, name:node.nodeNm, svrId:node.svrId});
    					}
    				};
    			};
    		};
    		$scope.selectedAgent = $scope.selectedGroup.selectedAgent;
    		$scope.searchOptions.selectedAgent = $scope.selectedAgent;
		};				
    };	
    
    $(document).ready(function(){  
    	$("select").material_select();
    	$scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;
    	$scope.init();
	});
    
    $scope.init = function () {
		$scope.isLoading = false;
		$scope.createUIComponent();
		$scope.initData();
		$scope.createChart();
		//$scope.getData();
    };	
    
    $scope.getChartData = function() {
    	$scope.getData();
    }
    $scope.$on('$destroy', function() {                
    });
        
// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// rest controller -->
// ===============================================================================    
// ===============================================================================
// rest controller <--
// ===============================================================================
// ===============================================================================
// jui -->
// ===============================================================================
	var style = {
            colors: ["#38c3ff", "#00ceae", "#ff474c", "#ffb500", "#e8e8e8", "#1bbe64", "#98dc08", "#cf0073", "#cf0073", "#576f83"]    
	};
	
	$scope.createUIComponent = function() {
		jui.ready(["ui.property"], function(PropertyView) {			
			var datePicker = new PropertyView("#datePicker", {
	            items:[
	            	{type: 'date', key: 'date-picker'}],
	            event: {
	            	change: function(item, data) {
	            		$scope.searchOptions.yyyymmdd = data; 		
	            	}
	            }
	        });
		});
	};
	
	
	$scope.resizeChart = function() {
	    $scope.chart.render();
	};
	
	
// ===============================================================================
// <-- jui 
// ===============================================================================    
// ===============================================================================
// function -->  
// ===============================================================================    
	
// ===============================================================================
// <-- function 
// ===============================================================================    
		 
	 $scope.initData = function(){
		//$('#trendLoading').hide();
		
		$('#trend_title').text('채널별 유입건수');
		
		var dt = new Date();
		var time = dt.getHours() + ":" + dt.getMinutes() + ":" + dt.getSeconds();
		
		$('#dev_time').text(time);
	};
			
	
	$scope.getData = function(){
		$('#trendLoading').show();
		
		var date = new Date();
		var compare = [];
		var current = [];
		
		var now = new Date();
		var _start = now.setHours(0);
		_start = now.setMinutes(0, 0, 0);
		var _end = now.setHours(24);
		_end = now.setMinutes(0, 0, 0);
		
		for(var i=_start, nLen=_end; i<nLen; i+=3600000){
			compare.push({
				t : Math.round(Math.random(0, 10000) / Math.random(1, 1000)),
				r : Math.round(Math.random(0, 10000) / Math.random(1, 1000)),
				x : i
			});
		}
		
		for(var i=_start, nLen=_end; i<nLen; i+=3600000){
			current.push({
				t : Math.round(Math.random(0, 10000) / Math.random(1, 1000)),
				r : Math.round(Math.random(0, 10000) / Math.random(1, 1000)),
				x : i
			});
		}
		
		for(var i = 0 ; i < compare.length ; i++) {
			var value = compare[i].t;
			if(value > 1000) {
				value = Math.ceil(compare[i].t/ 1000) * 1000;
			}
			if(_maxValue < value) {
				_maxValue = value;
			}
			
			value = current[i]?current[i].t:0;
			if(value > 1000) {
				value = Math.ceil(current[i].t/ 1000) * 1000;
			}
			
			if(_maxValue < value) {
				_maxValue = value;
			}
		}
		
		// update 
		$scope.chart.get('axis', 0).updateGrid('y', {
			domain : [ 0, _maxValue ]
		});
		
		$scope.chart.get('axis', 1).updateGrid('y', {
			domain : [ 0, _maxValue ]
		});
		
		$scope.chart.axis(0).update(compare);
		$scope.chart.axis(1).update(current);
		
		$('#trendLoading').hide();
	};
	
	$scope.createChart = function() {
		if ($scope.chart != undefined) { return }
		$scope.chartElement = angular.element("#trendChart");  
		
		var now = new Date();
		var _start = now.setHours(0);
		_start = now.setMinutes(0, 0, 0);
		var _end = now.setHours(24);
		_end = now.setMinutes(0, 0, 0);
		
		jui.ready(["chart.builder"], function (juiChart) {
			$scope.chart = juiChart('#trendChart', {
				width : '100%',
				height : 555,
				theme : "dark",
				padding : {
					'left' : 40,
					'right' : 40,
					'top' : 40,
					'bottom' : 40
				},
				axis : [ {
					x : {
						type : 'date',
						domain : [ _start, _end ],
						interval : 120, // 단위 시간에 대한 간격 설정
						realtime : "minutes", // 단위 시간 설정
						format : "HH:mm",
						key : "x"
					},
					y : {
						type : 'range',
						domain : function(data) {
							var sum = Math.max(0, data['t']);
							if (sum > 1000) {
								sum = Math.ceil(sum / 1000) * 1000;
							}
	
							if (sum == 0) {
								sum = 10;
							}
							
							if (_maxValue < sum) {
								_maxValue = sum;
							}
							return sum;
						},
						step : 5,
						format : function(v) {
							if (typeof (v) == "number") {
								return nFormatter(v, 1);
							}
							return v;
						}
					},
					data : []
				}, {
					x : {
						hide : true
					},
					y : {
						hide : true,
						type : 'range',
						domain : function(data) {
							var sum = Math.max(0, data['t']);
							if (sum > 1000) {
								sum = Math.ceil(sum / 1000) * 1000;
							}
	
							if (sum == 0) {
								sum = 10;
							}
							
							if (_maxValue < sum) {
								_maxValue = sum;
							}
							return sum;
						},
						step : 5,
						format : function(v) {
							if (typeof (v) == "number") {
								return nFormatter(v, 1);
							}
							return v;
						}
					},
					extend : 0,
					data : []
				}, ],
				brush : [ {
					type : 'area',
					target : [ 't' ],
					colors : ['#04927a'],
					line : false,
					axis : 0,
//					#06c6a6
//				    #04927a
				}, {
					type : 'line',
					colors : ['#06c6a6'],
					display : 'max',
					animate : true,
					axis : 1,
					target : [ 't' ] ,
					useEvent : false
				} 
				],
				widget : [
				{
					type : "title",
					text : "건수",
					align : "start",
					orient : "top",
					dx : -20,
					dy : 0
				},
				{
					type : "title",
					text : "시각",
					align : "end",
					orient : "bottom",
					dx : 0,
					dy : 0
				},
				/*
				{
				    type : "tooltip",
				    //brush : 1,
				    format : function(_data, _key) {
				         if(_data){
				         	if(_key == 'r'){
				         		return (_data[_key]/1000).toFixed(2) + "s";
				         	}else{
				         		if(_data[_key] == 0 ){ return '0'; }
				         		return nFormatter(_data[_key], 1);
				         	}
				         }else{
				        	// area
				         	return 'N/A';
				         }
				         
				     }
				},*/
				{
				    type : 'legend',
				    orient : 'right',
					align : 'top',
					brush : [0],
					colors: [_color],
					format : function(k) {
						return itemNm2;
					}
				}
				],
				style : {
					gridAxisBorderColor : "pink",
					gridBorderColor : "black",
					backgroundColor : 'white', //배경컬러
					gridXFontColor : "black",//x폰트컬러
					gridYFontColor : "black",//y폰트컬러
					tooltipPointRadius : 3,
					legendFontColor: "black"
				}
			});
		});
	};
	
	
	var nFormatter = function(num, digits, _maxvalue) {
		if(num == 0) {
			return '';
		}
		
		var si = [ {
			value : 1E18,
			symbol : 'E'
		}, {
			value : 1E15,
			symbol : 'P'
		}, {
			value : 1E12,
			symbol : 'T'
		}, {
			value : 1E9,
			symbol : 'G'
		}, {
			value : 1E6,
			symbol : 'M'
		}, {
			value : 1E3,
			symbol : 'k'
		}, ], i, len;
		if(_maxvalue){
			for (i = 0, len = si.length; i < len; i++) {
				if (_maxvalue >= si[i].value) {
					return (num / si[i].value).toFixed(digits).replace(/\.?0+$/, '') + si[i].symbol;
				}
			}
		}else{
			for (i = 0, len = si.length ; i < len; i++) {
				if (num >= si[i].value) {
					return (num / si[i].value).toFixed(digits).replace(/\.?0+$/, '') + si[i].symbol;
				}
			}
		}
		return num.toFixed(digits);
	};
});//controller


