'use strict';
angular.module('popupApp')
.controller('monitoringjmxResponseRateLargeCntr', function ($scope, $rootScope, $interval, $timeout, $filter, Data, Common, StorageManager, $routeParams) {
// ===============================================================================
// initialize -->
// ===============================================================================
	
	$scope.param = $routeParams['param'];
	
	//variables	
	$scope.allAgent = [];
	$scope.selectedGroup = {};
	$scope.groupAllAgent = [];	
	$scope.selectedAgent = [];
	
	
	$scope.chart = undefined;
	$scope.chartElement = undefined;	
	$scope.chartData = [];
	
	$scope.today = function () {
    	var date = new Date();
    	var year = date.getFullYear();
    	var month = (1+date.getMonth());
    	month = month>=10? month:'0'+month;
    	var day = date.getDate();
    	day = day>=10? day:'0'+day;
    	return year + '/' + month + '/' + day;
    };	
    
	$scope.searchOptions = {yyyymmdd:$scope.today(), selectedAgent:[], counter: "ActiveService"};
	$scope.isLoading = true;
		
	$scope.resetLayout = function() {
        if ($scope.chart != undefined && $scope.chartElement != undefined) {
        	$scope.resizeChart();
        };              
    };
   
    angular.element(window).on('resize', function(e) {		
		$scope.resetLayout();
    });
	
	$scope.ready = function () {
		$scope.isLoading = false;		
		if (StorageManager.getAllAgent() != undefined && StorageManager.getAllAgent() != null) {
			$scope.allAgent = StorageManager.getAllAgent();
		};
		
		if (StorageManager.getSelectedGroup() != undefined && StorageManager.getSelectedGroup() != null) {
			$scope.selectedGroup = StorageManager.getSelectedGroup();
			$scope.groupAllAgent = [];			
			for (var i=0; i<$scope.allAgent.length; i++) {
    			if ($scope.allAgent[i].nodeGroupId == $scope.selectedGroup.id) {
    				var group = $scope.allAgent[i];
    				for (var j=0; j<group.serverList.length; j++) {
    					var server =  group.serverList[j];
    					for (var k=0; k<server.nodeList.length; k++) {
    						var node = server.nodeList[k];				
    						$scope.groupAllAgent.push({id:node.nodeId, name:node.nodeNm, svrId:node.svrId});
    					}
    				};
    			};
    		};
    		$scope.selectedAgent = $scope.selectedGroup.selectedAgent;
    		$scope.searchOptions.selectedAgent = $scope.selectedAgent;
		};				
    };	
    
    $(document).ready(function(){
    	$("select").material_select();
    	$scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;
    	$scope.init();
    	$scope.getChartData();
	});
    
    $scope.init = function () {
		$scope.isLoading = false;
		
		$scope.createUIComponent();		
		$scope.createChart();			
    };	
    
    $scope.$on('$destroy', function() {                
    });
        
// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// rest controller -->
// ===============================================================================    
    $scope.getChartData = function() {
    	var selectedAgentIds = [];	    		
		for (var i=0; i<$scope.searchOptions.selectedAgent.length; i++) {
			var param = $scope.searchOptions.selectedAgent[i].svrId + "_" + $scope.searchOptions.selectedAgent[i].id;
			selectedAgentIds.push(param);	
		};
		var split = $scope.searchOptions.yyyymmdd.split('/');
		var yyyymmdd = split.join(''); 
		var params = {nodeGroupId: $scope.param};
		
//		Data.ajax({url:'dashBoard/loadCounter', param:params, successCallback:function(data, status) {
		Data.ajax({url:'dashBoard/requestChart', param:params, successCallback:function(data, status) {
			try {
				if(data) {
	        		if ($scope.chart != undefined) {
	        			data = data.requestChartList;
						$scope.updateChart(data);
					} 
				}
			} catch(ex) {}
		}});	
	};
// ===============================================================================
// rest controller <--
// ===============================================================================
// ===============================================================================
// jui -->
// ===============================================================================
	var style = {
            colors: ["#38c3ff", "#00ceae", "#ff474c", "#ffb500", "#e8e8e8", "#1bbe64", "#98dc08", "#cf0073", "#cf0073", "#576f83"]    
	};
	
	$scope.createUIComponent = function() {
		jui.ready(["ui.property"], function(PropertyView) {			
			var datePicker = new PropertyView("#datePicker", {
	            items:[
	            	{type: 'date', key: 'date-picker'}],
	            event: {
	            	change: function(item, data) {
	            		$scope.searchOptions.yyyymmdd = data; 		
	            	}
	            }
	        });
		});
	};
	
    $scope.createChart = function() {
    	if ($scope.chart != undefined) { return }   
    	$scope.chartElement = angular.element("#chart");    	
	   	var start = new Date(Common.getToday());
	   	var end = new Date(Common.getTomorrow());	   	
    	
    	jui.ready(["chart.builder"], function (juiChart) {
    		$scope.chart = juiChart(("#chart"), {
				padding: { left: 40, top: 22, right: 20, bottom: 62 },	
				height: 555,
				axis: {
	                x: {
	                	type: "dateblock",
				    	domain: [start, end],
				    	interval: 1000*60*60, //1시간
				    	format: function (d, i) {
				    		return i;
				    	}
	                },
	                y: {
	                    type : "range",
	                    domain : [ 0, 100 ],
	                    step : 5,
	                    line: true
	                }
	            },			 
	            brush: [{
	                    type: "line",
	                    target: ["responseRate"]
	            }],	
	            style: style,
	            format:function(v){
	            	return Common.formatNumber(v);
	            },
	            render: false
	        }); 		
		});
	};
	
	$scope.updateChart = function(data) {
		if ($scope.chart == undefined || $scope.chart == null) { return };
//    	if (data == undefined || data == null || data.length == 0) { return };
    	var dataSource = getDataSource(data);//x
    	var ymax1=0;
    	
    	for (var i = 0; i < dataSource.length; i++) {
			var temp = dataSource[i];
			
			for (var key in temp){
				if (temp[key] != undefined){
					ymax1=Math.max(temp[key], ymax1);
				}
			}
		}
    	var ymax2=Math.floor(ymax1/5)*5+5;
    	
    	$scope.chart.axis(0).set("y", {domain: [0, ymax2]});
		$scope.chart.axis(0).update(dataSource);
		$scope.chart.render();
	}; 
	
	$scope.resizeChart = function() {	
		var width = Common.getElementWidth($scope.chartElement);
        var height = 555;
   	 
   	 	$scope.chart.setSize(width, height);
	    $scope.chart.render();
	};
	
	
// ===============================================================================
// <-- jui 
// ===============================================================================    
// ===============================================================================
// function -->  
// ===============================================================================
	
	//시간 x축
	function getDataSource(data){
    	var dataSource = [];
    	
    	for (var i=0; i<288; i++) {
   			var obj = {};
			var prop = "responseRate";
			var value = data[i];
			obj[prop] = value;
			
   			dataSource.push(obj);
   		}; //for
   		return dataSource;
   	};
// ===============================================================================
// <-- function 
// ===============================================================================    
				
});//controller


