'use strict';
angular.module('popupApp')
.controller('XLogLargeCtrl', function ($scope, $rootScope, $interval, $timeout, $filter, $window, Data, Common, StorageManager, $location) {
// ===============================================================================
// initialize -->
// ===============================================================================
	var timeGap = 0;
	$scope.selectedAgent = [];
	$scope.selectedAgentIds = [];
	$scope.uxid = (new Date()).getTime();      	
	
	var topologyData = {nodes:[], edges:[]};
	var boxElement = null;
	
	var hostindex = location.href.indexOf(location.host) + location.host.length;
	var serviceBase = location.href.substring(0, location.href.indexOf('/', hostindex + 1)) + "/";
	var isAjaxCollectEnd = true;
	var isCollectInterval;
	$scope.autoScaleVal = null;
	//UI comp
	$scope.topology = undefined;
	$scope.xLogChart = undefined;
	$scope.xLogChartElement = undefined;	
	$scope.profileList = undefined;
	$scope.profileText = undefined;	
	
	$scope.xLogData = [];
	$scope.profileListData = [];
	$scope.profileTextData = [];    
	$scope.topologyData = [];
	$scope.topologyNodeData = [];
	$scope.topologyEdgeData = [];	
    
    $scope.serviceNm = '';
    $scope.clientIp = '';
    $scope.guid = '';
    
	var DIR = 'images/topology/';
    var EDGE_LENGTH_MAIN = 150;
    var EDGE_LENGTH_SUB = 50;
    var fontStyle = {size:20, color:'#1e2533', face:'Nanum Gothic', strokeWidth:0}
   
    var imageUser = DIR + 'user.png';
    var imageHost = DIR + 'server.png';
    var imageInstance = DIR + 'was.png';
    var imageDB = DIR + 'db.png';
    var lineStyle = {color:'#b2b2b2'}
	
	//variables
	$scope.today = function () {
    	var date = new Date();
    	var year = date.getFullYear();
    	var month = (1+date.getMonth());
    	month = month>=10? month:'0'+month;
    	var day = date.getDate();
    	day = day>=10? day:'0'+day;
    	return year + '/' + month + '/' + day;
    };	
    
    $scope.thisTime = function () {
    	var date = new Date();
    	var HH = date.getUTCHours();
    	HH = HH>=10? HH:'0'+HH;
    	var mm = date.getUTCMinutes();
    	mm = mm>=10? mm:'0'+mm;
    	return HH + ':' + mm;
    };	
    
	$scope.searchOptions = {yyyymmdd:$scope.today(), sHHmm:"00:00", eHHmm:"00:00", errorFilter: false, type: "svc", selectedSecond : ""};
	$scope.serviceNm = "";
	$scope.clientIp = "";
	$scope.yMax = 10000; //10sec
	
	$scope.isRealTime = false; //0->실시간, 1->검색
	$scope.isRealTimeStr = "실시간 Off";
	$scope.isLoading = true;
	$scope.isReady = false;
	$scope.isInterval;
	$scope.time = jui.include("util.time");
	
	//watch
	$scope.$watch("isRealTime", function(newVal, oldVal) {
	   	if (newVal !== oldVal) { 
	   		if (newVal) {
    			$scope.isRealTimeStr = "실시간 On";
    			$scope.xLogData = [];
    			$scope.profileList.update([]);
    			$scope.profileText.update([]);
    			
    			fnStartInterval();
    		} else {
    			$scope.isRealTimeStr = "실시간 Off";    			
    			$scope.xLogData = [];    			
    			$scope.profileList.update([]);
    			$scope.profileText.update([]);
    			fnStopInterval();
    		}
	   		
	   		$timeout(function() {
    			$scope.xLogChart.axis(0).set("x", {domain: []});
    			$scope.xLogChart.axis(0).update([]);
    			$scope.xLogChart.render();
			}, 1000)
		};
   });
	
	$scope.resetLayout = function() {
        if ($scope.xLogChart != undefined && $scope.xLogChartElement != undefined) {
        	$scope.resizeXLog();
        };              
   };
   
   angular.element(window).on('resize', function(e) {
		$scope.resetLayout();
   });
   
	
	$scope.ready = function () {
		//loading or transition
		$scope.isLoading = true;
    };	
    
    $(document).ready(function(){
    	$scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;
    	$("select").material_select();
    	$scope.init();
	});
    
    $scope.init = function () {
		$scope.isLoading = false;
		timeGap = Number(StorageManager.getTimeGap());
		
		$scope.config = {visible : true, setting: false};
		$scope.createUIComponent();		
		
		fnCreateXTable();		
		fnCreateXLog();	
		
		var date = new Date();
		var sHH = date.getHours()-3;
    	sHH = 0 >= sHH ? 0 : sHH;
		sHH = sHH >= 10 ? sHH : '0' + sHH;
    	var eHH = date.getHours();
    	eHH = eHH >= 10 ? eHH : '0' + eHH;
    	var mm = date.getUTCMinutes();
    	mm = mm>=10? mm:'0'+mm;
		
    	$scope.searchOptions.sHHmm = sHH+":"+mm;
    	$scope.searchOptions.eHHmm = eHH+":"+mm;
    	
        $scope.startHH = sHH; //시작시간
        $scope.startmm = mm; //시작분
        $scope.endHH = eHH; //종료시간
        $scope.endmm = mm; //종료분
        
		
    	$scope.selectedGroupId = opener.selectedGroupId;
    	
    	var allAgent = StorageManager.getAllAgent();
		
		for (var i = 0; i < allAgent.length; i++) {
			var nodeGroupId = allAgent[i].nodeGroupId;
			if (nodeGroupId == $scope.selectedGroupId){
				$scope.selectedGroupNm = allAgent[i].nodeGroupNm;
				$scope.selectedAgentIds = [];
				if (allAgent[i].serverList.length > 0){
					for (var serverCnt=0; serverCnt < allAgent[i].serverList.length; serverCnt++) {
						var server =  allAgent[i].serverList[serverCnt];
						for (var j=0; j<server.nodeList.length; j++) {
							var node = server.nodeList[j];				
							var param = node.svrId + "_" + node.nodeId;
							$scope.selectedAgentIds.push(param);	
						}
					};
					
				}
				break;
			}
			
		};
    	
    };	
    
    function fnStartInterval() {
    	if (!$scope.isRealTime){
    		return;
    	}
    	
    	var params = {oid: $scope.selectedAgentIds.toString(','), type: 'svc',  uxid: $scope.uxid};
		
		isCollectInterval = $interval(function() {
        	fnCollectSearch(params);        	
        }, 2000);
    };

    function fnCollectSearch(params){
    	isAjaxCollectEnd = false;
    	
		Data.ajax({url:'dashBoard/xLogData', param:params, successCallback:function(data, status) {
			try {
				isAjaxCollectEnd = true;
				if(data) {
					if ($scope.isRealTime) {
		        		if ($scope.xLogChart != undefined) {        			
		    				$scope.updateXLog(data);
		    			} 
		    		}
				}
			} catch(ex) {}
		}});
    }
    
    function fnStopInterval() {
    	if (angular.isDefined(isCollectInterval)) {
            $interval.cancel(isCollectInterval);
            isCollectInterval = undefined;
        }
    };
    
    $scope.$on('$destroy', function() {
    	fnStopInterval();        
    });

    $scope.normalFilter = true;
    $scope.errorFilter = true;
    
    $scope.searchOptions.selectedSecond =[
    	{id:0, val:5000, name: "5초"}, {id:1, val:10000, name: "10초"},
    	{id:2, val:15000, name: "15초"}, {id:3, val:20000, name: "20초"},
    	{id:4, val:30000, name: "30초"}, {id:5, val:60000, name: "60초"},
    	{id:6, val:150000, name: "150초"}];
    
// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// rest controller -->
// ===============================================================================   
    // time validation
    $scope.startHHCheck = function (startHH) {
    	var intValue = parseInt(startHH);
    	if( $.isNumeric(intValue) == false ){
    		$scope.startHH= "";
    	}
    	if(intValue >=25){
    		alert("시작 시간을 올바르게 입력 해주세요");
    		$scope.startHH= "";
    	}
    };
    $scope.startmmCheck = function (startmm) {
    	var intValue = parseInt(startmm);
    	if( $.isNumeric(intValue) == false ){
    		$scope.startmm= "";
    	}
    	if(intValue >= 60){
    		alert("시작 시간을 올바르게 입력 해주세요");
    		$scope.startmm= "";
    	}
    };
    $scope.endHHCheck = function (endHH) {
    	var intValue = parseInt(endHH);
    	if( $.isNumeric(intValue) == false ){
    		$scope.endHH= "";
    	}
    	if(intValue >= 25){
    		alert("종료 시간을 올바르게 입력 해주세요");
    		$scope.endHH= "";
    	}
    };
    $scope.endmmCheck = function (endmm) {
    	var intValue = parseInt(endmm);
    	if( $.isNumeric(intValue) == false ){
    		$scope.endmm= "";
    	}
    	if(intValue >= 60){
    		alert("종료 시간을 올바르게 입력 해주세요");
    		$scope.endmm= "";
    	}
    };
    $scope.searchOptionsChangeSelect = function (id, name) {
    	if(name == "undefined" || name == null){
    		$scope.autoScaleVal = null;
		}else{
			$scope.autoScaleVal = name;
		}
    }
    $scope.searchXLogData = function() {
//		$scope.searchOptions.sHHmm = angular.element("#sTime")[0].value;
//		$scope.searchOptions.eHHmm = angular.element("#eTime")[0].value;
		$scope.searchOptions.sHHmm = angular.element("#sHH")[0].value + ":" + angular.element("#smm")[0].value;
		$scope.searchOptions.eHHmm = angular.element("#eHH")[0].value + ":" + angular.element("#emm")[0].value;
		
		if(! /\d+\:\d+/.test($scope.searchOptions.sHHmm)) {
			alert('시작시간이 잘못 되었습니다. ');
			return;
		} else if(! /\d+\:\d+/.test($scope.searchOptions.eHHmm)) {
			alert('종료시간이 잘못 되었습니다. ');
			return;
		}
		
		var split = $scope.searchOptions.yyyymmdd.split('/');
		var yyyymmdd = split.join('');    		
		
		split = $scope.searchOptions.sHHmm.split(':');
		var sHHmm = split.join('');
		
		split = $scope.searchOptions.eHHmm.split(':');
		var eHHmm = split.join('');
		
		if(sHHmm > eHHmm) {
			alert('시작시간과 종료시간이 잘못 되었습니다. ');
			return;
		}
		
		if ($scope.searchOptions.errorFilter){
			$scope.normalFilter = false;
			$scope.errorFilter = true;
		} else {
			$scope.normalFilter = true;
			$scope.errorFilter = true;
		}
		$scope.serviceNm=$scope.serviceNm.trim();
		$scope.clientIp=$scope.clientIp.trim();
		if((eHHmm-sHHmm)>300 && ($scope.serviceNm || $scope.clientIp)) {
			alert('service나 IP조회는 3시간 이내로만 가능합니다. ');
			return;
		}
		var params = {oid: $scope.selectedAgentIds.toString(','), type: $scope.searchOptions.type,  yyyymmdd: yyyymmdd, sHHmm: sHHmm, eHHmm: eHHmm, 
				serviceNm:$scope.serviceNm,
				clientIp:$scope.clientIp,
				guid:$scope.guid,
				normalFilter:$scope.normalFilter,
				errorFilter: $scope.errorFilter};
		$('#xLogChartLoading').show();
		Data.ajax({url:'dashBoard/xLogLoadData', param:params, successCallback:function(data, status) {
			try {
				if(data) {
	        		$scope.xLogData = [];
	        		if ($scope.xLogChart != undefined && !$scope.isRealTime ) {        			
						$scope.updateXLog(data);
					} 
				}
			} catch(ex) {}
			$('#xLogChartLoading').hide();
		}});   	
	};
    
    $scope.getProfileList = function (selectedData) {
    	if ($scope.profileList != undefined) {
    		$scope.profileList.showLoading();  	
    	};
    	var sTime, eTime, minValue, maxValue;
    	sTime=new Date(selectedData.x1).getTime()-100;
    	eTime=new Date(selectedData.x2).getTime()+100;
    	minValue=Math.floor(selectedData.y1);
    	maxValue = 1000;
    	
    	var y2=Math.ceil(selectedData.y2);
    	
    	if (minValue < 30){
    		minValue = -100;
    	}

    	if(y2>(10*0.97) ){
    		maxValue=1000000000;//150000;
    	}else{
    		maxValue=y2;
    	}
    	
    	var params = {
    					oid: $scope.selectedAgentIds.toString(','), 
    					type: $scope.searchOptions.type, 
    					sTime: sTime, 
    					eTime: eTime, 
    					minValue: minValue, 
    					maxValue: maxValue, 
    					normalFilter:$scope.normalFilter, 
    					errorFilter: $scope.errorFilter,
    					serviceNm:$scope.serviceNm,
    					clientIp:$scope.clientIp
    				 };
    	
    	Data.ajax({url:'dashBoard/xLogList', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
	                //success
	        		$scope.profileList.hideLoading(); 
	        		$scope.profileListData = data;            	
	            	$scope.profileList.update($scope.profileListData);
    			}
    		} catch(ex) {}
    	}});
    };
    
    $scope.getTopologyData = function (obj, e) {
        
    	var params = {serverId: obj.data.serverId, txId: obj.data.txid, eTime: obj.data.endTime};
    	
    	Data.ajax({url:'dashBoard/xLogFlow', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
	                //success
	            	$scope.topologyData = data[0];
	            	$scope.updateTopology();
    			}
    		} catch(ex) {}
    	}});
    };
    
    $scope.getProfileText = function (obj, e) {
    	if ($scope.profileText != undefined) {
    		$scope.profileText.showLoading();  	
    	};
    	var params = {serverId: obj.data.serverId, txId: obj.data.txid, eTime: obj.data.endTime};
    	
    	Data.ajax({url:'dashBoard/xLogProfile', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
	                //success
					$scope.profileTextData = data.xLogProfile.logSteps;
					for (var i=0; i<$scope.profileTextData.length; i++) {
						$scope.profileTextData[i].no = i+1;
						if($scope.profileTextData[i].pId != ""){
							var space = "";
							for(var x=0;x<$scope.profileTextData[i].contents.length;x++) {
								if($scope.profileTextData[i].contents.charAt(x)!=' '){
									break;
								}
								space = space + "&nbsp;&nbsp;&nbsp;&nbsp;";
							}
							$scope.profileTextData[i].contents = space + $scope.profileTextData[i].contents;
						}
					}
					$scope.profileText.update($scope.profileTextData);
					$scope.profileFullText=data.text;
    			}
    			$scope.profileText.hideLoading();
    		} catch(ex) {
    			$scope.profileText.hideLoading();
    		}
    	}});
    };
    
// ===============================================================================
// rest controller <--
// ===============================================================================
// ===============================================================================
// jui -->
// ===============================================================================    
	
	$scope.createUIComponent = function() {
		jui.ready(["ui.property"], function(PropertyView) {			
			var datePicker = new PropertyView("#datePicker", {
	            items:[
	            	{type: 'date', key: 'date-picker'}],
	            event: {
	            	change: function(item, data) {
	            		$scope.searchOptions.yyyymmdd = data; 		
	            	}
	            }
	        });
		});
	};
    
	$scope.dropDownShowHandler = function() {
		//alert("Click Drop Down");
		$scope.yearSelect.show();
	}
	
	
	$scope.updateTopology = function() {
		$scope.topology=null;
		
		var data = $scope.topologyData;
		$scope.topologyNodeData = [];
		$scope.topologyEdgeData = [];
		
		$scope.topologyNodeData.push({ id: 'ui', label: data.ipaddr, level: 1, image: imageUser, shape: 'image', font: fontStyle});
		$scope.topologyNodeData.push({ id: 'root', label: data.serviceName+'\n\r( '+data.objName+' ) ', level: 2, image: imageHost, shape: 'image', font: fontStyle});
		$scope.topologyEdgeData.push({from: 'root', to: 'ui', label: data.elapsed+' ms', length: EDGE_LENGTH_MAIN, font: fontStyle, color:lineStyle, arrows:'from'});

		if (data.step.length != 0) {
			for (var i=0; i<data.step.length; i++) {
				var txid = '';
				var stepType = data.step[i].stepType;
				var name = '';
				var type = '';
				var elapsed = '';
				var image = '';
				var title = null;
				if(stepType==2||stepType==8||stepType==16){
					name = data.step[i].name ? data.step[i].name.replace(/,/g,",\n\r") : 'SQL';
					type = 'db';
					elapsed = data.step[i].elapsed+' ms';
					txid = 's_'+i;
					image = imageDB;
					title = data.step[i].sql;
					$scope.topologyNodeData.push({ id: txid, label: name, level: 3, image: imageInstance, shape: 'image', font: fontStyle, title: title});
				}else{
					name = data.step[i].name;
					type = 'server';
					elapsed = data.step[i].elapsed+' ms';
					txid = 'p_'+data.step[i].txid;
					image = imageInstance;
					$scope.topologyNodeData.push({ id: txid, label: name, level: 3, image: imageInstance, shape: 'image', font: fontStyle});
				}
				//$scope.topologyNodeData.push({ id: txid, label: name, level: 3, image: imageInstance, shape: 'image', font: fontStyle});
				$scope.topologyEdgeData.push({from: txid, to: 'root', label: elapsed, length: EDGE_LENGTH_MAIN, font: fontStyle, color:lineStyle, arrows:'from'});
			};		
		};
		
		boxElement = $("#topologyViewTab");
    	var container = $("#topology");
		var options = {
			width : '100%',
			height : '100%',
			edges: {
				smooth: {
					type: 'cubicBezier',
					forceDirection: 'horizontal',
					roundness: 0.4 
				}
			},
			layout: {
				hierarchical: {
					direction: "LR", //"UD", DU, LR, RL
//					sortMethod: "directed",
					nodeSpacing: 100,
					levelSeparation: 250
	        	}
	        },
	        physics:false
		}; //options
		
		topologyData.nodes = $scope.topologyNodeData;
		topologyData.edges = $scope.topologyEdgeData;
		
		$scope.topology = new vis.Network(container[0], topologyData, options);
		
		var serverId = data.serverId;
		var endTime = data.endTime;
		
		$scope.topology.on("doubleClick", function(properties) {
			var nodes = properties.nodes;
			if(0 < nodes.length){
				var id = nodes[0];
				if(-1 < id.indexOf('p_')){
					var txid = id.replace("p_","");
					$scope.openXLogProfilePopup(serverId, txid, endTime);
				}else if(-1 < id.indexOf('s_')){
					var index = id.replace("s_","");
					//Common.alertDialog('',data.step[index].sql);
				}
			}
		});
	};
	
	$scope.openXLogProfilePopup = function(serverId, txid, eTime, xTyp) {
		var popupX = (window.screen.width/2) - (1280/2);
    	var popupY = (window.screen.height/2) - (720/2);
    	
    	var popup = $window.open(serviceBase + "popup.html#/xlog_profile/"+serverId+"/"+txid+"/"+eTime+"/"+xTyp, "popup_error", "width=1280, height=720, left="+popupX+", top="+popupY);
    	
    };
	
    function fnCreateXLog() {  
    	if ($scope.xLogChart != undefined) { return }   
    	$scope.xLogChartElement = angular.element("#xLogChart");
    	jui.ready(["chart.builder"], function (juiChart) {
    		var style = {					
    				colors: ["#38c3ff", "#ffb500", "#ff474c", "#ff474c", "#123456"],
			};	
    		$scope.xLogChart = juiChart("#xLogChart", {
    			padding: { left: 40, top: 20, right: 20, bottom: 20 },
    			height: 240,
    			canvas: true,
    		    axis : {
    		        x : {
    		        	type: "date",  		        
    		            domain : Common.pastTimeInterval(5, timeGap),
    		            interval: 1,
    		            realtime: "minutes",
    		            format: "HH:mm",
    		            key: "time",
    		            line : true
    		        },
    		        y : {
    		            type : "range",
    		            domain :  [0, $scope.yMax],
    		            step : 5,
    		            line : true,
    		            format : function(d) {
		            		return (d/1000) + "(S)";
			            } 
    		        },
    		        data : $scope.xLogData,
    		    },
			    brush : [
			    	{
				    	type : "canvas.scatter",
				        size : 3,
				        target : "elapsed",		       
				        symbol: "circle",
			            colors: function (d) {
			            	if($scope.normalFilter && d.error!=2)
			            		return d.error;
			            	else 
			            		return 4;
			            }
		            },
			    	{
			    		type : "canvas.scatter",
			    		size : 6,
			    		target : "errTk",		       
				        symbol: "cross",
			    		colors: function (d) {
			    			if( $scope.errorFilter && d.error==2) 
			    				return d.error;
			            	else 
			            		return 4;
			    		}
			    	}
			    ],
    		    widget : [{
    		        type : "dragselect",
    		        dataType : "area" // "list"
    		    }, {
    		        type : "tooltip",
    		        format : function(data, key) {
    	                return {
    	                    key: data[key],
    	                    value: (data.elapsed) + "ms"
    	                }
    	            }
    		    }],
    		    event : {
    		        "dragselect.end": function(data) {
    		        	$scope.getProfileList(data);    		        	
    		        }
    		    },
    		    style: style,
    		    render: false
    		});    		    		    		
    	});
	};
	
	$scope.updateXLog = function(data) {		
		if (data == undefined || data == null){
			return;
		}
		
		if ($scope.xLogData.length == 1 && $scope.xLogData[0].time == undefined) {
			$scope.xLogData = [];
		}
		
		var xDomain;
		
		if ($scope.isRealTime) {
			if (data.length == 0){
				return;
			}
			xDomain = Common.pastTimeInterval(5, timeGap);
			
			$scope.xLogChart.axis(0).set("x", {domain: xDomain});
			$scope.xLogChart.axis(0).set("x", {interval: 1});
			$scope.xLogChart.axis(0).set("x", {format: "HH:mm"});
			
			for (var i = 0; i < data.length; i++) {
	            data[i].time = new Date(data[i].eTime);
				if(data[i].error==2) {
					data[i].errTk=data[i].elapsed;
					data[i].elapsed=undefined;
				}
	            
	            $scope.xLogData.push(data[i]);
	        }		

			var y3=0;
			if ($scope.xLogData.length > 0){
				var currentTime = xDomain[0].getTime();
		    	
		    	var arrCnt = 0;
		    	while(arrCnt < $scope.xLogData.length) {
		    		if ($scope.xLogData.length <= arrCnt){
		    			break;
		    		}
		    		var dt1= $scope.xLogData[arrCnt];
		    		if (currentTime >= dt1.time.getTime() - 3000){
		    			$scope.xLogData.splice(arrCnt , 1);
		    		}else {
		    			if(dt1.errTk){
		    				y3=Math.max(dt1.errTk,y3);
		    			}else if(dt1.elapsed){
		    				y3=Math.max(dt1.elapsed,y3);
		    			}
		    			arrCnt ++;
		    		}
		        }
			}
		} else {
			//test
    		var start = getDateTime($scope.searchOptions.yyyymmdd, $scope.searchOptions.sHHmm);
    		var end = getDateTime($scope.searchOptions.yyyymmdd, $scope.searchOptions.eHHmm);    		
    		xDomain = [start, end];	
    		
    		$scope.xLogChart.axis(0).set("x", {domain: xDomain});
			$scope.xLogChart.axis(0).set("x", {interval: getInterval(start, end)});
			$scope.xLogChart.axis(0).set("x", {format: "HH:mm"});
			
			for (var i = 0; i < data.length; i++) {
	            data[i].time = new Date(data[i].eTime);
				if(data[i].error==2) {
					data[i].errTk=data[i].elapsed;
					data[i].elapsed=undefined;
				}
	            
	            $scope.xLogData.push(data[i]);
	        }
			
			var y3=0;
			if ($scope.xLogData.length > 0){
				var currentTime = xDomain[0].getTime();
		    	
		    	var arrCnt = 0;
		    	while(arrCnt < $scope.xLogData.length) {
		    		if ($scope.xLogData.length <= arrCnt){
		    			break;
		    		}
		    		var dt1= $scope.xLogData[arrCnt];
		    		if (currentTime >= dt1.time.getTime() - 3000){
		    			$scope.xLogData.splice(arrCnt , 1);
		    		}else {
		    			if(dt1.errTk){
		    				y3=Math.max(dt1.errTk,y3);
		    			}else if(dt1.elapsed){
		    				y3=Math.max(dt1.elapsed,y3);
		    			}
		    			arrCnt ++;
		    		}
		        }
			}
		}
		
		var yMax;
		if($scope.autoScaleVal != null) {
			yMax = $scope.autoScaleVal;
		} else {
			y3=Math.min(170000,y3);
			y3=(Math.floor(y3/5000)+1)*5000;
			yMax=y3;
		}
		var yDomain = [0, yMax];
		$scope.xLogChart.axis(0).set("y", {domain: yDomain});
		$scope.xLogChart.axis(0).update($scope.xLogData);
		$scope.xLogChart.render();			
	}; 
	
	$scope.resizeXLog = function() {	
		var width = Common.getElementWidth($scope.xLogChartElement);
        var height = 200;
   	 
   	 	$scope.xLogChart.setSize(width, height);
	    $scope.xLogChart.render();
	};
	
	function fnCreateXTable() {
		jui.ready([ "grid.xtable" ], function(juiXTable) {
	    	$scope.profileList = juiXTable("#profileListXtable", {
	            data:$scope.profileListData,
	            event: {
	            	select: function(row, e) {
	            		if ($(row.element).hasClass("selected")) {
	            			//this.unselect(row.index);
	            		} else {
	            			this.select(row.index);
	            			$scope.getProfileText(row, e);	  
	            			$scope.getTopologyData(row, e);
	            		}; 	            			            		              	
	            	}
	             },
	            tpl: {
	                row: angular.element("#tpl_row_profile_list_xtable").html(),
	                none: angular.element("#tpl_none_profile_list_xtable").html(),
	                loading: angular.element("#tpl_loading").html()
	            },
    		    sort: true,
                fields: ["objName", "serviceName", "startTimeFmt", "endTimeFmt", "elapsed", "sqlTime", "cpu", "error"],
	            resize: true,
	            buffer: "scroll",
	            bufferCount: 20,
	            scrollHeight: 220
	        });
	    });
	    
	    jui.ready([ "grid.xtable" ], function(juiXTable) {
	    	$scope.profileText = juiXTable("#profileTextXtable", {
	            data:$scope.profileTextData,
	            event: {
	            	select: function(row, e) {
	            		if ($(row.element).hasClass("selected")) {
	            			//this.unselect(row.index);
	            		} else {
	            			this.select(row.index);
	            			var title = "프로파일 상세정보";
	            			var text = row.data.contents;
	            			text = text.replace(/&nbsp;/gi,'');
	    					Common.alertDialog(title, text);
	            			
	            		}; 	            			            		              	
	            	}
	             },
	            tpl: {
	                row: angular.element("#tpl_row_profile_text_xtable").html(),
	                none: angular.element("#tpl_none_profile_text_xtable").html(),
	                loading: angular.element("#tpl_loading").html()
	            },
	            resize: true,
	            buffer: "scroll",
	            bufferCount: 20,
	            scrollHeight: 220
	        });
	    });
	}
   
// ===============================================================================
// <-- jui 
// ===============================================================================    
// ===============================================================================
// function -->  
// ===============================================================================    
	function getDateTime (date, time) {
		var result = [];
		var split = date.split('/');
		var year = split[0];		
		var month = split[1];
		var day = split[2];
		split = time.split(':');
		var hour = split[0];
		var min = split[1];
		
		var dateString = year + '-' + month + '-' + day + ' ' + hour + ':' + min + ':00';
		var reggie = /(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})/;
		var dateArray = reggie.exec(dateString); 
		var dateObject = new Date(
			(+dateArray[1]),
			(+dateArray[2])-1,
			(+dateArray[3]),
			(+dateArray[4]),
			(+dateArray[5]),
			(+dateArray[6])			
		);
		
		return dateObject;		
	}
	
	function getInterval (start, end) {
		var gap = (end.getTime() - start.getTime()) / 60000;
		var interval = Math.ceil(gap/6);
		return interval;	
	}	
// ===============================================================================
// <-- function 
// ===============================================================================    
		
});//controller


