'use strict';
angular.module('popupApp')
.controller('XLogProfileCtrl', function ($scope, $rootScope, $interval, $timeout, $filter, $routeParams, Data, Common, StorageManager) {
// ===============================================================================
// initialize -->
// ===============================================================================
	
	$scope.serverId = $routeParams['serverId'];
	$scope.txid = $routeParams['txid'];
	$scope.xTyp = $routeParams['xTyp'];
	$scope.eTime = $routeParams['eTime'];
	
	var topologyData = {nodes:[], edges:[]};
	var boxElement = null;
	
	//UI comp
	$scope.topology = undefined;
	$scope.profileText = undefined;	
	
	$scope.profileListData = [];
	$scope.profileHead = {};
	$scope.profileTextData = [];    
	$scope.topologyData = [];
	$scope.topologyNodeData = [];
	$scope.topologyEdgeData = [];	
	$scope.topologyNmKey = [];	
		
	var DIR = 'images/topology/';
    var EDGE_LENGTH_MAIN = 150;
    var EDGE_LENGTH_SUB = 50;
    var fontStyle = {size:15, color:'#1e2533', face:'Nanum Gothic', strokeWidth:0}
   
    var imageUser = DIR + 'user.png';
    var imageHost = DIR + 'server.png';
    var imageInstance = DIR + 'was.png';
    var imageDB = DIR + 'db.png';
	
    $(document).ready(function(){
    	$scope.imageUrl = $rootScope.appImageLogoUrl;
    	$scope.apmNm = $rootScope.appName;
    	$scope.init();
	});
    
    $scope.init = function () {
    	
    	$scope.createXTable();
    	
    	var obj = {
    			serverId : $scope.serverId,
    			txid : $scope.txid,
    			xTyp :$scope.xTyp,
    			endTime :$scope.eTime,
    	}
    	
    	$scope.getProfileText(obj);
    	$scope.getTopologyData(obj);
    };	
        
// ===============================================================================
// initialize <--
// ===============================================================================
// ===============================================================================
// rest controller -->
// ===============================================================================    
    
    $scope.getTopologyData = function (obj) {
        
    	var params = {serverId: obj.serverId, txId: obj.txid, xTyp: obj.xTyp, eTime: obj.endTime};
    	
    	Data.ajax({url:'dashBoard/xLogFlow', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
	                //success
	            	$scope.topologyData = data;
	            	$scope.updateTopology(obj.txid);
    			}
    		} catch(ex) {}
    	}});
    };
    
    $scope.getProfileText = function (obj) {
    	if ($scope.profileText != undefined) {
    		$scope.profileText.showLoading();
    	};
    	var params = {serverId: obj.serverId, txId: obj.txid, xTyp: obj.xTyp, eTime: obj.endTime};
    	
    	Data.ajax({url:'dashBoard/xLogProfile', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
    				
	            	$scope.profileText.hideLoading();
	                //success
	            	$scope.profileTextData = data.logSteps;
	            	for (var i=0; i<$scope.profileTextData.length; i++) {
	            		$scope.profileTextData[i].no = i+1;
	            	} 
	            	$scope.profileText.hideLoading();  	
	            	$scope.profileText.update($scope.profileTextData);
	            	$scope.profileHead=data.value;

    			}
    		} catch(ex) {}
    	}});
    	Data.ajax({url:'dashBoard/xLogProfileText', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
	            	$scope.profileFullText=data.text;
    			}
    		} catch(ex) {}
    	}});	    	    	
    };
    
// ===============================================================================
// rest controller <--
// ===============================================================================
// ===============================================================================
// jui -->
// ===============================================================================    
    $scope.stepNext=function(curid,parid,error , lvl) {
    	lvl++;
		for(var n=0;n<$scope.topologyData.length;n++) {
			var data = $scope.topologyData[n];
			if(data.txid!=curid){
				continue;
			}
			var objNm=data.objName;
			if(/.+\/(.+)/.test(objNm)){
				objNm=RegExp.$1;
			}
			if(parid=='caller'){
				$scope.topologyNodeData.push({ id: parid, label: data.ipaddr, level: 0, image: imageUser, shape: 'image', font: fontStyle});
			}
			$scope.topologyNodeData.push({ id: curid, label: data.serviceName+'\n\r( '+objNm+' ) ', level: lvl, image: imageHost, shape: 'image', font: fontStyle});
			$scope.topologyEdgeData.push({from: parid, to: curid, label: data.elapsed+' ms', length: EDGE_LENGTH_MAIN, font: fontStyle, color:$scope.lineStyle(error), arrows:'to'});
			if (data.step.length != 0) {
				for (var i=0; i<data.step.length; i++) {
					var txid = '';
					var stepType = data.step[i].stepType;
					var name = '';
					var type = '';
					var elapsed = '';
					var image = '';
					var title = null;
					if(stepType==2||stepType==8||stepType==16){
						if(data.step[i].name)
							name = data.step[i].name ;
						else if(data.step[i].sql.length<15)
							name= data.step[i].sql;
						else
							name="";
						type = 'db';
						elapsed = data.step[i].elapsed+'(ms)';
						txid = 's_'+data.step[i].hash;
						image = imageDB;
						title = data.step[i].sql;
					}else if(stepType==6){
						$scope.stepNext(data.step[i].txid, curid,0, lvl);
						continue;
					}else{
						name = data.step[i].name;
						type = 'server';
						elapsed = data.step[i].elapsed+'(ms)';
						txid = 'p_'+data.step[i].txid;
						image = imageInstance;
					}
					if(!$scope.topologyNmKey[txid]){
						$scope.topologyNodeData.push({ id: txid, label: name, level: lvl+1, image: image, shape: 'image', font: fontStyle, title: title});
					}
					$scope.topologyNmKey[txid]=1;
					$scope.topologyEdgeData.push({from: curid, to: txid, label: elapsed, length: EDGE_LENGTH_MAIN, font: fontStyle, color:$scope.lineStyle(data.step[i].error), arrows:'to'});
					
				};		
			};
		}    	
    };
	$scope.lineStyle = function(error) {
	    return error==0 ? {color:'#b2b2b2'} : {color:'red'};
	}
	$scope.updateTopology = function(curid) {
		$scope.topology=null;
		
		$scope.topologyNodeData = [];
		$scope.topologyEdgeData = [];
		$scope.topologyNmKey = {};

		$scope.stepNext(curid ,'caller', 0,0);
		
		boxElement = $("#topologyViewTab");
    	var container = $("#topology");
		var options = {
			width : '100%',
			height : '100%',
			edges: {
				smooth: {
					type: 'cubicBezier',
					forceDirection: 'horizontal',
					roundness: 0.4 
				}
			},
			layout: {
				hierarchical: {
					direction: "LR", //"UD", DU, LR, RL
					sortMethod: "directed",
					nodeSpacing: 100,
					levelSeparation: 300
	        	}
	        },
	        physics:false
		}; //options
		
		topologyData.nodes = $scope.topologyNodeData;
		topologyData.edges = $scope.topologyEdgeData;
		$scope.topology = new vis.Network(container[0], topologyData, options);
	};
	$scope.openXLogProfilePopup = function(serverId, txid, eTime, xTyp) {
		if(txid==$scope.txid){
			return;
		}
		var popupX = (window.screen.width/2) - (1280/2);
    	var popupY = (window.screen.height/2) - (720/2);
    	
    	var popup = window.open("popup.html#/xlog_profile/"+serverId+"/"+txid+"/"+eTime+"/"+xTyp, "popup"+(new Date()).getTime(), "width=1280, height=720, left="+popupX+", top="+popupY);
    	
    };	
	$scope.createXTable = function() {
	    jui.ready([ "grid.xtable" ], function(juiXTable) {
	    	$scope.profileText = juiXTable("#profileTextXtable", {
	            data:$scope.profileTextData,
	            event: {
//	            	select: function(row, e) {
//	            		if ($(row.element).hasClass("selected")) {
//	            			//this.unselect(row.index);
//	            		} else {
//	            			this.select(row.index);
//	            			var title = "프로파일 상세정보";
//	    					Common.alertDialog(title, row.data.contents);
//	            			
//	            		}; 	            			            		              	
//	            	}
	             },
	            tpl: {
	                row: angular.element("#tpl_row_profile_text_xtable").html(),
	                none: angular.element("#tpl_none_profile_text_xtable").html(),
	                loading: angular.element("#tpl_loading").html()
	            },
	            resize: true,
	            buffer: "scroll",
	            bufferCount: 20,
	            scrollHeight: 220
	        });
	    });
	}
   
// ===============================================================================
// <-- jui 
// ===============================================================================    
// ===============================================================================
// function -->  
// ===============================================================================    
// ===============================================================================
// <-- function 
// ===============================================================================    
		
});//controller


