'use strict';
angular.module('popupApp')
.controller('XLogRealCtrl', function ($scope, $rootScope, $interval, $timeout, $filter, $routeParams, Data, Common, StorageManager) {
   	var topologyData = {nodes:[], edges:[]};
	var boxElement = null;
	
	
	var selectedData=opener.selectedData;
	var userInfo=opener.userInfo;
	$scope.userInfo = userInfo;
	$scope.topology = undefined;
	$scope.realProfileList = undefined;
	$scope.profileText = undefined;
	
	$scope.realProfileListData = [];    	
	$scope.profileHead = {};    	
	$scope.profileTextData = [];    	
	$scope.topologyData = [];
	$scope.topologyNodeData = [];
	$scope.topologyEdgeData = [];	
	$scope.profileFullTex='';
		

    $scope.txInfo = "";
    $scope.selected = [];
    $scope.xLogDatas = [];
    $scope.txProfiles = [];
    
    var DIR = 'images/topology/';
    var EDGE_LENGTH_MAIN = 150;
    var EDGE_LENGTH_SUB = 50;
    var fontStyle = {size:20, color:'#1e2533', face:'Nanum Gothic', strokeWidth:0}
   
    var imageUser = DIR + 'user.png';
    var imageHost = DIR + 'server.png';
    var imageInstance = DIR + 'was.png';
    var imageDB = DIR + 'db.png';
    var lineStyle = {color:'#b2b2b2'}
    
    $(document).ready(function(){
        $scope.init();
    });
    
    $scope.init = function () {
        jui.ready([ "grid.xtable" ], function(juiXTable) {
        	$scope.realProfileList = juiXTable("#profileListXtable", {
                data:$scope.realProfileListData,
                event: {
	            	 select: function(row, e) {
	            		if ($(row.element).hasClass("selected")) {
	            			//this.unselect(row.index);
	            		} else {
	            			this.select(row.index);
	            			$scope.getProfileText(row, e);
	            			$scope.getTopologyData(row, e);
	            		};	            			            		              	
	            	 }
                 },
                tpl: {
                    row: angular.element("#tpl_row_profile_list_xtable").html(),
	                none: angular.element("#tpl_none_profile_list_xtable").html(),
	                loading: angular.element("#tpl_loading").html()                        
                },
                resize: true,
                sort: true,
                fields: ["objName", "serviceName", "startTimeFmt", "endTimeFmt", "elapsed", "sqlTime", "cpu", "error", "ipaddr"],
                buffer: "scroll",
                bufferCount: 20,
                scrollHeight: 220
            });
        });
        
        jui.ready([ "grid.xtable" ], function(juiXTable) {
        	$scope.profileText = juiXTable("#profileTextXtable", {
                data:$scope.profileTextData,
                event: {
	            	select: function(row, e) {
	            		if ($(row.element).hasClass("selected")) {
	            			//this.unselect(row.index);
	            		} else {
	            			this.select(row.index);
	            			var title = "프로파일 상세정보";
	            			var text = row.data.contents;
	            			text = text.replace(/&nbsp;/gi,'');
	    					Common.alertDialog(title, text);
	            			
	            		}; 	            			            		              	
	            	}
	             },
                tpl: {
                    row: angular.element("#tpl_row_profile_text_xtable").html(),                       
	                none: angular.element("#tpl_none_profile_text_xtable").html(),
	                loading: angular.element("#tpl_loading").html()
                },  
                resize: true,
                buffer: "scroll",
                bufferCount: 20,
                scrollHeight: 220,
               /* expand:true,*/
                animate:true                                        
            });
        });
        	
        $scope.getProfileList();
    };

    $scope.cancel = function() {
        $mdDialog.cancel();
    };

    $scope.onSelect = function (item) {
    };
    
    $scope.getProfileList = function () {
    	var sTime, eTime, minValue, maxValue;
    	sTime=new Date(selectedData.x1).getTime()-100;
    	eTime=new Date(selectedData.x2).getTime()+100;
    	minValue=Math.floor(selectedData.y1);
    	var y2=Math.ceil(selectedData.y2);
    	var maxValue = 1000;
    	
    	if (minValue < 30){
    		minValue = -100;
    	}

    	if(y2>(opener.xlogYMax*0.97) ){
    		maxValue=1000000000;//150000;
    	}else{
    		maxValue=y2;
    	}
    	
       	var normalFilter=opener.normalFilter;
    	var errorFilter=opener.errorFilter;
    	var oid = opener.selectedAgentIds.toString(',');
    	var params = {type: 'svc', oid: oid, sTime: sTime, eTime: eTime, minValue: minValue, maxValue: maxValue, normalFilter:normalFilter, errorFilter:errorFilter};
    	
    	Data.ajax({url:'dashBoard/xLogList', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
                    //success            		
                	$scope.realProfileListData = data;
                	$scope.realProfileList.update($scope.realProfileListData);
    			}
    		} catch(ex) {}
    	}});
    };
    
    $scope.getTopologyData = function (obj, e) {
    	var params = {serverId: obj.data.serverId, txId: obj.data.txid, eTime: obj.data.endTime};
    	
    	Data.ajax({url:'dashBoard/xLogFlow', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
                    //success
                	$scope.topologyData = data[0];
                	$scope.updateTopology();
    			}
    		} catch(ex) {}
    	}});
    };
    
    $scope.getProfileText = function (obj, e) {
		if ($scope.profileText != undefined) {
			$scope.profileText.showLoading();
		};
		var params = {serverId: obj.data.serverId, txId: obj.data.txid, eTime: obj.data.endTime};
    	
    	Data.ajax({url:'dashBoard/xLogProfile', param:params, successCallback:function(data, status) {
    		try {
    			if(data) {
	                //success
					$scope.profileText.hideLoading();
					
					$scope.profileTextData = data.xLogProfile.logSteps;
					for (var i=0; i<$scope.profileTextData.length; i++) {
						$scope.profileTextData[i].no = i+1;
						if($scope.profileTextData[i].pId != ""){
							var space = "";
							for(var x=0;x<$scope.profileTextData[i].contents.length;x++) {
								if($scope.profileTextData[i].contents.charAt(x)!=' '){
									break;
								}
								space = space + "&nbsp;&nbsp;&nbsp;&nbsp;";
							}
							$scope.profileTextData[i].contents = space + $scope.profileTextData[i].contents;
						}
						
						$scope.profileTextData[i].sqlExecAuthYn = $scope.userInfo.sqlExecAuthYn;
						$scope.profileTextData[i].sqlParmAuthYn = $scope.userInfo.sqlParmAuthYn;
					}
					$scope.profileText.update($scope.profileTextData);
					$scope.profileHead=data.xLogProfile.value;
					$scope.profileFullText=data.text;
    			}
    			$scope.profileText.hideLoading();
			} catch(ex) {
				$scope.profileText.hideLoading();
			}
		}});
	};

	$scope.updateTopology = function() {
		$scope.topology=null;
		
		var data = $scope.topologyData;
		$scope.topologyNodeData = [];
		$scope.topologyEdgeData = [];
		
		$scope.topologyNodeData.push({ id: 'ui', label: 'UI', level: 1, image: imageHost, shape: 'image', font: fontStyle});
		$scope.topologyNodeData.push({ id: 'root', label: data.serviceName+'\n\r( '+data.objName+' ) ', level: 2, image: imageHost, shape: 'image', font: fontStyle});
		$scope.topologyEdgeData.push({from: 'root', to: 'ui', label: data.elapsed+'(ms)', length: EDGE_LENGTH_MAIN, font: fontStyle, color:lineStyle});

		if (data.step.length != 0) {
			for (var i=0; i<data.step.length; i++) {
				var txid = '';
				var stepType = data.step[i].stepType;
				var name = '';
				var type = '';
				var elapsed = '';
				var image = '';
				var title = null;
				if(stepType==2||stepType==8||stepType==16){
					name = data.step[i].name ? data.step[i].name.replace(/,/g,",\n\r") :  data.step[i].sql;
					type = 'db';
					txid = 's_'+i;
					image = imageDB;
					title = data.step[i].sql;
				}else{
					name = data.step[i].name;
					type = 'server';
					elapsed = data.step[i].elapsed+'(ms)';
					txid = 'p_'+data.step[i].txid;
					image = imageInstance;
				}
				
				$scope.topologyNodeData.push({ id: txid, label: name, level: 3, image: image, shape: 'image', font: fontStyle, title: title});
				$scope.topologyEdgeData.push({from: txid, to: 'root', label: elapsed, length: EDGE_LENGTH_MAIN, font: fontStyle, color:lineStyle});
				
			};		
		};
		
		boxElement = $("#topologyViewTab");
    	var container = $("#topology");
		var options = {
			width : '100%',
			height : '100%',
			edges: {
				smooth: {
					type: 'cubicBezier',
					forceDirection: 'horizontal',
					roundness: 0.4 
				}
			},
			layout: {
				hierarchical: {
					direction: "LR", //"UD", DU, LR, RL
//					sortMethod: "directed",
					nodeSpacing: 100,
					levelSeparation: 250
	        	}
	        },
	        physics:false
		}; //options
		
		topologyData.nodes = $scope.topologyNodeData;
		topologyData.edges = $scope.topologyEdgeData;
		
		$scope.topology = new vis.Network(container[0], topologyData, options);
	};
	
	$scope.openXLogProfilePopup = function(serverId, txid, eTime, xTyp) {
		var popupX = (window.screen.width/2) - (1280/2);
    	var popupY = (window.screen.height/2) - (720/2);
    	
    	var popup = window.open("popup.html#/xlog_profile/"+serverId+"/"+txid+"/"+eTime+"/"+xTyp, "popup"+(new Date()).getTime(), "width=1280, height=720, left="+popupX+", top="+popupY);
    	
    };

    $scope.openXLogSQLPopup = function(data) {
	
    }
});//controller


