angular.module(
  'wowUIGrid', 
  [
  'ui.grid', 
  'ui.grid.cellNav', 
  'ui.grid.edit', 
  'ui.grid.resizeColumns', 
  'ui.grid.pinning', 
  'ui.grid.selection', 
  'ui.grid.moveColumns'
  ]
);

angular.module('wowUIGrid')
  .controller('MainCtrl', MainCtrl);

MainCtrl.$inject = ['$scope', '$http', 'uiGridConstants'];

function MainCtrl($scope, $http, uiGridConstants) {
  $scope.name = 'World';
  $scope.gridOptions = {
    enableFiltering: true,
    showGridFooter:true,
    showColumnFooter:false,
    onRegisterApi: function(gridApi){
      $scope.gridApi = gridApi;
      console.log("init api");
    },
    columnDefs: [
      { field: 'name', width: 100,
        pinnedLeft: 'left'
      },
      { field: 'gender',width: 100},                               
      { field: 'company',width: 100, enableFiltering: false },
      { field: 'email',width: 100, enableFiltering: false },
      { field: 'phone',width: 100, enableFiltering: false },
      { field: 'age',width: 130, enableFiltering: false },
      { field: 'mixedDate', width: '15%', enableFiltering: false },
      { field: 'company',width: 100, enableFiltering: false },
      { field: 'email',width: 100, enableFiltering: false },
      { field: 'phone', width: 100,enableFiltering: false },
      { field: 'company',width: 100, enableFiltering: false },
      { field: 'email', width: 100,enableFiltering: false },
      { field: 'phone',width: 100, enableFiltering: false },
      { field: 'company', width: 100,enableFiltering: false },
      { field: 'email', width: 100,enableFiltering: false },
      { field: 'phone', width: 100,enableFiltering: false },
      { field: 'company',width: 100, enableFiltering: false },
      { field: 'email',width: 100, enableFiltering: false },
      { field: 'phone',width: 100, enableFiltering: false }
    ]
  };
  
  $http.get('https://cdn.rawgit.com/angular-ui/ui-grid.info/gh-pages/data/500_complex.json')
    .success(function(data) {
      $scope.gridOptions.data = data;
    });
}
