'use strict';
var app = angular.module('mainApp',
		[ 'ngAnimate', 'ngMessages', 'ngCookies', 'ngResource', 'ngRoute', 'ngSanitize', 'ngMaterial', 'gridster', 'toastr', 'material.components.tooltip',
			'ui.grid', 'ui.grid.cellNav', 'ui.grid.edit', 'ui.grid.resizeColumns', 'ui.grid.pinning', 'ui.grid.selection', 'ui.grid.moveColumns', 'ui.grid.pagination', 'ivh.treeview']);

app.config(function($routeProvider) {
	$routeProvider.when('/', {
		templateUrl : 'views/main/login.html',
		controller : 'LoginCtrl',
		controllerAs : 'login'	
	}).when('/error', {
		templateUrl : 'views/main/error.html',
		controller : 'ErrorCtrl',
		controllerAs : 'error'
	}).when('/login', {
		templateUrl : 'views/main/login.html',
		controller : 'LoginCtrl',
		controllerAs : 'login'
	}).when('/signup', {
		templateUrl : 'views/main/signup.html',
		controller : 'SignupCtrl',
		controllerAs : 'signup'
	}).when('/dashboard', {
		templateUrl : 'views/main/dashBoard.html',
		controller : 'DashBoardCtrl',
		controllerAs : 'dashBoard'			
	}).when('/dashBoardSetting', {
		templateUrl : 'views/main/dashBoardSetting.html',
		controller : 'DashBoardSettingCtrl',
		controllerAs : 'dashBoardSetting'		
	}).when('/topology', {
		templateUrl : 'views/main/topology.html',
		controller : 'TopologyCtrl',
		controllerAs : 'topology'
	}).when('/monitoring', {
		templateUrl : 'views/main/monitoring.html',
		controller : 'MonitoringCtrl',
		controllerAs : 'monitoring'	
    }).when('/statistics_application', {
        templateUrl : 'views/main/statisticsApplication.html',
        controller : 'StatisticsApplicationCtrl',
        controllerAs : 'statisticsApplication'	
	}).when('/statistics_graph', {
		templateUrl : 'views/main/statisticsGraph.html',
		controller : 'StatisticsGraphCtrl',
		controllerAs : 'statisticsGraph'			
	}).when('/statistics_query', {
		templateUrl : 'views/main/statisticsQuery.html',
		controller : 'StatisticsQueryCtrl',
		controllerAs : 'statisticsQuery'
	}).when('/performance', {
		templateUrl : 'views/main/performance.html',
		controller : 'PerformanceCtrl',
		controllerAs : 'performance'
	}).when('/settings_agent', {
		templateUrl : 'views/main/settingsAgent.html',
		controller : 'SettingsAgentCtrl',
		controllerAs : 'settingsAgent'
	}).when('/settings_node', {
		templateUrl : 'views/main/settingsNode.html',
		controller : 'SettingsNodeCtrl',
		controllerAs : 'settingsNode'
	}).when('/settings_group', {
		templateUrl : 'views/main/settingsGroup.html',
		controller : 'SettingsGroupCtrl',
		controllerAs : 'settingsGroup'
	}).when('/settings_user', {
		templateUrl : 'views/main/settingsUser.html',
		controller : 'SettingsUserCtrl',
		controllerAs : 'settingsUser'
	}).when('/statistics_analyze', {
        templateUrl : 'views/main/statisticsAnalyze.html',
        controller : 'statisticsAnalyzeCtrl',
        controllerAs : 'statisticsAnalyze'
	}).when('/report', {
        templateUrl : 'views/main/report.html',
        controller : 'reportCtrl',
        controllerAs : 'report'
	}).otherwise({
		redirectTo : '/'
	});
});

app.config(function($mdThemingProvider) {
	$mdThemingProvider.theme('docs-dark', 'default')
    .primaryPalette('yellow')
    .accentPalette('blue')
    .dark();
});

			
app.filter('object2Array', function() {
	return function(input) {
		var out = [];
		for (var i in input) {
			out.push(input[i]);
		}
		return out;
	}
});

app.service('WidgetInfoManager', widgetInfoManagerService);
    function widgetInfoManagerService($rootScope) {
        return {
        getWidgetInfo: function (id) {
        	for (var i=0; i<$rootScope.widgetInfo.length; i++) {
        		if ($rootScope.widgetInfo[i].id == id) {
        			return $rootScope.widgetInfo[i];
        		}
         	}
        },
    }
}
    
app.service('StorageManager', storageManagerService);
    function storageManagerService($rootScope) {
        return { 
        	getUserInfo : function () {
        		return $rootScope.userInfo;
        	},
        	getMyDashboards: function () {
                return angular.fromJson(localStorage.getItem('watch_apm_myDashboards'));
            },
            setMyDashboards: function (myDashboards) {
                return localStorage.setItem('watch_apm_myDashboards', angular.toJson(myDashboards));
            },
            clearMyDashboards: function () {
                return localStorage.removeItem('watch_apm_myDashboards');
            },	
            
            getAllAgent: function () {
            	return angular.fromJson(localStorage.getItem('watch_apm_allAgent'));
            },
            setAllAgent: function (allAgent) {
            	return localStorage.setItem('watch_apm_allAgent', angular.toJson(allAgent));
            },
            clearAllAgent: function () {
            	return localStorage.removeItem('watch_apm_allAgent');
            },    
            
            /*getSelectedAgent: function () {
            	return angular.fromJson(localStorage.getItem('watch_apm_selectedAgent'));
            },
            setSelectedAgent: function (selectedAgent) {
            	return localStorage.setItem('watch_apm_selectedAgent', angular.toJson(selectedAgent));
            },
            clearSelectedAgent: function () {
            	return localStorage.removeItem('watch_apm_selectedAgent');
            },*/  
            getSelectedGroup: function () {
            	return angular.fromJson(localStorage.getItem('watch_apm_selectedGroup'));
            },
            setSelectedGroup: function (selectedGroup) {
            	return localStorage.setItem('watch_apm_selectedGroup', angular.toJson(selectedGroup));
            },
            clearSelectedGroup: function () {
            	return localStorage.removeItem('watch_apm_selectedGroup');
            },  
            getXlogYMax: function (grp) {
            	var v2=angular.fromJson(localStorage.getItem('watch_apm_XlogYMax_'+(grp ? grp.id : "no")));
            	return v2 ? v2:10000;
            },
            setXlogYMax: function (grp,v1) {
            	return localStorage.setItem('watch_apm_XlogYMax_'+(grp ? grp.id : "no"), v1);
            },
            
            getTimeGap: function () {
            	return localStorage.getItem('watch_apm_timeGap');
            },
            setTimeGap: function (timeGap) {
            	return localStorage.setItem('watch_apm_timeGap', timeGap);
            },
            clearTimeGap: function () {
            	return localStorage.removeItem('watch_apm_timeGap');
            }                      
    }
};

app.directive('ngEnter', function() {
	  return function(scope, element, attrs) {
		  element.bind("keydown keypress", function(event) {
			  if(event.which === 13) {
				  scope.$apply(function() {
					  scope.$eval(attrs.ngEnter, {'event': event});
				  });
				  
				  event.preventDefault();
			  }
		  });
	  };
});


/**
 * ui-grid custom 페이징 공통
 * @returns
 */
app.service('Paginator', PaginatorService);
function PaginatorService($rootScope) {
	return {		
		// 페이지 이동 :: ex) setPage(13) => 13페이지로 이동
		setPage: function(page) {				
									
			var vm = this._scope;		
			
			var tmpGridOptions = this._gridOptions;
			vm.pager = {};							
			
			if (tmpGridOptions != null && tmpGridOptions != undefined){
				var tmpGridApi = this._gridApi;
				
				if (page < 1 || page > this.getTotalPages(tmpGridOptions.data.length, tmpGridOptions.paginationPageSize)) {
					return;
				}			
					
				tmpGridOptions.pager = this.getPager(tmpGridOptions.data.length, page, tmpGridOptions.paginationPageSize);
							
				tmpGridApi.pagination.seek(page);
			}else{
				// 존재하지 않는 페이지 예외처리
				if (page < 1 || page > this.getTotalPages(vm.gridOptions.data.length, vm.gridOptions.paginationPageSize)) {
					return;
				}			
					
				vm.gridOptions.pager = this.getPager(vm.gridOptions.data.length, page, vm.gridOptions.paginationPageSize);
							
				vm.gridApi.pagination.seek(page);
			}
			
				
		},
		
		// 현재 사용중인 Controller Scope 받아 Paginator 에서 사용할 사본 생성
		setScope: function(scope) {
			this._scope = scope;
		
		},			
		
		// 현재 사용중인 Controller Scope 받아 Paginator 에서 사용할 사본 생성
		setScopeParamAdd: function(scope, gridOptions, gridApi) {
			this._scope = scope;
			this._gridOptions = gridOptions;
			this._gridApi = gridApi;
		},	
		// 전체 페이지 수 계산 return
		getTotalPages: function(totalItems, pageSize) {
			return Math.ceil(totalItems / pageSize);
		},
		
		/**
		 * 페이징 관련 필요 데이터 가공 
		 * 페이징 번호리스트 호출
		 * ex) pages: 3 4 5 6 7 8(current page) 9 10 11 12
		 * totalItems : 전체 데이터 수
		 * currentPage : 현재 페이지
		 * pageSize : 페이지당 보여질 리스트 수
		 * optionsCnt : select 박스 옵션 사용 개수
		 * numPerPage : 페이지번호(pages) 개수
		 */			
		getPager : function(totalItems, currentPage, pageSize, optionsCnt, numPerPage) {
			
			var totalPages = this.getTotalPages(totalItems, pageSize); //Math.ceil(totalItems / pageSize); // 전체 페이지 수 계산
			
			currentPage = currentPage || 1;
	
			pageSize = pageSize || 10;
			
			optionsCnt = optionsCnt || 3;
			optionsCnt = (optionsCnt < 1) ? 0 : optionsCnt;
			
			numPerPage = numPerPage || 10; // 
			numPerPage = (numPerPage < 1) ? 1 : numPerPage; //  페이지번호는 최소 1개 
			 				
			var options = new Array();
			
			if (totalPages / optionsCnt >= 1) {
				var splitNumber = Math.floor(totalPages/optionsCnt);
				for (var i=1; i<=optionsCnt; i++) {
					var info = new Object();
					var value = (splitNumber * i > 0) ? splitNumber * i : 1;
					info.id = value;
					info.name = value;
					
					options[i-1] = info;
					//options.push(splitNumber * i);
				}	
			}
			
			var startPage, endPage;
			if (totalPages <= numPerPage) {
				// less than numPerPage total pages so show all
				startPage = 1;
				endPage = totalPages;
			} else {				
				if (currentPage <= Math.ceil(numPerPage/2)) {
					startPage = 1;
					endPage = numPerPage;
				} else if (currentPage + (numPerPage - Math.ceil(numPerPage/2)) > totalPages) {
					startPage = totalPages - numPerPage + 1;
					endPage = totalPages;
				} else {					
					startPage = currentPage - (numPerPage - Math.ceil(numPerPage/2));
					endPage = currentPage + (numPerPage - Math.ceil(numPerPage/2));
					endPage = (numPerPage % 2 == 0) ? endPage - 1 : endPage;
				}
			}
	
			// calculate start and end item indexes
			var startIndex = (currentPage - 1) * pageSize;
			var endIndex = Math.min(startIndex + pageSize - 1, totalItems - 1);
	
			// create an array of pages to ng-repeat in the pager control
			//var pages = _.range(startPage, endPage + 1);		
			var pages = [];
			for (i=startPage; i<endPage+1; i++) {	   
				pages.push(i);
			}	
	
			// return object with all pager properties required by the view
			
			return {
				totalItems: totalItems, //전체 데이터 수
				currentPage: currentPage, // 현재 페이지
				pageSize: pageSize, // 
				totalPages: totalPages,
				startPage: startPage,
				endPage: endPage,
				startIndex: startIndex,
				endIndex: endIndex,
				pages: pages,
				options: options
			};				
		}
	}		
}

/**
 * 페이징 공통 HTML
 * @returns
 */	
app.directive('pagination', function() {
	  return {
		  restrict: 'AE',
//		  scope: {
//			  loadInfo: '=info'
//		  },
//		  link: function($scope, Paginator) {
//			  $scope.$watch('loadInfo', function(newVal, oldVal) {		
//			  });
//		  },
		  scope: false,

		  templateUrl: 'views/main/paginator.html'
	  }
});


//app.directive('autoFocus', function($timeout) {
//	return {
//		restrict: 'A',
//		link: function(_scope, _element){
//			$timeout(function(){
//				_element[0].focus();
//			}, 0);
//		}
//	};
//});


app.run(function($rootScope, $location, Data, $cookies, StorageManager, $mdDialog, Common, $timeout, $interval) {
	var widgetInfo =
		[
			{ id:1, type:"RealTimeActiveService",    title:"최근 액티브서비스 개수", 		tooltip: "선택된 서비스 그룹 또는 에이전트에 대해 최근 액티브 서비스 수를 표출(30초 평균)   		<br><div class='boldName'>x=</div> 시간(1min), <div class='boldName'>y=</div> 액티브 서비스 수(건)"},
			{ id:2, type:"RealTimeActiveServiceEQ",  title:"실시간 액티브서비스 개수", 		tooltip: "선택된 서비스 그룹 또는 에이전트에 대해 실시간 액티브 서비스 수를 표출		<br><font color='#38c3ff'>■</font> 3초 이하<br><font color='#ffb500'>■</font> 3초 이상<br><font color='#ff474c'>■</font> 8초 이상<br><font color='#808080'>■</font> 수집서버와 통신단절시<br><div class='boldName'>x=</div> 에이전트 명, <div class='boldName'>y=</div> 액티브 서비스 수(건)"},
			{ id:3, type:"RealTimeXlog", 			 title:"응답시간 분포도", 			tooltip: "응답이 완료된 트랜잭션을 차트로 표출					   		<br><font color='#38c3ff'>■</font> 3초 이하<br><font color='#ffb500'>■</font> 3초 이상<br><font color='#ff474c'>■</font> 오류가 발생한 경우<br><div class='boldName'>x=</div> 시간(1min), <div class='boldName'>y=</div>응답시간(초)"},
			{ id:4, type:"RealTimeProcessCPU", 		 title:"최근 프로세스 CPU 사용률(%)",  tooltip: "선택된 서비스 그룹 또는 에이전트에 대해 최근 JVM 프로세스 CPU 사용률을 표출 	<br><div class='boldName'>x=</div> 시간(1min), <div class='boldName'>y=</div> CPU사용률(%)"},
			{ id:5, type:"RealTimeSystemCPUEQ", 	 title:"시스템 CPU 사용률(%)", 		tooltip: "선택된 서비스 그룹 또는 에이전트의 호스트 CPU 사용률을 표출			<br><font color='#38c3ff'>■</font> NICE<br><font color='#80ff00'>■</font> SYS<br><font color='#8000ff'>■</font> USER<br><font color='#ff474c'>■</font> WAIT<br><font color='#808080'>■</font> 수집서버와 통신단절시<br><div class='boldName'>x=</div> 호스트명, <div class='boldName'>y=</div> CPU사용률(%)"},
			{ id:6, type:"RealTimeHeapMemory", 		 title:"힙 메모리 사용률(%)", 		tooltip: "선택된 서비스 그룹 또는 에이전트에 대해 힙(Heap) 메모리 사용률 표출<br><div class='boldName'>x=</div> 시간(5min), <div class='boldName'>y=</div> 힙(Heap) 메모리 사용률(%)"},
            { id:7, type:"CounterTodayTPS", 		 title:"서비스 처리량(24시간)", 		tooltip: "선택된 서비스 그룹 또는 에이전트에 대해 서비스 처리량이 표출<br><div class='boldName'>x=</div> 시간, <div class='boldName'>y=</div>서비스 처리건수(건)"},
            { id:8, type:"RealTimeActiveThreadList", title:"실시간 요청 서비스 목록", 		tooltip: "선택된 서비스 그룹 또는 에이전트에 대해 실시간 요청 서비스 목록을 표출		<br>리스트에 표출된 건을 클릭하면 상세 스레드(Thread) 정보가 표출"},
            { id:9, type:"CounterTodayVisitor", 	 title:"시간당 방문자수(24시간)", 		tooltip: "선택된 서비스 그룹 또는 에이전트에 대해 시간당 방문자수가 표출<br>시간당 접속해 있는 사용자 합계<br><div class='boldName'>x=</div> 시간, <div class='boldName'>y=</div>시간당 방문자수(명)"},
			{ id:10, type:"CounterTodayCurrentUser", title:"동시 사용자수(24시간)", 		tooltip: "선택된 서비스 그룹 또는 에이전트에 대해 동시 사용자수가 표출<br>5분간 1회라도 서비스 요청한 유니크한 사용자 합계<br>시간당 접속해 있는 사용자 합계<br><div class='boldName'>x=</div> 시간, <div class='boldName'>y=</div>동시 사용자수(명)"},
            { id:11, type:"RealTimeDBCounter", 		 title:"DB 커넥션 개수", 			tooltip: "선택된 서비스 그룹 또는 에이전트의 Active DB 커넥션 개수를 표출			<br>DB 컨넥션 정보는 WAS에 DB Pool 사용시 확인 가능<br><div class='boldName'>x=</div> 시간(1min), <div class='boldName'>y=</div>Active DB 커넥션 개수(건)"},
			{ id:12, type:"TopologyView", 			 title:"토폴로지", 				tooltip: ""}
		]; 

	var myDashboards = [
		{
			id:0,
			name: "Dashboard",
			widgets:
				[
					{ col:0, row:2, sizeX:2, sizeY:1, id: 1 },					
					{ col:0, row:0, sizeX:6, sizeY:1, id: 2 },
					{ col:6, row:0, sizeX:3, sizeY:2, id: 3 },
					{ col:0, row:3, sizeX:2, sizeY:1, id: 4 },
					{ col:0, row:1, sizeX:4, sizeY:1, id : 5 },					
					{ col:2, row:2, sizeX:2, sizeY:1, id : 6 },
					{ col:4, row:1, sizeX:2, sizeY:1, id : 7 },
					{ col:6, row:2, sizeX:3, sizeY:2, id : 8 },
					{ col:4, row:2, sizeX:2, sizeY:1, id : 9 },
					{ col:4, row:3, sizeX:2, sizeY:1, id : 10 },
					{ col:2, row:3, sizeX:2, sizeY:1, id : 11 }
				]
		},
		{
			id:1,
			name: "Topology",
			widgets:
				[
					{ col:0, row:0, sizeX:6, sizeY:4, id: 12 },
					{ col:7, row:1, sizeX:3, sizeY:1, id: 6 },
					{ col:7, row:2, sizeX:3, sizeY:1, id: 11 },
					{ col:7, row:3, sizeX:3, sizeY:1, id: 5 },
					{ col:7, row:4, sizeX:3, sizeY:1, id : 2 }
				]
		}		
	];
    
	var authCheck = true;
	
	$rootScope.authenticated = false;
	$rootScope.logined = false;
	$rootScope.timeGap = 0;	
	$rootScope.userInfo = {};
	$rootScope.widgetInfo = widgetInfo;
	$rootScope.myDashboards = [];	
	$rootScope.allAgent = [];	
	$rootScope.selectedGroup = {};	
	$rootScope.selectedGroup.selectedAgent = [];
	$rootScope.selectedAgentIds = [];
	$rootScope.networkConnected = true;
	$rootScope.xlogYMax = 10000;
	$rootScope.xlogAutoYMax = 10000;
	$rootScope.xlogErrorFilter = false;
	
	$rootScope.loadDates = {currentUserLoadDate:"", serviceCallLoadDate:"", visitorLoadDate:""};	
	$rootScope.rcgnAuthenticationInfo = [];
	
	$rootScope.ContextPath      = "/app";          // 서버 ContextPath 기본값 
    $rootScope.RootPath         = ".";             // js, html, image 등의 파일경로
    $rootScope.urlPattern		= ".ajax";
    $rootScope.connectMode		= "ktds";
    $rootScope.noticeSeq = 0; //공지사항 번호
    $rootScope.notices = []; //공지사항 data
    $rootScope.noticeCloseFlag = true;
    $rootScope.ivhTreeData = undefined;
    
    if($rootScope.connectMode != "kt"){
    	$rootScope.appImageLogoUrl = "images/logo_big_DS.png";
    	$rootScope.appName = "OBICs Watch APM";
    }else{
    	$rootScope.appImageLogoUrl = "images/logo_big.png";
    	$rootScope.appName = "IT's Signal";
    }
    
    
	if (StorageManager.getMyDashboards() == undefined || StorageManager.getMyDashboards() == null) {
		StorageManager.clearMyDashboards();
		StorageManager.setMyDashboards(myDashboards);
	} else {
		if (StorageManager.getMyDashboards().length <= 0) {
			StorageManager.clearMyDashboards();
			StorageManager.setMyDashboards(myDashboards);
		}
	};
	
	
	$interval(function() {
		if (authCheck == false){
			return;
		}
		Data.ajax({url:'cmmn/authInfo', errorCallback:function(xhr, textStatus, errorThrown, errorCallback){
			if (xhr  == null){
				$rootScope.networkConnected = false;
				return;
    		}
		}, successCallback:function(data, status) {
			$rootScope.networkConnected = true;
			try {
				if(data) {
					// success 
					if (data == "" || data.name == 'anonymousUser' || data.name == undefined) {
						if($rootScope.authenticated){
							alertDialog("알림", "세션이 만료 되었습니다. 다시 로그인 하세요.");
						}
						$rootScope.authenticated = false;						
					}else {
						$rootScope.userInfo = data.userInfo;
						$rootScope.authenticated = true;
                                                if (data.licenseMsg != ""){
							Common.toastr(data.licenseMsg, "error", "N", null, null);
						}
					};
				}
			} catch(ex) {}
			
		}});
    }, 5000);
	
	
	/********** 대시보드 상단 공지사항 **********/
	$rootScope.tickerRunFlag = true;
	$rootScope.prevLocationHref = "";		
	
	$interval(function() {
		if($rootScope.authenticated != true){
			return;
		}
	    
		var params = {};		
    	Data.ajax({url:'notice/listNotice', param:params, successCallback:function(data, status) {
			try {				
				if(data) {
					
					if ($rootScope.prevLocationHref != location.href) {
						$rootScope.tickerRunFlag = true;
					}
					$rootScope.prevLocationHref = location.href
					
					//success
					for (var i = 0; i < data.list.length; i++) {
						data.list[i].inptDt = data.list[i].inptDt.substring(0,19);
						data.list[i].uptdDt = data.list[i].uptdDt.substring(0,19);
						data.list[i].startDt = data.list[i].startDt.substring(0,19);
						data.list[i].endDt = data.list[i].endDt.substring(0,19);
					}
					
					// 새로 시작 시 데이터 갱신						
					$rootScope.notices = data.list;
					if (data.list.length > 0){
						if ($rootScope.noticeSeq != data.list[0].seq){
							$rootScope.openNotice('noticeLarge', data.list[0].seq);
						}
						$rootScope.noticeSeq = data.list[0].seq;
					}else{
						$rootScope.noticeSeq = 0;
					}
					
					if ($rootScope.tickerRunFlag) {						
						
						 
						$rootScope.runTicker();
						$rootScope.tickerRunFlag = false;
					}									
				}
			} catch(ex) {}
		}});
		
	}, 7000);	
	
	$rootScope.runTicker = function() {
		$timeout(function() {
			$("#noticeList").slick({
				autoplay:true,
				autoplaySpeed: 5000,
				rows:1,
				/*infinite:true,*/
				arrows:false,
				dots:false,
				vertical: true
			});
			
		}, 1000);
	};
	
	$rootScope.$watch("noticeSeq", function(newVal, oldVal) {    	
    	if ( newVal !== oldVal && newVal > 0) {
	   		// 상단 공지사항 영역 노출 시 
	   		$('.notice-msg-besides').css('margin', '30px 0 0 0'); // 공지사항 영역 확보 (메뉴 네비게이션 영역을 아래로 => 닫기 버튼 클릭(closeNotice() )시 margin 제거 )
	   		$rootScope.noticeCloseFlag = false;
	   	}else if (newVal < 1){
	   		$rootScope.closeNotice();
	   	};
    });
	
	//공지사항
	$rootScope.closeNotice = function (){
    	$rootScope.noticeCloseFlag = true;
    	//$('.top-nav').css('margin-top', '0px'); // 상단 공지사항 영역 제거
    	$('.notice-msg-besides').animate( {margin: '0'}, 500, function(){ }); // 상단 공지사항 영역 제거
    	/*$('.navbar-fixed').animate( {height: '56px'}, 1000, function(){
        });*/
    }
    
	/********** // 대시보드 상단 공지사항 **********/
	
	//공지사항
	$rootScope.openNotice = function(type, val) {
    	var widgetType = type;
		if (widgetType == "noticeLarge") {
			var popupX = (window.screen.width/2) - (800/2);
			var popupY = (window.screen.height/2) - (800/2);
			$rootScope.noticeLargeHandler(popupX, popupY, val);
		}
    };
    function openNotice(val){
    	$rootScope.openNotice("noticeLarge", val);
    }
	$rootScope.noticeLargeHandler = function(popupX, popupY, val) {
		var hostindex = location.href.indexOf(location.host) + location.host.length;
		var serviceBase = location.href.substring(0, location.href.indexOf('/', hostindex + 1)) + "/";
		
    	window.open(serviceBase + "popup.html#/noticeLarge?param="+val, "noticeLarge", "width=750, height=750, left="+popupX+", top="+popupY);
    };

    
    
	$rootScope.myDashboards = StorageManager.getMyDashboards();

	// start main application 
	$rootScope.$on("$routeChangeSuccess", function(event, current, previous) {
		var path = current.$$route.originalPath;
		
		if (path == "/login" || path == "/signup" || path == "" || path == "ok"){
			authCheck = false;
		}else{
			authCheck = true;
		}
		
	});
	
	$rootScope.$on("$setServerDate", function() {
		var clientDate = new Date();
		var clientTime = clientDate.getTime(); 
		var serverDate, serverTime;
		
		Data.ajax({url:'cmmn/serverDate', successCallback:function(data, status) {
			try {
				if(data) {
	        		serverDate = new Date(data.timeMillis);
	    			serverTime = serverDate.getTime();
	    			StorageManager.clearTimeGap();
	    			StorageManager.setTimeGap(serverTime - clientTime);
				}
			} catch(ex) {}
		}});
	});
	
	$rootScope.$on("$routeChangeStart", function(event, next, current) {
		var path = next.$$route.originalPath;
		if (path != "/dashboard") {
			// 메인 대시보드 페이지가 아니면 toast 제거
			Common.toastrClearAll();
		}
		if (path == "/login" || path == "/signup" || path == "") { return; }
		var clientDate = new Date();
		var clientTime = clientDate.getTime(); 
		var serverDate, serverTime;
		
		var params = {};
		
		Data.ajax({url:'cmmn/authInfo', errorCallback:function(xhr, textStatus, errorThrown, errorCallback){
			if (xhr  == null){
				Common.alertDialog("오류", "네트워크 상태가 원할하지 않습니다.");
				return;
    		}
		}, successCallback:function(data, status) {
			try {
				if(data) {
					// success 
					if (data == "" || data.name == 'anonymousUser' || data.name == undefined) {
						if($rootScope.authenticated){
							alertDialog("알림", "세션이 만료 되었습니다. 다시 로그인 하세요.");
						}
						$rootScope.authenticated = false;
						$location.path("/login");
						return;
					}else {
						$rootScope.userInfo = data.userInfo;
					};
				}
			} catch(ex) {}
		}});
		
		Data.ajax({url:'cmmn/serverDate', successCallback:function(data, status) {
			try {
				if(data) {
	        		serverDate = new Date(data.timeMillis);
	    			serverTime = serverDate.getTime();
	    			$rootScope.timeGap = serverTime - clientTime;    			
	    			StorageManager.clearTimeGap();
	    			StorageManager.setTimeGap($rootScope.timeGap);
				}
			} catch(ex) {}
		}});
	});

	$rootScope.logOut = function() {
		Data.ajax({url:'cmmn/logout', successCallback:function(data, status) {
			try {
				if(data) {
					$rootScope.logined = false;
					if(data.result == 1){
						$rootScope.authenticated = false;
						$location.path("/login");
					}
				}
			} catch(ex) {}
		}});
	};
	
//===============================================================================
// Date Dialog -->
//===============================================================================
	$rootScope.openUserInfoDialog = function() {
    	$mdDialog.show({
            controller: $rootScope.userInfoDialogController,
            templateUrl: 'views/modal/addUserDialog.html',
            parent: angular.element(document.getElementById("wrap")),
            targetEvent: event,
            clickOutsideToClose:true
        }).then(function(formData) {
        	var params = formData;
        	
        	Data.ajax({url:'confMng/updateUserInfoByMe', param:params, successCallback:function(data, status) {
        		try {
        			if(data) {
	                	if (data.result == "1") {
	                		Common.alertDialog("확인", "사용자 정보가 수정되었습니다.");
	                		$rootScope.userInfo.mobileAlertYn = formData.mobileAlertYn;
	                		$rootScope.userInfo.emailAlertYn = formData.emailAlertYn;
	                		$rootScope.userInfo.pushAlertYn = formData.pushAlertYn;
	                	}else{
	                		Common.alertDialog("오류", data.resultMsg);
	                	}
        			}
        		} catch(ex) {}
        	}});
        }, function(selectedDate) {
        	//close modal        	        	
        });
    };

    $rootScope.userInfoDialogController = function($scope, $rootScope, $mdDialog, Common, Data) {
    	$scope.mode=0; //0->user info, 1->change pwd
    	
    	$scope.formType = "view";
    	
    	$scope.oldPwd = "";
    	$scope.newPwd = "";
    	$scope.checkPwd = "";
    	
    	$scope.formData = {
			userId : $rootScope.userInfo.userId, 
			userNm : $rootScope.userInfo.userNm, 
			deptNm : $rootScope.userInfo.deptNm, 
			mobile : $rootScope.userInfo.mobile, 
			mobileAlertYn : $rootScope.userInfo.mobileAlertYn, 
			pushAlertYn : $rootScope.userInfo.pushAlertYn, 
			email : $rootScope.userInfo.email, 
			emailAlertYn : $rootScope.userInfo.emailAlertYn,
			connectMode : $rootScope.connectMode
		};
    	    	
    	$(document).ready(function(){
        	$scope.init();
    	});
    	
        $scope.init = function() {
        };
        
        $scope.cancel = function() {
        	$mdDialog.cancel();
        };
        
        $scope.answer = function() {      
            $mdDialog.hide($scope.formData);
        };
        
        $scope.pwdChange = function() {
        	$mdDialog.cancel();
        	$rootScope.registerBtnClickHandler();
        };
        
        $scope.gotoPwd = function() {
        	$scope.mode = 1;
        };
        
        $scope.changePwd = function() {        	
        	Data.ajax({url:'cmmn/logout', successCallback:function(data, status) {
        		try {
        			Common.toast("비밀번호 변경 완료");
        		} catch(ex) {}
        	}});
        };
        
    }; //dateDialogController
    
  //handler
	$rootScope.registerBtnClickHandler = function() {
		$rootScope.openUserDialog($rootScope.userInfo);
	};
    
	//dialog
	$rootScope.openUserDialog = function(selectedData) {
  		$mdDialog.show({
              controller: $rootScope.userDialogController,
              templateUrl: 'views/modal/changePasswordDialog.html',
              parent: angular.element(document.getElementById("wrap")),
              targetEvent: event,
              clickOutsideToClose:true,
              locals :  {
	                  	selectedData : selectedData
              			}
          }).then(function(formData) {
    		
          }, function(selectedData) {
        	  //close modal        	        	          	
          });
      };
      
      //controller
      $rootScope.userDialogController = function($scope, $mdDialog, $timeout, Common, Data, selectedData) {
  	  	//variables
    		$scope.selectedUserId = null;
    		$scope.selectedData = selectedData;
			
			$scope.init = function() {    
			};
			$scope.answer = function() {
				if (selectedData.password1 == selectedData.password2){
					alert("기존 비밀번호와 변경할 비밀번호가 동일합니다.");
					return;
				}else if (selectedData.password2 != selectedData.password3){
					alert("입력한 비밀번호와 비밀번호 확인 값이 상이합니다.");
					return;
				}
				
				Data.ajax({url:'init/updateChgPwd', param:selectedData, successCallback:function(data, status) {
        			try {
        				if(data) {
		                	if (data.result == "1") {
		                		Common.alertDialog("알림", "비밀번호가 성공적으로 변경되었습니다.");
		                	} else {
		                		alert(data.resultMsg);
		                	}
        				}
        			} catch(ex) {
        				
        			}
        		}});
			};

			$scope.cancel = function() {
				$mdDialog.cancel();
			};
    };
    

//===============================================================================
// <-- Date Dialog
//=============================================================================== 
	    
});	    

	

app.filter('formatNumber', function($filter){
	return function(input, fractionSize) {
		
		if(!angular.isNumber(input)){
			return "-";
		}
		
		return $filter('number')(input, fractionSize);
	
	}
});
/**
 * ivh tree config
 * @param ivhTreeviewOptionsProvider
 * @returns
 */
app.config(function(ivhTreeviewOptionsProvider) {
	ivhTreeviewOptionsProvider.set({
		defaultSelectedState: false,
		validate: true,
		labelAttribute: 'name',
		//twistieExpandedTpl: '－',
		//twistieCollapsedTpl: '＋',
		//twistieLeafTpl: '·',
		twistieExpandedTpl: '<i class="i-expanded"></i>',
		twistieCollapsedTpl: '<i class="i-collapsed"></i>',
		twistieLeafTpl: '<i class="i-leaf"></i>',		
		expandToDepth: 0

		// default options
		// opts.idAttribute === 'id'
		// opts.labelAttribute === 'label'
		// opts.childrenAttribute === 'children'
		// opts.selectedAttribute === 'selected'
		// opts.useCheckboxes === true
		// opts.disableCheckboxSelectionPropagation === false
		// opts.expandToDepth === 0
		// opts.indeterminateAttribute === '__ivhTreeviewIndeterminate'
		// opts.expandedAttribute === '__ivhTreeviewExpanded'
		// opts.defaultSelectedState === true
		// opts.validate === true
		// opts.twistieExpandedTpl === '(-)'
		// opts.twistieCollapsedTpl === '(+)'
		// opts.twistieLeafTpl === 'o'
		// opts.nodeTpl =(eh)= '...'	 
	});	
});
/*
app.factory('ivhTree', function() {
	return {
		replaceData: function(data) {
			return returnData;
		}
	}
});*/
