'use strict';
var app = angular.module('popupApp',
    [ 'ngAnimate', 'ngMessages', 'ngCookies', 'ngResource', 'ngRoute',
        'ngSanitize', 'ngMaterial', 'gridster', 'toastr' , 'ui.grid', 'ui.grid.cellNav', 'ui.grid.edit', 'ui.grid.resizeColumns', 'ui.grid.pinning', 'ui.grid.selection', 'ui.grid.moveColumns', 'ui.grid.pagination','ui.grid.treeView']);


app.config(function($routeProvider) {
	$routeProvider.when('/xlog_large', {
        templateUrl : 'views/popup/xLogLarge.html',
        controller : 'XLogLargeCtrl',
        controllerAs : 'xLogLarge'
	}).when('/activeservice_large', {        		
        templateUrl : 'views/popup/activeServiceLarge.html',
        controller : 'ActiveServiceLargeCtrl',
        controllerAs : 'activeServiceLarge'        
	}).when('/processcpu_large', {
        templateUrl : 'views/popup/processCpuLarge.html',
        controller : 'ProcessCpuLargeCtrl',
        controllerAs : 'processCpuLarge'  
	}).when('/heapmemory_large', {
        templateUrl : 'views/popup/heapMemoryLarge.html',
        controller : 'HeapMemoryLargeCtrl',
        controllerAs : 'errorLarge'  
	}).when('/dbcounter_large', {
        templateUrl : 'views/popup/dbCounterLarge.html',
        controller : 'DbCounterLargeCtrl',
        controllerAs : 'dbCounterLarge'
	}).when('/error_large/:param', {
        templateUrl : 'views/popup/errorLarge.html',
        controller : 'ErrorLargeCtrl',
        controllerAs : 'errorLarge'  
	}).when('/xlog_profile/:serverId/:txid/:eTime/:xTyp', {
        templateUrl : 'views/popup/xLogProfile.html',
        controller : 'XLogProfileCtrl',
        controllerAs : 'xLogProfile'  
	}).when('/groupBtnHandler1', {
		templateUrl : 'views/popup/groupBtnHandler1.html',
		controller : 'groupBtnHandler1Ctrl',
		controllerAs : 'groupBtnHandler1'
	}).when('/groupBtnHandler2', {
		templateUrl : 'views/popup/groupBtnHandler2.html',
		controller : 'groupBtnHandler2Ctrl',
		controllerAs : 'groupBtnHandler2'
	}).when('/groupBtnHandler3', {
		templateUrl : 'views/popup/groupBtnHandler3.html',
		controller : 'groupBtnHandler3Ctrl',
		controllerAs : 'groupBtnHandler3'
	}).when('/monitoringjmxResponseRateLarge', {
		templateUrl : 'views/popup/monitoringjmxResponseRateLarge.html',
		controller : 'monitoringjmxResponseRateLargeCntr',
		controllerAs : 'monitoringjmxResponseRateLarge'
	}).when('/monitoringErrRateLarge', {
		templateUrl : 'views/popup/monitoringErrRateLarge.html',
		controller : 'monitoringErrRateLargeCntr',
		controllerAs : 'monitoringErrRateLarge'
	}).when('/monitoringChartSample', {
		templateUrl : 'views/popup/monitoringChartSample.html',
		controller : 'monitoringChartSampleCntr',
		controllerAs : 'monitoringChartSample'
	}).when('/xlog_real', {
		templateUrl : 'views/popup/xLogReal.html',
		controller : 'XLogRealCtrl',
		controllerAs : 'xLogReal'
	}).when('/noticeLarge', {
		templateUrl : 'views/popup/noticeLarge.html',
		controller : 'noticeLargeCtrl',
		controllerAs : 'noticeLarge'
	}).when('/statisticsAnalyzeDtl', {
		templateUrl : 'views/popup/statisticsAnalyzeDtl.html',
		controller : 'statisticsAnalyzeDtlCtrl',
		controllerAs : 'statisticsAnalyzeLarge'
	}).otherwise({
		//redirectTo : '/'
	});
});

app.config(function($mdThemingProvider) {
	$mdThemingProvider.theme('docs-dark', 'default')
    .primaryPalette('yellow')
    .accentPalette('blue')
    .dark();
});

app.service('StorageManager', storageManagerService);
function storageManagerService() {
    return {
        getTimeGap: function () {
        	return localStorage.getItem('watch_apm_timeGap');
        },
        getAllAgent: function () {
        	return angular.fromJson(localStorage.getItem('watch_apm_allAgent'));
        },
        setAllAgent: function (allAgent) {
        	return localStorage.setItem('watch_apm_allAgent', angular.toJson(allAgent));
        },
        clearAllAgent: function () {
        	return localStorage.removeItem('watch_apm_allAgent');
        },    
        /*
        getSelectedAgent: function () {
        	return angular.fromJson(localStorage.getItem('watch_apm_selectedAgent'));
        },
        setSelectedAgent: function (selectedAgent) {
        	return localStorage.setItem('watch_apm_selectedAgent', angular.toJson(selectedAgent));
        },
        clearSelectedAgent: function () {
        	return localStorage.removeItem('watch_apm_selectedAgent');
        },
        */
        getSelectedGroup: function () {
        	return angular.fromJson(localStorage.getItem('watch_apm_selectedGroup'));
        },
        setSelectedGroup: function (selectedGroup) {
        	return localStorage.setItem('watch_apm_selectedGroup', angular.toJson(selectedGroup));
        },
        clearSelectedGroup: function () {
        	return localStorage.removeItem('watch_apm_selectedGroup');
        }, 
    }
};


/**
 * ui-grid custom 페이징 공통
 * @returns
 */
app.service('Paginator', PaginatorService);
function PaginatorService($rootScope) {
	return {		
		// 페이지 이동 :: ex) setPage(13) => 13페이지로 이동
		setPage: function(page) {				
									
			var vm = this._scope;		
			
			// 존재하지 않는 페이지 예외처리
			if (page < 1 || page > this.getTotalPages(vm.gridOptions.data.length, vm.gridOptions.paginationPageSize)) {
				return;
			}			
			vm.pager = {};								
			vm.gridOptions.pager = this.getPager(vm.gridOptions.data.length, page, vm.gridOptions.paginationPageSize);
						
			vm.gridApi.pagination.seek(page);
				
		},
		
		// 현재 사용중인 Controller Scope 받아 Paginator 에서 사용할 사본 생성
		setScope: function(scope) {
			this._scope = scope;
		},			
		
		// 전체 페이지 수 계산 return
		getTotalPages: function(totalItems, pageSize) {
			return Math.ceil(totalItems / pageSize);
		},
		
		/**
		 * 페이징 관련 필요 데이터 가공 
		 * 페이징 번호리스트 호출
		 * ex) pages: 3 4 5 6 7 8(current page) 9 10 11 12
		 * totalItems : 전체 데이터 수
		 * currentPage : 현재 페이지
		 * pageSize : 페이지당 보여질 리스트 수
		 * optionsCnt : select 박스 옵션 사용 개수
		 * numPerPage : 페이지번호(pages) 개수
		 */			
		getPager : function(totalItems, currentPage, pageSize, optionsCnt, numPerPage) {
			
			var totalPages = this.getTotalPages(totalItems, pageSize); //Math.ceil(totalItems / pageSize); // 전체 페이지 수 계산
			
			currentPage = currentPage || 1;
	
			pageSize = pageSize || 10;
			
			optionsCnt = optionsCnt || 3;
			optionsCnt = (optionsCnt < 1) ? 0 : optionsCnt;
			
			numPerPage = numPerPage || 10; // 
			numPerPage = (numPerPage < 1) ? 1 : numPerPage; //  페이지번호는 최소 1개 
			 				
			var options = new Array();
			
			if (totalPages / optionsCnt >= 1) {
				var splitNumber = Math.floor(totalPages/optionsCnt);
				for (var i=1; i<=optionsCnt; i++) {
					var info = new Object();
					var value = (splitNumber * i > 0) ? splitNumber * i : 1;
					info.id = value;
					info.name = value;
					
					options[i-1] = info;
					//options.push(splitNumber * i);
				}	
			}
			
			var startPage, endPage;
			if (totalPages <= numPerPage) {
				// less than numPerPage total pages so show all
				startPage = 1;
				endPage = totalPages;
			} else {				
				if (currentPage <= Math.ceil(numPerPage/2)) {
					startPage = 1;
					endPage = numPerPage;
				} else if (currentPage + (numPerPage - Math.ceil(numPerPage/2)) > totalPages) {
					startPage = totalPages - numPerPage + 1;
					endPage = totalPages;
				} else {					
					startPage = currentPage - (numPerPage - Math.ceil(numPerPage/2));
					endPage = currentPage + (numPerPage - Math.ceil(numPerPage/2));
					endPage = (numPerPage % 2 == 0) ? endPage - 1 : endPage;
				}
			}
	
			// calculate start and end item indexes
			var startIndex = (currentPage - 1) * pageSize;
			var endIndex = Math.min(startIndex + pageSize - 1, totalItems - 1);
	
			// create an array of pages to ng-repeat in the pager control
			//var pages = _.range(startPage, endPage + 1);		
			var pages = [];
			for (i=startPage; i<endPage+1; i++) {	   
				pages.push(i);
			}	
	
			// return object with all pager properties required by the view
			
			return {
				totalItems: totalItems, //전체 데이터 수
				currentPage: currentPage, // 현재 페이지
				pageSize: pageSize, // 
				totalPages: totalPages,
				startPage: startPage,
				endPage: endPage,
				startIndex: startIndex,
				endIndex: endIndex,
				pages: pages,
				options: options
			};				
		}
	}		
}

/**
 * 페이징 공통 HTML
 * @returns
 */	
app.directive('pagination', function() {
	  return {
		  restrict: 'AE',
//		  scope: {
//			  loadInfo: '=info'
//		  },
//		  link: function($scope, Paginator) {
//			  $scope.$watch('loadInfo', function(newVal, oldVal) {		
//			  });
//		  },		  		  
		  scope: false,

		  templateUrl: 'views/main/paginator.html'
	  }
});

app.run(function($rootScope, Data) {
	$rootScope.ContextPath      = '/WatchApm/app';          // 서버 ContextPath 기본값 
    $rootScope.RootPath         = '.';                      // js, html, image 등의 파일경로
    $rootScope.urlPattern		= '.ajax';
    $rootScope.connectMode		= "ktds";
    $rootScope.userInfo = {};
    
    if($rootScope.connectMode != "kt"){
    	$rootScope.appImageLogoUrl = "images/logo_small_DS.png";
    	$rootScope.appName = "OBICs Watch APM";
    }else{
    	$rootScope.appImageLogoUrl = "images/logo_small.png";
    	$rootScope.appName = "IT's Signal";
    }
    
    Data.ajax({url:'cmmn/authInfo', errorCallback:function(xhr, textStatus, errorThrown, errorCallback){
		if (xhr  == null){
			return;
		}
	}, successCallback:function(data, status) {
		try {
			if(data) {
				// success 
				if (data == "" || data.name == 'anonymousUser' || data.name == undefined) {
					$rootScope.userInfo = null;				
				}else {
					$rootScope.userInfo = data.userInfo;
				};
			}
		} catch(ex) {}
		
	}});
});
