app.factory('Worker', ['$q',
    function ($q) {			
		workers = [];	
        
		return {
        	startWork: function(postData) {
        		var defer = $q.defer(); 
        		if (workers.length > 0) {
        			for (var i=0; i<workers.length; i++) {
            			var worker = workers[i];
            			worker.terminate();
            		}
        		};
        		
        		for (var i=0; i<postData.length; i++) {
        			var worker = new Worker("scripts/workerWrapper.js");
        			workers.push(worker);
        			
        			worker.onmessage = function(event) {
            			defer.notify(event.data);
            		}; 
            		worker.postMessage(postData[i]);
            		
        		}        		
        		return defer.promise;
        	},
        	
        	stopWork: function() {
        		//console.log("stopWork");
        		if (workers.length > 0) {
        			for (var i=0; i<workers.length; i++) {
            			var worker = workers[i];
            			worker.terminate();
            			console.log("worker.terminate()");
            		}
        		}        		
        		workers = [];
        	}
        };
    }]);